/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 9 "src/asm/parser.y"

#include <ctype.h>
#include <errno.h>
#include <inttypes.h>
#include <stdbool.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "asm/charmap.h"
#include "asm/fixpoint.h"
#include "asm/format.h"
#include "asm/fstack.h"
#include "asm/lexer.h"
#include "asm/macro.h"
#include "asm/main.h"
#include "asm/opt.h"
#include "asm/output.h"
#include "asm/rpn.h"
#include "asm/section.h"
#include "asm/symbol.h"
#include "asm/util.h"
#include "asm/warning.h"

#include "extern/utf8decoder.h"

#include "linkdefs.h"
#include "platform.h" // strncasecmp, strdup

static struct CaptureBody captureBody; // Captures a REPT/FOR or MACRO

static void upperstring(char *dest, char const *src)
{
	while (*src)
		*dest++ = toupper(*src++);
	*dest = '\0';
}

static void lowerstring(char *dest, char const *src)
{
	while (*src)
		*dest++ = tolower(*src++);
	*dest = '\0';
}

static uint32_t str2int2(uint8_t *s, uint32_t length)
{
	if (length > 4)
		warning(WARNING_NUMERIC_STRING_1,
			"Treating string as a number ignores first %" PRIu32 " character%s\n",
			length - 4, length == 5 ? "" : "s");
	else if (length > 1)
		warning(WARNING_NUMERIC_STRING_2,
			"Treating %" PRIu32 "-character string as a number\n", length);

	uint32_t r = 0;

	for (uint32_t i = length < 4 ? 0 : length - 4; i < length; i++) {
		r <<= 8;
		r |= s[i];
	}

	return r;
}

static const char *strrstr(char const *s1, char const *s2)
{
	size_t len1 = strlen(s1);
	size_t len2 = strlen(s2);

	if (len2 > len1)
		return NULL;

	for (char const *p = s1 + len1 - len2; p >= s1; p--)
		if (!strncmp(p, s2, len2))
			return p;

	return NULL;
}

static void errorInvalidUTF8Byte(uint8_t byte, char const *functionName)
{
	error("%s: Invalid UTF-8 byte 0x%02hhX\n", functionName, byte);
}

static size_t strlenUTF8(char const *s)
{
	size_t len = 0;
	uint32_t state = 0;

	for (uint32_t codep = 0; *s; s++) {
		uint8_t byte = *s;

		switch (decode(&state, &codep, byte)) {
		case 1:
			errorInvalidUTF8Byte(byte, "STRLEN");
			state = 0;
			// fallthrough
		case 0:
			len++;
			break;
		}
	}

	// Check for partial code point.
	if (state != 0)
		error("STRLEN: Incomplete UTF-8 character\n");

	return len;
}

static void strsubUTF8(char *dest, size_t destLen, char const *src, uint32_t pos, uint32_t len)
{
	size_t srcIndex = 0;
	size_t destIndex = 0;
	uint32_t state = 0;
	uint32_t codep = 0;
	uint32_t curLen = 0;
	uint32_t curPos = 1;

	// Advance to starting position in source string.
	while (src[srcIndex] && curPos < pos) {
		switch (decode(&state, &codep, src[srcIndex])) {
		case 1:
			errorInvalidUTF8Byte(src[srcIndex], "STRSUB");
			state = 0;
			// fallthrough
		case 0:
			curPos++;
			break;
		}
		srcIndex++;
	}

	// A position 1 past the end of the string is allowed, but will trigger the
	// "Length too big" warning below if the length is nonzero.
	if (!src[srcIndex] && pos > curPos)
		warning(WARNING_BUILTIN_ARG,
			"STRSUB: Position %" PRIu32 " is past the end of the string\n", pos);

	// Copy from source to destination.
	while (src[srcIndex] && destIndex < destLen - 1 && curLen < len) {
		switch (decode(&state, &codep, src[srcIndex])) {
		case 1:
			errorInvalidUTF8Byte(src[srcIndex], "STRSUB");
			state = 0;
			// fallthrough
		case 0:
			curLen++;
			break;
		}
		dest[destIndex++] = src[srcIndex++];
	}

	if (curLen < len)
		warning(WARNING_BUILTIN_ARG, "STRSUB: Length too big: %" PRIu32 "\n", len);

	// Check for partial code point.
	if (state != 0)
		error("STRSUB: Incomplete UTF-8 character\n");

	dest[destIndex] = '\0';
}

static size_t charlenUTF8(char const *s)
{
	size_t len;

	for (len = 0; charmap_ConvertNext(&s, NULL); len++)
		;

	return len;
}

static void charsubUTF8(char *dest, char const *src, uint32_t pos)
{
	size_t charLen = 1;

	// Advance to starting position in source string.
	for (uint32_t curPos = 1; charLen && curPos < pos; curPos++)
		charLen = charmap_ConvertNext(&src, NULL);

	char const *start = src;

	if (!charmap_ConvertNext(&src, NULL))
		warning(WARNING_BUILTIN_ARG,
			"CHARSUB: Position %" PRIu32 " is past the end of the string\n", pos);

	// Copy from source to destination.
	memcpy(dest, start, src - start);

	dest[src - start] = '\0';
}

static uint32_t adjustNegativePos(int32_t pos, size_t len, char const *functionName)
{
	// STRSUB and CHARSUB adjust negative `pos` arguments the same way,
	// such that position -1 is the last character of a string.
	if (pos < 0)
		pos += len + 1;
	if (pos < 1) {
		warning(WARNING_BUILTIN_ARG, "%s: Position starts at 1\n", functionName);
		pos = 1;
	}
	return (uint32_t)pos;
}

static void strrpl(char *dest, size_t destLen, char const *src, char const *old, char const *rep)
{
	size_t oldLen = strlen(old);
	size_t repLen = strlen(rep);
	size_t i = 0;

	if (!oldLen) {
		warning(WARNING_EMPTY_STRRPL, "STRRPL: Cannot replace an empty string\n");
		strcpy(dest, src);
		return;
	}

	for (char const *next = strstr(src, old); next && *next; next = strstr(src, old)) {
		// Copy anything before the substring to replace
		unsigned int lenBefore = next - src;

		memcpy(dest + i, src, lenBefore < destLen - i ? lenBefore : destLen - i);
		i += next - src;
		if (i >= destLen)
			break;

		// Copy the replacement substring
		memcpy(dest + i, rep, repLen < destLen - i ? repLen : destLen - i);
		i += repLen;
		if (i >= destLen)
			break;

		src = next + oldLen;
	}

	if (i < destLen) {
		size_t srcLen = strlen(src);

		// Copy anything after the last replaced substring
		memcpy(dest + i, src, srcLen < destLen - i ? srcLen : destLen - i);
		i += srcLen;
	}

	if (i >= destLen) {
		warning(WARNING_LONG_STR, "STRRPL: String too long, got truncated\n");
		i = destLen - 1;
	}
	dest[i] = '\0';
}

static void initStrFmtArgList(struct StrFmtArgList *args)
{
	args->nbArgs = 0;
	args->capacity = INITIAL_STRFMT_ARG_SIZE;
	args->args = malloc(args->capacity * sizeof(*args->args));
	if (!args->args)
		fatalerror("Failed to allocate memory for STRFMT arg list: %s\n",
			   strerror(errno));
}

static size_t nextStrFmtArgListIndex(struct StrFmtArgList *args)
{
	if (args->nbArgs == args->capacity) {
		args->capacity = (args->capacity + 1) * 2;
		args->args = realloc(args->args, args->capacity * sizeof(*args->args));
		if (!args->args)
			fatalerror("realloc error while resizing STRFMT arg list: %s\n",
				   strerror(errno));
	}
	return args->nbArgs++;
}

static void freeStrFmtArgList(struct StrFmtArgList *args)
{
	free(args->format);
	for (size_t i = 0; i < args->nbArgs; i++)
		if (!args->args[i].isNumeric)
			free(args->args[i].string);
	free(args->args);
}

static void strfmt(char *dest, size_t destLen, char const *fmt, size_t nbArgs, struct StrFmtArg *args)
{
	size_t a = 0;
	size_t i = 0;

	while (i < destLen) {
		int c = *fmt++;

		if (c == '\0') {
			break;
		} else if (c != '%') {
			dest[i++] = c;
			continue;
		}

		c = *fmt++;

		if (c == '%') {
			dest[i++] = c;
			continue;
		}

		struct FormatSpec spec = fmt_NewSpec();

		while (c != '\0') {
			fmt_UseCharacter(&spec, c);
			if (fmt_IsFinished(&spec))
				break;
			c = *fmt++;
		}

		if (fmt_IsEmpty(&spec)) {
			error("STRFMT: Illegal '%%' at end of format string\n");
			dest[i++] = '%';
			break;
		} else if (!fmt_IsValid(&spec)) {
			error("STRFMT: Invalid format spec for argument %zu\n", a + 1);
			dest[i++] = '%';
			a++;
			continue;
		} else if (a >= nbArgs) {
			// Will warn after formatting is done.
			dest[i++] = '%';
			a++;
			continue;
		}

		struct StrFmtArg *arg = &args[a++];
		static char buf[MAXSTRLEN + 1];

		if (arg->isNumeric)
			fmt_PrintNumber(buf, sizeof(buf), &spec, arg->number);
		else
			fmt_PrintString(buf, sizeof(buf), &spec, arg->string);

		i += snprintf(&dest[i], destLen - i, "%s", buf);
	}

	if (a < nbArgs)
		error("STRFMT: %zu unformatted argument(s)\n", nbArgs - a);
	else if (a > nbArgs)
		error("STRFMT: Not enough arguments for format spec, got: %zu, need: %zu\n", nbArgs, a);

	if (i > destLen - 1) {
		warning(WARNING_LONG_STR, "STRFMT: String too long, got truncated\n");
		i = destLen - 1;
	}
	dest[i] = '\0';
}

static void compoundAssignment(const char *symName, enum RPNCommand op, int32_t constValue) {
	struct Expression oldExpr, constExpr, newExpr;
	int32_t newValue;

	rpn_Symbol(&oldExpr, symName);
	rpn_Number(&constExpr, constValue);
	rpn_BinaryOp(op, &newExpr, &oldExpr, &constExpr);
	newValue = rpn_GetConstVal(&newExpr);
	sym_AddVar(symName, newValue);
}

static void initDsArgList(struct DsArgList *args)
{
	args->nbArgs = 0;
	args->capacity = INITIAL_DS_ARG_SIZE;
	args->args = malloc(args->capacity * sizeof(*args->args));
	if (!args->args)
		fatalerror("Failed to allocate memory for ds arg list: %s\n",
			   strerror(errno));
}

static void appendDsArgList(struct DsArgList *args, const struct Expression *expr)
{
	if (args->nbArgs == args->capacity) {
		args->capacity = (args->capacity + 1) * 2;
		args->args = realloc(args->args, args->capacity * sizeof(*args->args));
		if (!args->args)
			fatalerror("realloc error while resizing ds arg list: %s\n",
				   strerror(errno));
	}
	args->args[args->nbArgs++] = *expr;
}

static void freeDsArgList(struct DsArgList *args)
{
	free(args->args);
}

static void failAssert(enum AssertionType type)
{
	switch (type) {
		case ASSERT_FATAL:
			fatalerror("Assertion failed\n");
		case ASSERT_ERROR:
			error("Assertion failed\n");
			break;
		case ASSERT_WARN:
			warning(WARNING_ASSERT, "Assertion failed\n");
			break;
	}
}

static void failAssertMsg(enum AssertionType type, char const *msg)
{
	switch (type) {
		case ASSERT_FATAL:
			fatalerror("Assertion failed: %s\n", msg);
		case ASSERT_ERROR:
			error("Assertion failed: %s\n", msg);
			break;
		case ASSERT_WARN:
			warning(WARNING_ASSERT, "Assertion failed: %s\n", msg);
			break;
	}
}

void yyerror(char const *str)
{
	error("%s\n", str);
}

// The CPU encodes instructions in a logical way, so most instructions actually follow patterns.
// These enums thus help with bit twiddling to compute opcodes
enum {
	REG_B = 0,
	REG_C,
	REG_D,
	REG_E,
	REG_H,
	REG_L,
	REG_HL_IND,
	REG_A
};

enum {
	REG_BC_IND = 0,
	REG_DE_IND,
	REG_HL_INDINC,
	REG_HL_INDDEC,
};

enum {
	REG_BC = 0,
	REG_DE = 1,
	REG_HL = 2,
	// LD/INC/ADD/DEC allow SP, PUSH/POP allow AF
	REG_SP = 3,
	REG_AF = 3
};

enum {
	CC_NZ = 0,
	CC_Z,
	CC_NC,
	CC_C
};


#line 534 "src/asm/parser.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "parser.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_T_NUMBER = 3,                   /* "number"  */
  YYSYMBOL_T_STRING = 4,                   /* "string"  */
  YYSYMBOL_T_PERIOD = 5,                   /* "."  */
  YYSYMBOL_T_COMMA = 6,                    /* ","  */
  YYSYMBOL_T_COLON = 7,                    /* ":"  */
  YYSYMBOL_T_LBRACK = 8,                   /* "["  */
  YYSYMBOL_T_RBRACK = 9,                   /* "]"  */
  YYSYMBOL_T_LPAREN = 10,                  /* "("  */
  YYSYMBOL_T_RPAREN = 11,                  /* ")"  */
  YYSYMBOL_T_NEWLINE = 12,                 /* "newline"  */
  YYSYMBOL_T_OP_LOGICNOT = 13,             /* "!"  */
  YYSYMBOL_T_OP_LOGICAND = 14,             /* "&&"  */
  YYSYMBOL_T_OP_LOGICOR = 15,              /* "||"  */
  YYSYMBOL_T_OP_LOGICGT = 16,              /* ">"  */
  YYSYMBOL_T_OP_LOGICLT = 17,              /* "<"  */
  YYSYMBOL_T_OP_LOGICGE = 18,              /* ">="  */
  YYSYMBOL_T_OP_LOGICLE = 19,              /* "<="  */
  YYSYMBOL_T_OP_LOGICNE = 20,              /* "!="  */
  YYSYMBOL_T_OP_LOGICEQU = 21,             /* "=="  */
  YYSYMBOL_T_OP_ADD = 22,                  /* "+"  */
  YYSYMBOL_T_OP_SUB = 23,                  /* "-"  */
  YYSYMBOL_T_OP_OR = 24,                   /* "|"  */
  YYSYMBOL_T_OP_XOR = 25,                  /* "^"  */
  YYSYMBOL_T_OP_AND = 26,                  /* "&"  */
  YYSYMBOL_T_OP_SHL = 27,                  /* "<<"  */
  YYSYMBOL_T_OP_SHR = 28,                  /* ">>"  */
  YYSYMBOL_T_OP_USHR = 29,                 /* ">>>"  */
  YYSYMBOL_T_OP_MUL = 30,                  /* "*"  */
  YYSYMBOL_T_OP_DIV = 31,                  /* "/"  */
  YYSYMBOL_T_OP_MOD = 32,                  /* "%"  */
  YYSYMBOL_T_OP_NOT = 33,                  /* "~"  */
  YYSYMBOL_NEG = 34,                       /* NEG  */
  YYSYMBOL_T_OP_EXP = 35,                  /* "**"  */
  YYSYMBOL_T_OP_DEF = 36,                  /* "DEF"  */
  YYSYMBOL_T_OP_BANK = 37,                 /* "BANK"  */
  YYSYMBOL_T_OP_ALIGN = 38,                /* "ALIGN"  */
  YYSYMBOL_T_OP_SIZEOF = 39,               /* "SIZEOF"  */
  YYSYMBOL_T_OP_STARTOF = 40,              /* "STARTOF"  */
  YYSYMBOL_T_OP_SIN = 41,                  /* "SIN"  */
  YYSYMBOL_T_OP_COS = 42,                  /* "COS"  */
  YYSYMBOL_T_OP_TAN = 43,                  /* "TAN"  */
  YYSYMBOL_T_OP_ASIN = 44,                 /* "ASIN"  */
  YYSYMBOL_T_OP_ACOS = 45,                 /* "ACOS"  */
  YYSYMBOL_T_OP_ATAN = 46,                 /* "ATAN"  */
  YYSYMBOL_T_OP_ATAN2 = 47,                /* "ATAN2"  */
  YYSYMBOL_T_OP_FDIV = 48,                 /* "FDIV"  */
  YYSYMBOL_T_OP_FMUL = 49,                 /* "FMUL"  */
  YYSYMBOL_T_OP_FMOD = 50,                 /* "FMOD"  */
  YYSYMBOL_T_OP_POW = 51,                  /* "POW"  */
  YYSYMBOL_T_OP_LOG = 52,                  /* "LOG"  */
  YYSYMBOL_T_OP_ROUND = 53,                /* "ROUND"  */
  YYSYMBOL_T_OP_CEIL = 54,                 /* "CEIL"  */
  YYSYMBOL_T_OP_FLOOR = 55,                /* "FLOOR"  */
  YYSYMBOL_T_OP_HIGH = 56,                 /* "HIGH"  */
  YYSYMBOL_T_OP_LOW = 57,                  /* "LOW"  */
  YYSYMBOL_T_OP_ISCONST = 58,              /* "ISCONST"  */
  YYSYMBOL_T_OP_STRCMP = 59,               /* "STRCMP"  */
  YYSYMBOL_T_OP_STRIN = 60,                /* "STRIN"  */
  YYSYMBOL_T_OP_STRRIN = 61,               /* "STRRIN"  */
  YYSYMBOL_T_OP_STRSUB = 62,               /* "STRSUB"  */
  YYSYMBOL_T_OP_STRLEN = 63,               /* "STRLEN"  */
  YYSYMBOL_T_OP_STRCAT = 64,               /* "STRCAT"  */
  YYSYMBOL_T_OP_STRUPR = 65,               /* "STRUPR"  */
  YYSYMBOL_T_OP_STRLWR = 66,               /* "STRLWR"  */
  YYSYMBOL_T_OP_STRRPL = 67,               /* "STRRPL"  */
  YYSYMBOL_T_OP_STRFMT = 68,               /* "STRFMT"  */
  YYSYMBOL_T_OP_CHARLEN = 69,              /* "CHARLEN"  */
  YYSYMBOL_T_OP_CHARSUB = 70,              /* "CHARSUB"  */
  YYSYMBOL_T_LABEL = 71,                   /* "label"  */
  YYSYMBOL_T_ID = 72,                      /* "identifier"  */
  YYSYMBOL_T_LOCAL_ID = 73,                /* "local identifier"  */
  YYSYMBOL_T_ANON = 74,                    /* "anonymous label"  */
  YYSYMBOL_T_POP_EQU = 75,                 /* "EQU"  */
  YYSYMBOL_T_POP_EQUAL = 76,               /* "="  */
  YYSYMBOL_T_POP_EQUS = 77,                /* "EQUS"  */
  YYSYMBOL_T_POP_ADDEQ = 78,               /* "+="  */
  YYSYMBOL_T_POP_SUBEQ = 79,               /* "-="  */
  YYSYMBOL_T_POP_MULEQ = 80,               /* "*="  */
  YYSYMBOL_T_POP_DIVEQ = 81,               /* "/="  */
  YYSYMBOL_T_POP_MODEQ = 82,               /* "%="  */
  YYSYMBOL_T_POP_OREQ = 83,                /* "|="  */
  YYSYMBOL_T_POP_XOREQ = 84,               /* "^="  */
  YYSYMBOL_T_POP_ANDEQ = 85,               /* "&="  */
  YYSYMBOL_T_POP_SHLEQ = 86,               /* "<<="  */
  YYSYMBOL_T_POP_SHREQ = 87,               /* ">>="  */
  YYSYMBOL_T_POP_INCLUDE = 88,             /* "INCLUDE"  */
  YYSYMBOL_T_POP_PRINT = 89,               /* "PRINT"  */
  YYSYMBOL_T_POP_PRINTLN = 90,             /* "PRINTLN"  */
  YYSYMBOL_T_POP_IF = 91,                  /* "IF"  */
  YYSYMBOL_T_POP_ELIF = 92,                /* "ELIF"  */
  YYSYMBOL_T_POP_ELSE = 93,                /* "ELSE"  */
  YYSYMBOL_T_POP_ENDC = 94,                /* "ENDC"  */
  YYSYMBOL_T_POP_EXPORT = 95,              /* "EXPORT"  */
  YYSYMBOL_T_POP_DB = 96,                  /* "DB"  */
  YYSYMBOL_T_POP_DS = 97,                  /* "DS"  */
  YYSYMBOL_T_POP_DW = 98,                  /* "DW"  */
  YYSYMBOL_T_POP_DL = 99,                  /* "DL"  */
  YYSYMBOL_T_POP_SECTION = 100,            /* "SECTION"  */
  YYSYMBOL_T_POP_FRAGMENT = 101,           /* "FRAGMENT"  */
  YYSYMBOL_T_POP_RB = 102,                 /* "RB"  */
  YYSYMBOL_T_POP_RW = 103,                 /* "RW"  */
  YYSYMBOL_T_POP_MACRO = 104,              /* "MACRO"  */
  YYSYMBOL_T_POP_ENDM = 105,               /* "ENDM"  */
  YYSYMBOL_T_POP_RSRESET = 106,            /* "RSRESET"  */
  YYSYMBOL_T_POP_RSSET = 107,              /* "RSSET"  */
  YYSYMBOL_T_POP_UNION = 108,              /* "UNION"  */
  YYSYMBOL_T_POP_NEXTU = 109,              /* "NEXTU"  */
  YYSYMBOL_T_POP_ENDU = 110,               /* "ENDU"  */
  YYSYMBOL_T_POP_INCBIN = 111,             /* "INCBIN"  */
  YYSYMBOL_T_POP_REPT = 112,               /* "REPT"  */
  YYSYMBOL_T_POP_FOR = 113,                /* "FOR"  */
  YYSYMBOL_T_POP_CHARMAP = 114,            /* "CHARMAP"  */
  YYSYMBOL_T_POP_NEWCHARMAP = 115,         /* "NEWCHARMAP"  */
  YYSYMBOL_T_POP_SETCHARMAP = 116,         /* "SETCHARMAP"  */
  YYSYMBOL_T_POP_PUSHC = 117,              /* "PUSHC"  */
  YYSYMBOL_T_POP_POPC = 118,               /* "POPC"  */
  YYSYMBOL_T_POP_SHIFT = 119,              /* "SHIFT"  */
  YYSYMBOL_T_POP_ENDR = 120,               /* "ENDR"  */
  YYSYMBOL_T_POP_BREAK = 121,              /* "BREAK"  */
  YYSYMBOL_T_POP_LOAD = 122,               /* "LOAD"  */
  YYSYMBOL_T_POP_ENDL = 123,               /* "ENDL"  */
  YYSYMBOL_T_POP_FAIL = 124,               /* "FAIL"  */
  YYSYMBOL_T_POP_WARN = 125,               /* "WARN"  */
  YYSYMBOL_T_POP_FATAL = 126,              /* "FATAL"  */
  YYSYMBOL_T_POP_ASSERT = 127,             /* "ASSERT"  */
  YYSYMBOL_T_POP_STATIC_ASSERT = 128,      /* "STATIC_ASSERT"  */
  YYSYMBOL_T_POP_PURGE = 129,              /* "PURGE"  */
  YYSYMBOL_T_POP_REDEF = 130,              /* "REDEF"  */
  YYSYMBOL_T_POP_POPS = 131,               /* "POPS"  */
  YYSYMBOL_T_POP_PUSHS = 132,              /* "PUSHS"  */
  YYSYMBOL_T_POP_POPO = 133,               /* "POPO"  */
  YYSYMBOL_T_POP_PUSHO = 134,              /* "PUSHO"  */
  YYSYMBOL_T_POP_OPT = 135,                /* "OPT"  */
  YYSYMBOL_T_SECT_ROM0 = 136,              /* "ROM0"  */
  YYSYMBOL_T_SECT_ROMX = 137,              /* "ROMX"  */
  YYSYMBOL_T_SECT_WRAM0 = 138,             /* "WRAM0"  */
  YYSYMBOL_T_SECT_WRAMX = 139,             /* "WRAMX"  */
  YYSYMBOL_T_SECT_HRAM = 140,              /* "HRAM"  */
  YYSYMBOL_T_SECT_VRAM = 141,              /* "VRAM"  */
  YYSYMBOL_T_SECT_SRAM = 142,              /* "SRAM"  */
  YYSYMBOL_T_SECT_OAM = 143,               /* "OAM"  */
  YYSYMBOL_T_Z80_ADC = 144,                /* "adc"  */
  YYSYMBOL_T_Z80_ADD = 145,                /* "add"  */
  YYSYMBOL_T_Z80_AND = 146,                /* "and"  */
  YYSYMBOL_T_Z80_BIT = 147,                /* "bit"  */
  YYSYMBOL_T_Z80_CALL = 148,               /* "call"  */
  YYSYMBOL_T_Z80_CCF = 149,                /* "ccf"  */
  YYSYMBOL_T_Z80_CP = 150,                 /* "cp"  */
  YYSYMBOL_T_Z80_CPL = 151,                /* "cpl"  */
  YYSYMBOL_T_Z80_DAA = 152,                /* "daa"  */
  YYSYMBOL_T_Z80_DEC = 153,                /* "dec"  */
  YYSYMBOL_T_Z80_DI = 154,                 /* "di"  */
  YYSYMBOL_T_Z80_EI = 155,                 /* "ei"  */
  YYSYMBOL_T_Z80_HALT = 156,               /* "halt"  */
  YYSYMBOL_T_Z80_INC = 157,                /* "inc"  */
  YYSYMBOL_T_Z80_JP = 158,                 /* "jp"  */
  YYSYMBOL_T_Z80_JR = 159,                 /* "jr"  */
  YYSYMBOL_T_Z80_LD = 160,                 /* "ld"  */
  YYSYMBOL_T_Z80_LDI = 161,                /* "ldi"  */
  YYSYMBOL_T_Z80_LDD = 162,                /* "ldd"  */
  YYSYMBOL_T_Z80_LDH = 163,                /* "ldh"  */
  YYSYMBOL_T_Z80_NOP = 164,                /* "nop"  */
  YYSYMBOL_T_Z80_OR = 165,                 /* "or"  */
  YYSYMBOL_T_Z80_POP = 166,                /* "pop"  */
  YYSYMBOL_T_Z80_PUSH = 167,               /* "push"  */
  YYSYMBOL_T_Z80_RES = 168,                /* "res"  */
  YYSYMBOL_T_Z80_RET = 169,                /* "ret"  */
  YYSYMBOL_T_Z80_RETI = 170,               /* "reti"  */
  YYSYMBOL_T_Z80_RST = 171,                /* "rst"  */
  YYSYMBOL_T_Z80_RL = 172,                 /* "rl"  */
  YYSYMBOL_T_Z80_RLA = 173,                /* "rla"  */
  YYSYMBOL_T_Z80_RLC = 174,                /* "rlc"  */
  YYSYMBOL_T_Z80_RLCA = 175,               /* "rlca"  */
  YYSYMBOL_T_Z80_RR = 176,                 /* "rr"  */
  YYSYMBOL_T_Z80_RRA = 177,                /* "rra"  */
  YYSYMBOL_T_Z80_RRC = 178,                /* "rrc"  */
  YYSYMBOL_T_Z80_RRCA = 179,               /* "rrca"  */
  YYSYMBOL_T_Z80_SBC = 180,                /* "sbc"  */
  YYSYMBOL_T_Z80_SCF = 181,                /* "scf"  */
  YYSYMBOL_T_Z80_SET = 182,                /* "set"  */
  YYSYMBOL_T_Z80_STOP = 183,               /* "stop"  */
  YYSYMBOL_T_Z80_SLA = 184,                /* "sla"  */
  YYSYMBOL_T_Z80_SRA = 185,                /* "sra"  */
  YYSYMBOL_T_Z80_SRL = 186,                /* "srl"  */
  YYSYMBOL_T_Z80_SUB = 187,                /* "sub"  */
  YYSYMBOL_T_Z80_SWAP = 188,               /* "swap"  */
  YYSYMBOL_T_Z80_XOR = 189,                /* "xor"  */
  YYSYMBOL_T_TOKEN_A = 190,                /* "a"  */
  YYSYMBOL_T_TOKEN_B = 191,                /* "b"  */
  YYSYMBOL_T_TOKEN_C = 192,                /* "c"  */
  YYSYMBOL_T_TOKEN_D = 193,                /* "d"  */
  YYSYMBOL_T_TOKEN_E = 194,                /* "e"  */
  YYSYMBOL_T_TOKEN_H = 195,                /* "h"  */
  YYSYMBOL_T_TOKEN_L = 196,                /* "l"  */
  YYSYMBOL_T_MODE_AF = 197,                /* "af"  */
  YYSYMBOL_T_MODE_BC = 198,                /* "bc"  */
  YYSYMBOL_T_MODE_DE = 199,                /* "de"  */
  YYSYMBOL_T_MODE_SP = 200,                /* "sp"  */
  YYSYMBOL_T_MODE_HL = 201,                /* "hl"  */
  YYSYMBOL_T_MODE_HL_DEC = 202,            /* "hld/hl-"  */
  YYSYMBOL_T_MODE_HL_INC = 203,            /* "hli/hl+"  */
  YYSYMBOL_T_CC_NZ = 204,                  /* "nz"  */
  YYSYMBOL_T_CC_Z = 205,                   /* "z"  */
  YYSYMBOL_T_CC_NC = 206,                  /* "nc"  */
  YYSYMBOL_T_EOB = 207,                    /* "end of buffer"  */
  YYSYMBOL_YYACCEPT = 208,                 /* $accept  */
  YYSYMBOL_asmfile = 209,                  /* asmfile  */
  YYSYMBOL_lines = 210,                    /* lines  */
  YYSYMBOL_endofline = 211,                /* endofline  */
  YYSYMBOL_plain_directive = 212,          /* plain_directive  */
  YYSYMBOL_line = 213,                     /* line  */
  YYSYMBOL_214_1 = 214,                    /* $@1  */
  YYSYMBOL_215_2 = 215,                    /* $@2  */
  YYSYMBOL_line_directive = 216,           /* line_directive  */
  YYSYMBOL_if = 217,                       /* if  */
  YYSYMBOL_elif = 218,                     /* elif  */
  YYSYMBOL_else = 219,                     /* else  */
  YYSYMBOL_endc = 220,                     /* endc  */
  YYSYMBOL_def_id = 221,                   /* def_id  */
  YYSYMBOL_222_3 = 222,                    /* $@3  */
  YYSYMBOL_redef_id = 223,                 /* redef_id  */
  YYSYMBOL_224_4 = 224,                    /* $@4  */
  YYSYMBOL_scoped_id = 225,                /* scoped_id  */
  YYSYMBOL_scoped_anon_id = 226,           /* scoped_anon_id  */
  YYSYMBOL_label = 227,                    /* label  */
  YYSYMBOL_macro = 228,                    /* macro  */
  YYSYMBOL_229_5 = 229,                    /* $@5  */
  YYSYMBOL_macroargs = 230,                /* macroargs  */
  YYSYMBOL_assignment_directive = 231,     /* assignment_directive  */
  YYSYMBOL_directive = 232,                /* directive  */
  YYSYMBOL_trailing_comma = 233,           /* trailing_comma  */
  YYSYMBOL_compoundeq = 234,               /* compoundeq  */
  YYSYMBOL_equ = 235,                      /* equ  */
  YYSYMBOL_assignment = 236,               /* assignment  */
  YYSYMBOL_equs = 237,                     /* equs  */
  YYSYMBOL_rb = 238,                       /* rb  */
  YYSYMBOL_rw = 239,                       /* rw  */
  YYSYMBOL_rl = 240,                       /* rl  */
  YYSYMBOL_align = 241,                    /* align  */
  YYSYMBOL_opt = 242,                      /* opt  */
  YYSYMBOL_243_6 = 243,                    /* $@6  */
  YYSYMBOL_opt_list = 244,                 /* opt_list  */
  YYSYMBOL_opt_list_entry = 245,           /* opt_list_entry  */
  YYSYMBOL_popo = 246,                     /* popo  */
  YYSYMBOL_pusho = 247,                    /* pusho  */
  YYSYMBOL_pops = 248,                     /* pops  */
  YYSYMBOL_pushs = 249,                    /* pushs  */
  YYSYMBOL_fail = 250,                     /* fail  */
  YYSYMBOL_warn = 251,                     /* warn  */
  YYSYMBOL_assert_type = 252,              /* assert_type  */
  YYSYMBOL_assert = 253,                   /* assert  */
  YYSYMBOL_shift = 254,                    /* shift  */
  YYSYMBOL_load = 255,                     /* load  */
  YYSYMBOL_rept = 256,                     /* rept  */
  YYSYMBOL_257_7 = 257,                    /* @7  */
  YYSYMBOL_for = 258,                      /* for  */
  YYSYMBOL_259_8 = 259,                    /* $@8  */
  YYSYMBOL_260_9 = 260,                    /* $@9  */
  YYSYMBOL_261_10 = 261,                   /* @10  */
  YYSYMBOL_for_args = 262,                 /* for_args  */
  YYSYMBOL_break = 263,                    /* break  */
  YYSYMBOL_macrodef = 264,                 /* macrodef  */
  YYSYMBOL_265_11 = 265,                   /* $@11  */
  YYSYMBOL_266_12 = 266,                   /* $@12  */
  YYSYMBOL_267_13 = 267,                   /* @13  */
  YYSYMBOL_268_14 = 268,                   /* @14  */
  YYSYMBOL_rsset = 269,                    /* rsset  */
  YYSYMBOL_rsreset = 270,                  /* rsreset  */
  YYSYMBOL_rs_uconst = 271,                /* rs_uconst  */
  YYSYMBOL_union = 272,                    /* union  */
  YYSYMBOL_nextu = 273,                    /* nextu  */
  YYSYMBOL_endu = 274,                     /* endu  */
  YYSYMBOL_ds = 275,                       /* ds  */
  YYSYMBOL_ds_args = 276,                  /* ds_args  */
  YYSYMBOL_db = 277,                       /* db  */
  YYSYMBOL_dw = 278,                       /* dw  */
  YYSYMBOL_dl = 279,                       /* dl  */
  YYSYMBOL_def_equ = 280,                  /* def_equ  */
  YYSYMBOL_redef_equ = 281,                /* redef_equ  */
  YYSYMBOL_def_set = 282,                  /* def_set  */
  YYSYMBOL_def_rb = 283,                   /* def_rb  */
  YYSYMBOL_def_rw = 284,                   /* def_rw  */
  YYSYMBOL_def_rl = 285,                   /* def_rl  */
  YYSYMBOL_def_equs = 286,                 /* def_equs  */
  YYSYMBOL_redef_equs = 287,               /* redef_equs  */
  YYSYMBOL_purge = 288,                    /* purge  */
  YYSYMBOL_289_15 = 289,                   /* $@15  */
  YYSYMBOL_purge_list = 290,               /* purge_list  */
  YYSYMBOL_purge_list_entry = 291,         /* purge_list_entry  */
  YYSYMBOL_export = 292,                   /* export  */
  YYSYMBOL_export_list = 293,              /* export_list  */
  YYSYMBOL_export_list_entry = 294,        /* export_list_entry  */
  YYSYMBOL_include = 295,                  /* include  */
  YYSYMBOL_incbin = 296,                   /* incbin  */
  YYSYMBOL_charmap = 297,                  /* charmap  */
  YYSYMBOL_newcharmap = 298,               /* newcharmap  */
  YYSYMBOL_setcharmap = 299,               /* setcharmap  */
  YYSYMBOL_pushc = 300,                    /* pushc  */
  YYSYMBOL_popc = 301,                     /* popc  */
  YYSYMBOL_print = 302,                    /* print  */
  YYSYMBOL_println = 303,                  /* println  */
  YYSYMBOL_print_exprs = 304,              /* print_exprs  */
  YYSYMBOL_print_expr = 305,               /* print_expr  */
  YYSYMBOL_const_3bit = 306,               /* const_3bit  */
  YYSYMBOL_constlist_8bit = 307,           /* constlist_8bit  */
  YYSYMBOL_constlist_8bit_entry = 308,     /* constlist_8bit_entry  */
  YYSYMBOL_constlist_16bit = 309,          /* constlist_16bit  */
  YYSYMBOL_constlist_16bit_entry = 310,    /* constlist_16bit_entry  */
  YYSYMBOL_constlist_32bit = 311,          /* constlist_32bit  */
  YYSYMBOL_constlist_32bit_entry = 312,    /* constlist_32bit_entry  */
  YYSYMBOL_reloc_8bit = 313,               /* reloc_8bit  */
  YYSYMBOL_reloc_8bit_no_str = 314,        /* reloc_8bit_no_str  */
  YYSYMBOL_reloc_8bit_offset = 315,        /* reloc_8bit_offset  */
  YYSYMBOL_reloc_16bit = 316,              /* reloc_16bit  */
  YYSYMBOL_reloc_16bit_no_str = 317,       /* reloc_16bit_no_str  */
  YYSYMBOL_relocexpr = 318,                /* relocexpr  */
  YYSYMBOL_relocexpr_no_str = 319,         /* relocexpr_no_str  */
  YYSYMBOL_320_16 = 320,                   /* $@16  */
  YYSYMBOL_uconst = 321,                   /* uconst  */
  YYSYMBOL_const = 322,                    /* const  */
  YYSYMBOL_const_no_str = 323,             /* const_no_str  */
  YYSYMBOL_const_8bit = 324,               /* const_8bit  */
  YYSYMBOL_opt_q_arg = 325,                /* opt_q_arg  */
  YYSYMBOL_string = 326,                   /* string  */
  YYSYMBOL_strcat_args = 327,              /* strcat_args  */
  YYSYMBOL_strfmt_args = 328,              /* strfmt_args  */
  YYSYMBOL_strfmt_va_args = 329,           /* strfmt_va_args  */
  YYSYMBOL_section = 330,                  /* section  */
  YYSYMBOL_sectmod = 331,                  /* sectmod  */
  YYSYMBOL_sectiontype = 332,              /* sectiontype  */
  YYSYMBOL_sectorg = 333,                  /* sectorg  */
  YYSYMBOL_sectattrs = 334,                /* sectattrs  */
  YYSYMBOL_cpu_command = 335,              /* cpu_command  */
  YYSYMBOL_z80_adc = 336,                  /* z80_adc  */
  YYSYMBOL_z80_add = 337,                  /* z80_add  */
  YYSYMBOL_z80_and = 338,                  /* z80_and  */
  YYSYMBOL_z80_bit = 339,                  /* z80_bit  */
  YYSYMBOL_z80_call = 340,                 /* z80_call  */
  YYSYMBOL_z80_ccf = 341,                  /* z80_ccf  */
  YYSYMBOL_z80_cp = 342,                   /* z80_cp  */
  YYSYMBOL_z80_cpl = 343,                  /* z80_cpl  */
  YYSYMBOL_z80_daa = 344,                  /* z80_daa  */
  YYSYMBOL_z80_dec = 345,                  /* z80_dec  */
  YYSYMBOL_z80_di = 346,                   /* z80_di  */
  YYSYMBOL_z80_ei = 347,                   /* z80_ei  */
  YYSYMBOL_z80_halt = 348,                 /* z80_halt  */
  YYSYMBOL_z80_inc = 349,                  /* z80_inc  */
  YYSYMBOL_z80_jp = 350,                   /* z80_jp  */
  YYSYMBOL_z80_jr = 351,                   /* z80_jr  */
  YYSYMBOL_z80_ldi = 352,                  /* z80_ldi  */
  YYSYMBOL_z80_ldd = 353,                  /* z80_ldd  */
  YYSYMBOL_z80_ldio = 354,                 /* z80_ldio  */
  YYSYMBOL_c_ind = 355,                    /* c_ind  */
  YYSYMBOL_z80_ld = 356,                   /* z80_ld  */
  YYSYMBOL_z80_ld_hl = 357,                /* z80_ld_hl  */
  YYSYMBOL_z80_ld_sp = 358,                /* z80_ld_sp  */
  YYSYMBOL_z80_ld_mem = 359,               /* z80_ld_mem  */
  YYSYMBOL_z80_ld_cind = 360,              /* z80_ld_cind  */
  YYSYMBOL_z80_ld_rr = 361,                /* z80_ld_rr  */
  YYSYMBOL_z80_ld_r = 362,                 /* z80_ld_r  */
  YYSYMBOL_z80_ld_a = 363,                 /* z80_ld_a  */
  YYSYMBOL_z80_ld_ss = 364,                /* z80_ld_ss  */
  YYSYMBOL_z80_nop = 365,                  /* z80_nop  */
  YYSYMBOL_z80_or = 366,                   /* z80_or  */
  YYSYMBOL_z80_pop = 367,                  /* z80_pop  */
  YYSYMBOL_z80_push = 368,                 /* z80_push  */
  YYSYMBOL_z80_res = 369,                  /* z80_res  */
  YYSYMBOL_z80_ret = 370,                  /* z80_ret  */
  YYSYMBOL_z80_reti = 371,                 /* z80_reti  */
  YYSYMBOL_z80_rl = 372,                   /* z80_rl  */
  YYSYMBOL_z80_rla = 373,                  /* z80_rla  */
  YYSYMBOL_z80_rlc = 374,                  /* z80_rlc  */
  YYSYMBOL_z80_rlca = 375,                 /* z80_rlca  */
  YYSYMBOL_z80_rr = 376,                   /* z80_rr  */
  YYSYMBOL_z80_rra = 377,                  /* z80_rra  */
  YYSYMBOL_z80_rrc = 378,                  /* z80_rrc  */
  YYSYMBOL_z80_rrca = 379,                 /* z80_rrca  */
  YYSYMBOL_z80_rst = 380,                  /* z80_rst  */
  YYSYMBOL_z80_sbc = 381,                  /* z80_sbc  */
  YYSYMBOL_z80_scf = 382,                  /* z80_scf  */
  YYSYMBOL_z80_set = 383,                  /* z80_set  */
  YYSYMBOL_z80_sla = 384,                  /* z80_sla  */
  YYSYMBOL_z80_sra = 385,                  /* z80_sra  */
  YYSYMBOL_z80_srl = 386,                  /* z80_srl  */
  YYSYMBOL_z80_stop = 387,                 /* z80_stop  */
  YYSYMBOL_z80_sub = 388,                  /* z80_sub  */
  YYSYMBOL_z80_swap = 389,                 /* z80_swap  */
  YYSYMBOL_z80_xor = 390,                  /* z80_xor  */
  YYSYMBOL_op_mem_ind = 391,               /* op_mem_ind  */
  YYSYMBOL_op_a_r = 392,                   /* op_a_r  */
  YYSYMBOL_op_a_n = 393,                   /* op_a_n  */
  YYSYMBOL_T_MODE_A = 394,                 /* T_MODE_A  */
  YYSYMBOL_T_MODE_B = 395,                 /* T_MODE_B  */
  YYSYMBOL_T_MODE_C = 396,                 /* T_MODE_C  */
  YYSYMBOL_T_MODE_D = 397,                 /* T_MODE_D  */
  YYSYMBOL_T_MODE_E = 398,                 /* T_MODE_E  */
  YYSYMBOL_T_MODE_H = 399,                 /* T_MODE_H  */
  YYSYMBOL_T_MODE_L = 400,                 /* T_MODE_L  */
  YYSYMBOL_ccode_expr = 401,               /* ccode_expr  */
  YYSYMBOL_ccode = 402,                    /* ccode  */
  YYSYMBOL_reg_r = 403,                    /* reg_r  */
  YYSYMBOL_reg_tt = 404,                   /* reg_tt  */
  YYSYMBOL_reg_ss = 405,                   /* reg_ss  */
  YYSYMBOL_reg_rr = 406,                   /* reg_rr  */
  YYSYMBOL_hl_ind_inc = 407,               /* hl_ind_inc  */
  YYSYMBOL_hl_ind_dec = 408                /* hl_ind_dec  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
# define YYCOPY_NEEDED 1
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2486

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  208
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  201
/* YYNRULES -- Number of rules.  */
#define YYNRULES  514
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  928

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   462


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX) YY_CAST (yysymbol_kind_t, YYX)

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   689,   689,   692,   693,   696,   696,   699,   700,   701,
     702,   703,   706,   707,   709,   709,   717,   717,   735,   736,
     737,   738,   739,   740,   742,   743,   746,   756,   773,   789,
     794,   794,   802,   802,   810,   810,   811,   811,   813,   814,
     817,   820,   823,   826,   830,   836,   836,   844,   847,   853,
     854,   855,   856,   857,   858,   861,   862,   863,   864,   865,
     866,   867,   868,   869,   870,   871,   872,   873,   874,   875,
     876,   877,   878,   879,   880,   881,   882,   883,   884,   885,
     886,   887,   888,   889,   890,   891,   892,   893,   894,   895,
     896,   897,   898,   899,   900,   903,   903,   906,   907,   908,
     909,   910,   911,   912,   913,   914,   915,   918,   921,   922,
     925,   928,   934,   940,   946,   952,   963,   963,   969,   970,
     973,   976,   979,   982,   985,   988,   991,   994,   995,   996,
     997,  1000,  1011,  1022,  1026,  1032,  1033,  1036,  1039,  1042,
    1042,  1051,  1053,  1055,  1051,  1063,  1068,  1073,  1080,  1086,
    1088,  1090,  1086,  1097,  1097,  1107,  1110,  1113,  1114,  1117,
    1120,  1123,  1126,  1127,  1133,  1137,  1143,  1144,  1147,  1148,
    1151,  1152,  1155,  1158,  1161,  1162,  1163,  1164,  1167,  1173,
    1179,  1185,  1188,  1191,  1191,  1198,  1199,  1202,  1205,  1208,
    1209,  1212,  1215,  1222,  1227,  1232,  1239,  1244,  1245,  1248,
    1251,  1254,  1257,  1260,  1264,  1270,  1271,  1274,  1275,  1278,
    1290,  1291,  1294,  1297,  1306,  1307,  1310,  1313,  1322,  1323,
    1326,  1329,  1339,  1345,  1351,  1355,  1361,  1367,  1374,  1375,
    1386,  1387,  1388,  1391,  1394,  1397,  1400,  1403,  1406,  1409,
    1412,  1415,  1418,  1421,  1424,  1427,  1430,  1433,  1436,  1439,
    1442,  1445,  1448,  1451,  1452,  1453,  1454,  1455,  1456,  1457,
    1461,  1462,  1463,  1464,  1464,  1471,  1474,  1477,  1480,  1483,
    1486,  1489,  1492,  1495,  1498,  1501,  1504,  1507,  1510,  1513,
    1516,  1519,  1524,  1529,  1532,  1535,  1538,  1545,  1548,  1551,
    1554,  1555,  1565,  1566,  1572,  1578,  1584,  1587,  1590,  1593,
    1596,  1599,  1603,  1618,  1619,  1630,  1638,  1641,  1648,  1657,
    1662,  1663,  1664,  1667,  1668,  1669,  1670,  1671,  1672,  1673,
    1674,  1677,  1678,  1688,  1693,  1696,  1700,  1707,  1708,  1709,
    1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,
    1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,
    1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,
    1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,  1748,  1749,
    1750,  1751,  1752,  1755,  1759,  1762,  1766,  1767,  1768,  1775,
    1779,  1782,  1788,  1792,  1798,  1801,  1805,  1808,  1811,  1814,
    1815,  1818,  1821,  1824,  1836,  1837,  1840,  1844,  1848,  1853,
    1857,  1863,  1866,  1871,  1874,  1879,  1885,  1891,  1894,  1899,
    1900,  1906,  1907,  1908,  1909,  1910,  1911,  1912,  1913,  1916,
    1920,  1926,  1927,  1933,  1937,  1954,  1959,  1964,  1968,  1976,
    1982,  1988,  2010,  2014,  2022,  2025,  2029,  2032,  2035,  2038,
    2044,  2045,  2048,  2051,  2057,  2060,  2066,  2069,  2075,  2078,
    2084,  2087,  2097,  2101,  2104,  2107,  2113,  2119,  2125,  2131,
    2135,  2141,  2145,  2148,  2154,  2158,  2161,  2164,  2165,  2168,
    2169,  2172,  2173,  2176,  2177,  2180,  2181,  2184,  2185,  2188,
    2189,  2192,  2193,  2196,  2197,  2200,  2201,  2206,  2207,  2208,
    2209,  2212,  2213,  2214,  2215,  2216,  2217,  2218,  2219,  2222,
    2223,  2224,  2225,  2228,  2229,  2230,  2231,  2234,  2235,  2236,
    2237,  2240,  2241,  2244,  2245
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  static const char *const yy_sname[] =
  {
  "end of file", "error", "invalid token", "number", "string", ".", ",",
  ":", "[", "]", "(", ")", "newline", "!", "&&", "||", ">", "<", ">=",
  "<=", "!=", "==", "+", "-", "|", "^", "&", "<<", ">>", ">>>", "*", "/",
  "%", "~", "NEG", "**", "DEF", "BANK", "ALIGN", "SIZEOF", "STARTOF",
  "SIN", "COS", "TAN", "ASIN", "ACOS", "ATAN", "ATAN2", "FDIV", "FMUL",
  "FMOD", "POW", "LOG", "ROUND", "CEIL", "FLOOR", "HIGH", "LOW", "ISCONST",
  "STRCMP", "STRIN", "STRRIN", "STRSUB", "STRLEN", "STRCAT", "STRUPR",
  "STRLWR", "STRRPL", "STRFMT", "CHARLEN", "CHARSUB", "label",
  "identifier", "local identifier", "anonymous label", "EQU", "=", "EQUS",
  "+=", "-=", "*=", "/=", "%=", "|=", "^=", "&=", "<<=", ">>=", "INCLUDE",
  "PRINT", "PRINTLN", "IF", "ELIF", "ELSE", "ENDC", "EXPORT", "DB", "DS",
  "DW", "DL", "SECTION", "FRAGMENT", "RB", "RW", "MACRO", "ENDM",
  "RSRESET", "RSSET", "UNION", "NEXTU", "ENDU", "INCBIN", "REPT", "FOR",
  "CHARMAP", "NEWCHARMAP", "SETCHARMAP", "PUSHC", "POPC", "SHIFT", "ENDR",
  "BREAK", "LOAD", "ENDL", "FAIL", "WARN", "FATAL", "ASSERT",
  "STATIC_ASSERT", "PURGE", "REDEF", "POPS", "PUSHS", "POPO", "PUSHO",
  "OPT", "ROM0", "ROMX", "WRAM0", "WRAMX", "HRAM", "VRAM", "SRAM", "OAM",
  "adc", "add", "and", "bit", "call", "ccf", "cp", "cpl", "daa", "dec",
  "di", "ei", "halt", "inc", "jp", "jr", "ld", "ldi", "ldd", "ldh", "nop",
  "or", "pop", "push", "res", "ret", "reti", "rst", "rl", "rla", "rlc",
  "rlca", "rr", "rra", "rrc", "rrca", "sbc", "scf", "set", "stop", "sla",
  "sra", "srl", "sub", "swap", "xor", "a", "b", "c", "d", "e", "h", "l",
  "af", "bc", "de", "sp", "hl", "hld/hl-", "hli/hl+", "nz", "z", "nc",
  "end of buffer", "$accept", "asmfile", "lines", "endofline",
  "plain_directive", "line", "$@1", "$@2", "line_directive", "if", "elif",
  "else", "endc", "def_id", "$@3", "redef_id", "$@4", "scoped_id",
  "scoped_anon_id", "label", "macro", "$@5", "macroargs",
  "assignment_directive", "directive", "trailing_comma", "compoundeq",
  "equ", "assignment", "equs", "rb", "rw", "rl", "align", "opt", "$@6",
  "opt_list", "opt_list_entry", "popo", "pusho", "pops", "pushs", "fail",
  "warn", "assert_type", "assert", "shift", "load", "rept", "@7", "for",
  "$@8", "$@9", "@10", "for_args", "break", "macrodef", "$@11", "$@12",
  "@13", "@14", "rsset", "rsreset", "rs_uconst", "union", "nextu", "endu",
  "ds", "ds_args", "db", "dw", "dl", "def_equ", "redef_equ", "def_set",
  "def_rb", "def_rw", "def_rl", "def_equs", "redef_equs", "purge", "$@15",
  "purge_list", "purge_list_entry", "export", "export_list",
  "export_list_entry", "include", "incbin", "charmap", "newcharmap",
  "setcharmap", "pushc", "popc", "print", "println", "print_exprs",
  "print_expr", "const_3bit", "constlist_8bit", "constlist_8bit_entry",
  "constlist_16bit", "constlist_16bit_entry", "constlist_32bit",
  "constlist_32bit_entry", "reloc_8bit", "reloc_8bit_no_str",
  "reloc_8bit_offset", "reloc_16bit", "reloc_16bit_no_str", "relocexpr",
  "relocexpr_no_str", "$@16", "uconst", "const", "const_no_str",
  "const_8bit", "opt_q_arg", "string", "strcat_args", "strfmt_args",
  "strfmt_va_args", "section", "sectmod", "sectiontype", "sectorg",
  "sectattrs", "cpu_command", "z80_adc", "z80_add", "z80_and", "z80_bit",
  "z80_call", "z80_ccf", "z80_cp", "z80_cpl", "z80_daa", "z80_dec",
  "z80_di", "z80_ei", "z80_halt", "z80_inc", "z80_jp", "z80_jr", "z80_ldi",
  "z80_ldd", "z80_ldio", "c_ind", "z80_ld", "z80_ld_hl", "z80_ld_sp",
  "z80_ld_mem", "z80_ld_cind", "z80_ld_rr", "z80_ld_r", "z80_ld_a",
  "z80_ld_ss", "z80_nop", "z80_or", "z80_pop", "z80_push", "z80_res",
  "z80_ret", "z80_reti", "z80_rl", "z80_rla", "z80_rlc", "z80_rlca",
  "z80_rr", "z80_rra", "z80_rrc", "z80_rrca", "z80_rst", "z80_sbc",
  "z80_scf", "z80_set", "z80_sla", "z80_sra", "z80_srl", "z80_stop",
  "z80_sub", "z80_swap", "z80_xor", "op_mem_ind", "op_a_r", "op_a_n",
  "T_MODE_A", "T_MODE_B", "T_MODE_C", "T_MODE_D", "T_MODE_E", "T_MODE_H",
  "T_MODE_L", "ccode_expr", "ccode", "reg_r", "reg_tt", "reg_ss", "reg_rr",
  "hl_ind_inc", "hl_ind_dec", YY_NULLPTR
  };
  return yy_sname[yysymbol];
}
#endif

#define YYPACT_NINF (-472)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-309)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -472,    19,  1072,  -472,  -472,  -472,   522,    61,  2386,  2386,
      62,  -472,  2386,  -472,     3,  -472,  -472,  -472,  -472,  -472,
    2199,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,
    -472,  -472,  -472,     3,  -472,    50,  2386,  2386,   383,  -472,
    -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  2386,
    2386,  2386,  2386,    91,  -472,  -472,  2386,  2386,  2386,  2386,
    2386,  -472,    94,   100,   105,   128,   131,   145,   149,   152,
     154,   162,   166,   173,   176,   185,   199,   208,   221,   223,
     227,   230,   232,   237,   240,   244,   245,   247,   249,   250,
     251,   252,   253,   255,   257,  -472,  -472,  -472,   258,  -472,
    -472,  1097,  -472,    88,  -472,   111,  -472,    34,   260,  -472,
     202,  -472,  -472,  -472,  -472,  2386,  -472,   383,  2386,  2386,
    -472,   135,  2386,  2386,  2386,  2386,   -11,  -472,  2386,  -472,
    -472,  -472,   383,   383,   203,   211,  -472,  -472,  2386,     3,
     -11,  -472,   383,   383,     1,     1,  -472,  -472,  -472,  -472,
    -472,  -472,  -472,  1958,  1435,  1958,  2386,  1259,  -472,  1958,
    -472,  -472,    86,  -472,  -472,  -472,    86,   949,  1259,   104,
      26,    58,    68,  -472,  1958,   -10,   -10,  2386,     7,  -472,
    2386,    30,  -472,    30,  -472,    30,  -472,    30,  -472,  1958,
    -472,  2386,  2386,    30,    30,    30,  1958,    30,  1958,  -472,
     323,   503,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,
    -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,
    -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,
    -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,
    -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,
    -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,
    -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,
    -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,
    -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,
    -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,     3,
    -472,   276,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,
    -472,   799,   254,   254,   254,   254,   280,   101,   383,   383,
    2386,  2386,  2386,  2386,  2386,  2386,  2386,  2386,  2386,  2386,
    2386,  2386,  2386,  2386,  2386,  2386,  2386,  2386,   383,   383,
     383,   383,   383,   324,   383,   383,   383,   383,   383,   383,
      72,  2386,  2386,  2386,  2386,  2386,  2386,  2386,  2386,  2386,
    2386,  2386,  2386,  2386,  2386,  2386,  2386,  2386,  2386,  2386,
    2386,  -472,  -472,  -472,  -472,  -472,   219,   287,  -472,     3,
     295,  -472,  1097,    20,  -472,    12,   295,  -472,   300,  -472,
     302,  -472,  -472,    21,    31,   304,   305,  -472,  -472,    46,
      49,   306,  -472,    59,    63,  -472,  -472,   383,  -472,   325,
     330,   342,  -472,  -472,  -472,   383,  -472,  -472,   345,   346,
     359,  2386,  2386,   135,   294,   326,   167,   319,   357,  -472,
    -472,  -472,  -472,  -472,  -472,  -472,  -472,  1097,  -472,  -472,
     368,  -472,  -472,  -472,  -472,  -472,  -472,  -472,   369,   370,
    -472,  -472,  -472,  -472,   371,  -472,  1259,  -472,  -472,  -472,
    -472,  -472,  1097,   372,  -472,  -472,  -472,   385,   386,  -472,
    -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,
     373,  -472,   387,  1331,   405,   406,   407,   408,   410,   411,
     412,   413,  -472,  -472,   220,   417,   414,   222,   423,  2133,
     427,   428,   433,  -472,  -472,  -472,  -472,  -472,  -472,  -472,
    -472,   434,     7,  -472,  -472,  -472,  -472,  -472,  -472,  -472,
    -472,   435,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,
    -472,  2386,  2386,   383,  2386,  2386,  2386,  2386,  2386,  2386,
     383,  2386,  -472,  -472,  -472,    72,   425,   431,   432,   441,
     438,   438,   438,   438,   438,   438,   440,   457,   458,   463,
     465,   467,   438,   438,   438,   831,  1013,  1036,   468,   469,
     470,   471,   473,  -472,  -472,    90,   474,   475,   472,  -472,
     479,   480,   476,   481,  1763,  1575,   315,   315,   315,   315,
     315,   315,   430,   430,   150,   150,   150,   121,   121,   121,
     254,   254,   254,  -472,   416,     3,   488,  -472,  2386,   497,
    -472,  2386,  -472,  -472,   135,  -472,  2386,  -472,  2386,  2386,
    -472,  2386,  -472,   500,  2386,  2386,   436,   504,  -472,  -472,
    -472,   756,   506,  -472,   513,  -472,  -472,  -472,   326,  -472,
     494,  1514,  1629,  1958,  2386,     5,    30,  -472,  2386,    -5,
      45,  2386,  2386,   511,   526,   528,   113,   531,   533,   534,
    1392,   536,  2386,  2386,  1704,  1796,   -40,     0,  2030,   -40,
     537,   282,   514,   538,   541,   -40,   -40,   542,    30,    30,
    -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,
    -472,     3,   540,  -472,  -472,  -472,  -472,  2386,   543,   560,
     561,   562,   563,   580,  2386,  2386,  2386,  2386,  2386,  2386,
     581,   582,   583,  -472,  -472,  -472,   383,   383,   383,  2386,
    -472,   383,  -472,  -472,  -472,   383,   546,  -472,  -472,  2386,
    -472,  -472,  -472,  2386,  -472,  -472,  -472,  -472,  -472,   589,
    -472,  -472,  -472,   422,   604,  -472,  -472,  -472,   422,   383,
     383,   135,  -472,  -472,  -472,   600,   601,   602,   603,   605,
     607,   608,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,
    1870,  -472,  -472,   606,   611,  -472,  -472,  -472,  2133,  -472,
    -472,  -472,  -472,  -472,   192,  -472,  -472,  -472,  -472,  -472,
    -472,  -472,  -472,  -472,  -472,   615,   421,   617,   426,  -472,
    -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,
    -472,  -472,  -472,  -472,   438,   438,   438,   438,   438,   438,
    -472,  -472,  -472,   618,   619,   621,    96,  -472,   622,  2386,
     624,     3,   626,   627,  2386,  -472,  -472,  -472,  -472,  -472,
    -472,  -472,  -472,  -472,   631,  2386,   631,  -472,  -472,  -472,
    -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,   632,
    2386,  2386,  -472,   -40,   633,   -40,   634,   629,   635,   636,
     640,   641,   642,  -472,  -472,  -472,  2386,  -472,   383,  -472,
     102,  -472,  -472,  -472,  2386,  -472,  2386,  -472,  -472,  -472,
    -472,  1097,  1097,  -472,  -472,  -472,  -472,  -472,  -472,  -472,
    -472,  -472,  -472,   643,   644,     3,   638,   647,   639,   639,
    -472,  -472,  -472,  2386,  -472,   198,  -472,   649,   650,  2386,
    2386,   651,    71,  -472,  2386,  -472,   653,  -472
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       3,     0,     0,     1,    14,    39,     0,    40,     0,     0,
       0,   149,     0,   141,     0,     4,    13,    23,    24,    25,
       7,    11,    49,    50,    54,    51,    52,    53,    19,    20,
      21,    18,    22,     0,    16,    42,     0,     0,     0,    97,
      98,    99,   100,   101,   103,   102,   104,   105,   106,   157,
     157,   157,     0,    41,   231,   292,     0,     0,     0,     0,
       0,   263,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    34,    35,    37,     0,    36,
     230,   287,   228,     0,   229,     0,    28,     0,     0,   286,
       0,     5,     6,    12,    30,     0,    45,     0,     0,   203,
      29,     0,   166,     0,   168,   170,   310,   156,     0,   159,
     160,   161,     0,     0,     0,     0,   200,   201,   135,     0,
     310,   138,     0,     0,   127,   127,   183,    32,   123,   124,
     121,   122,   116,     0,     0,     0,     0,     0,   384,     0,
     387,   388,     0,   391,   392,   393,     0,     0,     0,     0,
       0,     0,     0,   434,     0,     0,     0,     0,   440,   442,
       0,     0,   444,     0,   446,     0,   448,     0,   450,     0,
     454,     0,   459,     0,     0,     0,     0,     0,     0,    55,
       0,     0,     9,    10,    94,    93,    91,    92,    89,    90,
      77,    78,    79,    76,    75,    65,    64,    66,    67,    68,
      62,    59,    60,    61,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    58,    69,    70,    71,    72,    73,    74,
      56,    57,    63,     8,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     345,   344,   346,   343,   415,   416,   411,   412,   413,   417,
     418,   414,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,    15,     0,
      44,     0,   107,   108,   110,   111,   158,   112,   113,   109,
      43,     0,   232,   253,   254,   255,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    26,    27,   150,   139,   142,     0,   114,    47,     0,
      95,   205,     0,   228,   207,   229,    95,   191,    95,   189,
      95,   210,   212,   228,   229,   162,    95,   214,   216,   228,
     229,    95,   218,   228,   229,   312,   311,     0,   155,   193,
       0,   197,   199,   136,   148,     0,   125,   126,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   471,
     473,   475,   477,   479,   481,   483,   469,   222,   374,   373,
     498,   491,   492,   493,   494,   495,   496,   467,     0,     0,
     376,   375,   380,   379,     0,   209,     0,   490,   487,   488,
     489,   382,   226,     0,   485,   386,   385,     0,     0,   503,
     504,   506,   505,   498,   389,   390,   394,   395,   398,   396,
       0,   399,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   509,   510,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   436,   435,   502,   499,   500,   501,   437,
     438,     0,     0,   441,   451,   443,   445,   447,   449,   453,
     452,     0,   460,   456,   457,   458,   462,   461,   463,   465,
     464,     0,     0,     0,   157,   157,   157,     0,     0,     0,
       0,     0,    17,   153,   285,     0,     0,     0,     0,     0,
     290,   290,   290,   290,   290,   290,     0,     0,     0,     0,
       0,     0,   290,   290,   290,     0,     0,     0,     0,     0,
       0,     0,     0,   296,   303,     0,     0,     0,     0,   306,
       0,     0,     0,     0,   234,   233,   236,   237,   238,   239,
     240,   235,   241,   242,   244,   243,   245,   246,   247,   248,
     249,   250,   251,   252,     0,     0,     0,    31,     0,    46,
     192,    96,   202,   204,    96,   188,    96,   167,     0,    96,
     169,    96,   171,     0,     0,     0,     0,     0,   129,   128,
     130,   131,   133,   187,    95,   185,    33,   120,   117,   118,
       0,     0,     0,     0,     0,     0,     0,   486,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     226,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     172,   174,   181,   178,   179,   180,   176,   173,   175,   182,
     177,     0,     0,   259,   260,   261,   262,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   256,   257,   258,     0,     0,     0,     0,
     283,     0,   297,   298,   299,     0,   305,   301,   284,     0,
     302,   151,   140,     0,   115,    48,   206,   190,   211,    95,
     164,   215,   219,     0,   194,   289,   196,   198,     0,     0,
       0,    96,   184,   119,   497,     0,     0,     0,     0,     0,
       0,     0,   470,   468,   378,   377,   381,   383,   397,   400,
       0,   507,   508,     0,     0,   513,   511,   466,     0,   409,
     432,   433,   421,   422,     0,   420,   425,   423,   424,   427,
     429,   431,   428,   430,   426,     0,     0,     0,     0,   408,
     406,   407,   405,   439,   455,   154,   264,   291,   273,   274,
     275,   276,   277,   278,   290,   290,   290,   290,   290,   290,
     265,   266,   267,     0,     0,     0,     0,   304,     0,     0,
       0,     0,     0,   145,    96,   163,   316,   315,   313,   318,
     317,   314,   319,   320,   321,     0,   321,   132,   134,   186,
     472,   474,   478,   482,   476,   480,   484,   512,   514,     0,
       0,     0,   419,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   280,   281,   282,     0,   294,     0,   307,
     229,   295,   152,   143,     0,   165,     0,   323,   195,   323,
     410,   224,   225,   401,   402,   403,   404,   279,   268,   269,
     270,   271,   272,     0,     0,     0,   146,     0,   309,   137,
     293,   300,   144,     0,   322,     0,   147,     0,     0,     0,
       0,     0,     0,   326,     0,   324,     0,   325
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -472,  -472,  -472,   -30,  -472,  -472,  -472,  -472,  -472,  -472,
    -472,  -472,  -472,  -472,  -472,  -472,  -472,  -114,  -300,  -472,
    -472,  -472,  -472,  -472,  -472,  -342,    51,  -472,  -472,  -472,
    -472,  -472,  -472,  -472,  -472,  -472,  -472,    25,  -472,  -472,
    -472,  -472,  -472,  -472,   539,  -472,  -472,  -472,  -472,  -472,
    -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,
    -472,  -472,  -472,   -37,  -472,  -472,  -472,  -472,  -472,  -472,
    -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,
    -472,  -472,  -472,   -92,  -472,  -472,    73,  -472,  -472,  -472,
    -472,  -472,  -472,  -472,  -472,  -472,   566,    77,  -107,  -472,
      70,  -472,    74,  -472,    82,  -129,  -472,  -472,   -95,  -472,
     313,   -83,  -472,   -12,    -7,  -140,  -472,  -434,    15,  -472,
    -472,  -472,  -472,   551,   -56,  -151,  -193,  -472,  -472,  -472,
    -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,
    -472,  -472,  -472,  -472,  -472,  -472,  -472,  -164,  -472,  -472,
    -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,
    -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,
    -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,  -472,
    -472,  -472,  -472,  -161,    43,    75,  -149,  -472,  -471,  -472,
    -472,  -472,  -472,   -79,  -472,  -102,   530,  -157,    36,  -472,
    -472
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     1,     2,   113,    14,    15,    33,   299,    16,    17,
      18,    19,   199,   200,   376,   201,   424,    99,   100,    20,
     202,   378,   609,    21,   203,   612,    52,    22,    23,    24,
      25,    26,    27,   204,   205,   425,   638,   639,   206,   207,
     208,   209,   210,   211,   421,   212,   213,   214,    28,   605,
      29,   110,   606,   905,   832,    30,    31,   107,   604,   831,
     691,   215,   216,   305,   217,   218,   219,   220,   739,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   423,   634,   635,   233,   388,   389,    32,   234,   235,
     236,   237,   238,   239,   240,   241,   380,   381,   454,   390,
     391,   396,   397,   401,   402,   436,   392,   862,   659,   398,
     101,   102,   316,   306,   109,   384,   746,   698,   104,   575,
     580,   726,   242,   407,   844,   887,   908,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   488,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   489,   438,   439,   473,   441,   442,   443,
     444,   445,   446,   647,   464,   447,   509,   475,   491,   492,
     493
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     108,   103,   105,   298,   440,   440,   440,   387,   500,   477,
     440,   501,   661,   307,   308,   111,   495,   546,  -208,     3,
     512,   496,   498,   502,  -208,   440,  -288,  -223,   661,   302,
     303,  -288,  -288,  -223,   494,   383,   383,  -213,   426,   393,
     440,   399,   403,  -213,   613,   309,   615,   440,   617,   440,
     583,   514,  -227,   304,   620,  -217,   495,   300,  -227,   622,
     474,  -217,   461,   522,   476,  -220,   497,   490,    53,  -221,
     511,  -220,   479,   481,   106,  -221,   499,   924,   463,   515,
     925,   516,   495,   517,   521,   518,   467,   468,   480,   482,
     405,   523,   524,   525,   426,   528,   721,   406,   310,   513,
     371,   722,   876,   377,   317,    55,   373,   877,  -308,   414,
     318,   395,   483,  -308,   495,   319,   408,   699,   700,   701,
     702,   703,   754,   372,   495,   418,   419,   420,   710,   711,
     712,   413,   379,   385,   385,   773,   774,   394,   320,   400,
     404,   321,   467,   468,    95,    96,    97,   409,   410,   455,
     429,   367,   368,   369,   301,   322,   370,   416,   417,   323,
     467,   468,   324,    86,   325,    88,    89,    90,    91,    92,
     455,    94,   326,    95,    96,    97,   327,   364,   365,   366,
     367,   368,   369,   328,   455,   370,   329,   505,   506,   507,
     429,   508,   755,   756,   757,   330,   758,   450,   452,   457,
     787,    98,   465,   469,   470,   471,   472,    95,    96,   331,
     112,   458,   459,   460,   860,   861,   429,   503,   332,  -208,
     429,   430,   431,   432,   433,   434,   435,  -288,  -223,   451,
     453,   333,   519,   334,   466,   917,   918,   335,  -213,   526,
     336,   529,   337,   759,   760,   692,   761,   338,   429,   504,
     339,   537,   541,  -227,   340,   341,  -217,   342,   429,   343,
     344,   345,   346,   347,   520,   348,  -220,   349,   350,   542,
    -221,   527,   374,   530,   375,   411,   429,   430,   431,   432,
     433,   434,   435,   412,   469,   470,   471,   472,   543,   370,
     545,   607,   752,   608,   429,   430,   431,   432,   433,   434,
     435,   611,   484,   485,   486,   487,   614,   859,   616,   633,
     618,   619,   621,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,    55,   641,
     637,   624,   547,   548,   549,   573,   625,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   626,   610,
     370,   628,   629,   568,   569,   570,   571,   572,   574,   576,
     577,   578,   579,   581,   582,   630,   636,   642,   640,   311,
     312,   313,   314,   315,   643,   644,   645,   646,   648,   651,
     867,   868,   869,   870,   871,   872,    86,    55,    88,    89,
      90,    91,    92,   652,    94,   649,   650,   835,   531,   532,
     533,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,   662,   663,   664,   665,   632,   666,   667,   668,   669,
     672,   670,   623,   673,    98,   534,   535,   671,   731,   674,
     627,   382,   382,   675,   676,   382,   693,   382,   382,   677,
     678,   679,   694,   695,   697,    86,   704,    88,    89,    90,
      91,    92,   696,    94,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   705,   706,   370,   437,   437,   437,   707,
     462,   708,   437,   709,   716,   717,   718,   719,   725,   755,
     462,   462,   729,    98,   720,   723,   724,   437,   765,   740,
     727,   728,   730,   437,   733,   536,   745,   683,   684,   685,
     387,   735,   437,   754,   790,   437,   743,   791,   747,   437,
     748,   437,   750,   801,   762,   764,   802,   786,   788,   751,
     794,   770,   796,    34,   680,   681,   799,   800,   383,    35,
     686,   687,   688,   393,   690,   771,   399,   772,   403,   789,
     775,   763,   776,   777,   766,   779,   795,   797,   682,   798,
     499,   806,   829,   767,   808,   689,   768,   769,   836,   837,
     838,   839,   840,   841,   842,   843,   792,   780,   781,   783,
     785,   809,   810,   811,   812,   732,   803,   804,   538,   539,
     540,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,   813,   820,   821,   822,   834,   734,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
     845,   850,   851,   852,   853,   857,   854,   744,   855,   856,
     858,   863,   864,   865,    49,    50,   385,   866,   878,   873,
     874,   394,   875,   884,   400,   881,   404,   633,   883,   886,
     897,   890,   894,   896,   913,   915,   898,   899,   565,   566,
     567,   900,   901,   902,   910,   911,   914,   919,   920,   849,
     923,   805,   927,   753,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   422,   386,   738,   737,   736,   879,
     807,   415,   846,   741,    51,   889,   909,   814,   815,   816,
     817,   818,   819,   742,   793,   885,   510,     0,     0,     0,
       0,     0,   826,     0,   893,     0,   895,     0,     0,     0,
       0,     0,   830,     0,     0,     0,   833,     0,     0,     0,
       0,   823,   824,   825,   631,     0,   827,     0,     0,     0,
     828,     0,     0,     0,     0,     0,   383,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   749,     0,   847,   848,     0,     0,     0,   312,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,     0,
       0,   370,     0,     0,     0,     0,   660,     0,     0,     0,
       0,   882,     0,     0,     0,     0,     0,     0,     0,     0,
     544,     0,   660,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,     0,     0,   370,     0,     0,     0,   888,     0,
       0,     0,   713,     0,   880,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   903,     0,   370,     0,     0,     0,
       0,     0,     0,     0,   907,   912,     0,   906,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   904,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   916,   921,   922,     0,
       0,     0,   926,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   382,     0,     0,     0,     0,   382,
       0,   437,   382,     0,   382,     0,     0,     0,   437,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    54,    55,   565,   566,   437,   437,     0,    56,
       0,   462,   456,     0,   462,   462,     0,     0,     0,     0,
       0,    58,    59,     0,     0,   462,   462,   462,   462,     0,
       0,   437,    60,     0,     0,    61,    62,     0,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
       0,    95,    96,    97,   714,     0,     0,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,     0,   715,   370,    98,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,     0,
       0,   370,    -2,     4,     0,     0,     0,     0,     0,     5,
       0,     0,     0,   566,   -38,     0,     0,     0,     0,     0,
       0,   592,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   -38,     0,
     -38,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
       0,     0,   370,     0,     0,     0,     0,     0,     0,     0,
       0,   457,   382,     6,   -38,     7,     0,   437,     0,     0,
     478,     0,     0,   458,   459,   460,     0,     0,     0,     0,
     -38,   -38,   -38,     8,     9,    10,   -38,   -38,   -38,   -38,
     -38,   -38,   -38,   891,   892,     0,    11,     0,   -38,   -38,
     -38,   -38,   -38,   -38,    12,    13,   -38,   -38,   -38,   -38,
     -38,   -38,     0,   -38,   -38,   -38,   -38,   -38,     0,   -38,
     -38,   -38,   -38,   -38,   -38,   -38,   -38,   -38,     0,     0,
       0,     0,     0,     0,     0,     0,   -38,   -38,   -38,   -38,
     -38,   -38,   -38,   -38,   -38,   -38,   -38,   -38,   -38,   -38,
     -38,   -38,   -38,   -38,   -38,   -38,   -38,   -38,   -38,   -38,
     -38,   -38,   -38,   -38,   -38,   -38,   -38,   -38,   -38,   -38,
     -38,   -38,   -38,   -38,   -38,   -38,   -38,   -38,   -38,   -38,
     -38,   -38,    54,    55,     0,     0,     0,     0,     0,    56,
       0,     0,   456,     0,     0,     0,     0,     0,     0,   -38,
       0,    58,    59,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    60,     0,     0,    61,    62,     0,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
       0,    95,    96,    97,    54,    55,     0,     0,     0,     0,
       0,    56,     0,     0,    57,     0,     0,     0,     0,     0,
       0,     0,     0,    58,    59,     0,     0,     0,     0,    98,
       0,     0,     0,     0,    60,     0,     0,    61,    62,     0,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,   653,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,     0,    95,    96,    97,   351,   352,   353,   354,
     355,   356,   357,   358,   778,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,     0,     0,   370,     0,     0,
       0,    98,     0,     0,     0,     0,     0,     0,    54,    55,
       0,     0,     0,   426,     0,    56,     0,     0,    57,     0,
       0,   457,     0,     0,     0,     0,     0,    58,    59,     0,
       0,     0,     0,   458,   459,   460,     0,     0,    60,     0,
       0,    61,    62,     0,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,   427,   428,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,     0,    95,    96,    97,
       0,     0,     0,     0,     0,     0,     0,    54,    55,     0,
       0,     0,     0,   431,    56,     0,     0,    57,     0,   654,
     655,     0,   656,   657,   658,    98,    58,    59,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    60,     0,     0,
      61,    62,     0,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,     0,    95,    96,    97,   351,
       0,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,     0,     0,
     370,     0,     0,     0,    98,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   429,   430,   431,   432,   433,
     434,   435,    54,    55,     0,   448,   449,     0,     0,    56,
       0,     0,    57,     0,     0,     0,     0,     0,     0,     0,
       0,    58,    59,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    60,     0,     0,    61,    62,     0,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
       0,    95,    96,    97,     0,     0,     0,    54,    55,     0,
       0,   755,   756,   757,    56,   758,     0,    57,     0,     0,
       0,     0,     0,     0,     0,     0,    58,    59,     0,    98,
       0,     0,     0,     0,     0,     0,     0,    60,     0,     0,
      61,    62,     0,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,     0,    95,    96,    97,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,     0,     0,   370,    54,
      55,     0,     0,     0,    98,     0,    56,     0,     0,    57,
       0,     0,     0,     0,     0,     0,     0,     0,    58,    59,
       0,     0,     0,     0,     0,     0,     0,   759,   760,    60,
     761,     0,    61,    62,     0,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,     0,    95,    96,
      97,     0,     0,    54,    55,     0,     0,     0,     0,     0,
      56,     0,     0,    57,     0,     0,     0,     0,     0,     0,
       0,     0,    58,    59,     0,     0,    98,     0,     0,     0,
       0,     0,     0,    60,     0,   782,    61,    62,     0,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,     0,    95,    96,    97,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    54,    55,     0,     0,     0,   426,     0,    56,     0,
      98,    57,     0,     0,     0,     0,     0,     0,     0,     0,
      58,    59,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    60,     0,     0,    61,    62,   784,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,   427,   428,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,     0,
      95,    96,    97,    54,    55,     0,     0,     0,   483,     0,
      56,     0,     0,    57,     0,     0,     0,     0,     0,     0,
       0,     0,    58,    59,     0,     0,     0,     0,    98,     0,
       0,     0,     0,    60,     0,     0,    61,    62,   759,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,   427,   428,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,     0,    95,    96,    97,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      98,     0,     0,     0,     0,     0,    54,    55,     0,     0,
       0,     0,     0,    56,     0,     0,    57,     0,   429,   430,
     431,   432,   433,   434,   435,    58,    59,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    60,     0,     0,    61,
      62,     0,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
     653,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,     0,    95,    96,    97,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     429,   430,   431,   432,   433,   434,   435,     0,     0,     0,
       0,     0,     0,    98,     0,   114,     0,   115,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   116,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   117,   118,   119,
       0,     0,     0,   120,   121,   122,   123,   124,   125,   126,
       0,     0,     0,     0,     0,   127,   128,   129,   130,   131,
     132,     0,     0,   133,   134,   135,   136,   137,   138,     0,
     139,   140,   141,   142,   143,   431,   144,   145,   146,   147,
     148,   149,   150,   151,   152,     0,     0,     0,     0,     0,
       0,     0,     0,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,    54,
      55,     0,     0,     0,     0,     0,    56,     0,     0,    57,
       0,     0,     0,     0,     0,     0,     0,     0,    58,    59,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    60,
       0,     0,    61,    62,     0,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,     0,    95,    96,
      97,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    98
};

static const yytype_int16 yycheck[] =
{
      12,     8,     9,    33,   153,   154,   155,   121,   172,   166,
     159,   172,   483,    50,    51,    12,    56,   317,     6,     0,
      13,   170,   171,   172,    12,   174,     6,     6,   499,    36,
      37,    11,    12,    12,     8,   118,   119,     6,     8,   122,
     189,   124,   125,    12,   386,    52,   388,   196,   390,   198,
     350,   180,     6,    38,   396,     6,    56,     7,    12,   401,
     162,    12,   157,   192,   166,     6,     8,   169,     7,     6,
     177,    12,   167,   168,    12,    12,     8,     6,   157,   181,
       9,   183,    56,   185,   191,   187,    56,    57,   167,   168,
     101,   193,   194,   195,     8,   197,     6,   108,     7,   178,
      12,    11,     6,   115,    10,     4,    72,    11,     6,   139,
      10,   123,     8,    11,    56,    10,   128,   551,   552,   553,
     554,   555,     9,    12,    56,   124,   125,   126,   562,   563,
     564,   138,   117,   118,   119,    22,    23,   122,    10,   124,
     125,    10,    56,    57,    72,    73,    74,   132,   133,   156,
     190,    30,    31,    32,   104,    10,    35,   142,   143,    10,
      56,    57,    10,    62,    10,    64,    65,    66,    67,    68,
     177,    70,    10,    72,    73,    74,    10,    27,    28,    29,
      30,    31,    32,    10,   191,    35,    10,   197,   198,   199,
     190,   201,   197,   198,   199,    10,   201,   154,   155,   192,
     200,   100,   159,   198,   199,   200,   201,    72,    73,    10,
     207,   204,   205,   206,    22,    23,   190,   174,    10,   207,
     190,   191,   192,   193,   194,   195,   196,   207,   207,   154,
     155,    10,   189,    10,   159,    37,    38,    10,   207,   196,
      10,   198,    10,   198,   199,   545,   201,    10,   190,   174,
      10,   200,   201,   207,    10,    10,   207,    10,   190,    10,
      10,    10,    10,    10,   189,    10,   207,    10,    10,   299,
     207,   196,    12,   198,    72,    72,   190,   191,   192,   193,
     194,   195,   196,    72,   198,   199,   200,   201,    12,    35,
      10,    72,   634,     6,   190,   191,   192,   193,   194,   195,
     196,     6,   198,   199,   200,   201,     6,   778,     6,   423,
       6,     6,     6,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,     4,    10,
       4,     6,   317,   318,   319,    11,     6,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,     6,   379,
      35,     6,     6,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,     6,    72,    10,   201,    56,
      57,    58,    59,    60,     6,     6,     6,     6,     6,     6,
     814,   815,   816,   817,   818,   819,    62,     4,    64,    65,
      66,    67,    68,     6,    70,    10,    10,   739,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,     6,     6,     6,     6,   422,     6,     6,     6,     6,
       6,   201,   407,   201,   100,   102,   103,    10,    12,     6,
     415,   118,   119,     6,     6,   122,    11,   124,   125,     6,
       6,     6,    11,    11,     6,    62,     6,    64,    65,    66,
      67,    68,    11,    70,    24,    25,    26,    27,    28,    29,
      30,    31,    32,     6,     6,    35,   153,   154,   155,     6,
     157,     6,   159,     6,     6,     6,     6,     6,     6,   197,
     167,   168,     6,   100,    11,    11,    11,   174,   645,   618,
      11,    11,    11,   180,     6,   172,   625,   534,   535,   536,
     614,     4,   189,     9,   668,   192,     6,   668,    72,   196,
       6,   198,     6,   677,   643,   644,   677,   666,   667,     6,
     669,    10,     8,     1,   531,   532,   675,   676,   611,     7,
     537,   538,   539,   616,   541,     9,   619,     9,   621,   668,
       9,   643,     9,     9,   646,     9,     9,     9,   533,     8,
       8,    11,     6,   648,    11,   540,   651,   652,   136,   137,
     138,   139,   140,   141,   142,   143,   668,   662,   663,   664,
     665,    11,    11,    11,    11,   605,   678,   679,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    11,    11,    11,    11,     6,   608,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
       6,    11,    11,    11,    11,     9,    11,   624,    11,    11,
       9,     6,   201,     6,   102,   103,   611,   201,     6,    11,
      11,   616,    11,     6,   619,    11,   621,   751,    12,     8,
      11,     9,     9,     9,     6,     6,    11,    11,   335,   336,
     337,    11,    11,    11,    11,    11,     9,     8,     8,   751,
       9,   691,     9,   638,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   145,   119,   616,   614,   611,   829,
     697,   140,   748,   619,   172,   846,   889,   704,   705,   706,
     707,   708,   709,   621,   668,   834,   176,    -1,    -1,    -1,
      -1,    -1,   719,    -1,   863,    -1,   865,    -1,    -1,    -1,
      -1,    -1,   729,    -1,    -1,    -1,   733,    -1,    -1,    -1,
      -1,   716,   717,   718,   421,    -1,   721,    -1,    -1,    -1,
     725,    -1,    -1,    -1,    -1,    -1,   829,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     6,    -1,   749,   750,    -1,    -1,    -1,   456,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    -1,
      -1,    35,    -1,    -1,    -1,    -1,   483,    -1,    -1,    -1,
      -1,   831,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      11,    -1,   499,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    35,    -1,    -1,    -1,   845,    -1,
      -1,    -1,    11,    -1,   829,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,   876,    -1,    35,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   886,   905,    -1,   884,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   878,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   913,   919,   920,    -1,
      -1,    -1,   924,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   611,    -1,    -1,    -1,    -1,   616,
      -1,   618,   619,    -1,   621,    -1,    -1,    -1,   625,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     3,     4,   641,   642,   643,   644,    -1,    10,
      -1,   648,    13,    -1,   651,   652,    -1,    -1,    -1,    -1,
      -1,    22,    23,    -1,    -1,   662,   663,   664,   665,    -1,
      -1,   668,    33,    -1,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    11,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    -1,    11,    35,   100,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    -1,
      -1,    35,     0,     1,    -1,    -1,    -1,    -1,    -1,     7,
      -1,    -1,    -1,   770,    12,    -1,    -1,    -1,    -1,    -1,
      -1,   778,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    36,    -1,
      38,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      -1,    -1,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   192,   829,    71,    72,    73,    -1,   834,    -1,    -1,
     201,    -1,    -1,   204,   205,   206,    -1,    -1,    -1,    -1,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   860,   861,    -1,   104,    -1,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,   122,   123,   124,   125,    -1,   127,
     128,   129,   130,   131,   132,   133,   134,   135,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,     3,     4,    -1,    -1,    -1,    -1,    -1,    10,
      -1,    -1,    13,    -1,    -1,    -1,    -1,    -1,    -1,   207,
      -1,    22,    23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    -1,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,     3,     4,    -1,    -1,    -1,    -1,
      -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    -1,    -1,    -1,    -1,   100,
      -1,    -1,    -1,    -1,    33,    -1,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    -1,    72,    73,    74,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    -1,    -1,    35,    -1,    -1,
      -1,   100,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,
      -1,    -1,    -1,     8,    -1,    10,    -1,    -1,    13,    -1,
      -1,   192,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,
      -1,    -1,    -1,   204,   205,   206,    -1,    -1,    33,    -1,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,    -1,
      -1,    -1,    -1,   192,    10,    -1,    -1,    13,    -1,   198,
     199,    -1,   201,   202,   203,   100,    22,    23,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    -1,    -1,
      36,    37,    -1,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    14,
      -1,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    -1,    -1,
      35,    -1,    -1,    -1,   100,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   190,   191,   192,   193,   194,
     195,   196,     3,     4,    -1,   200,   201,    -1,    -1,    10,
      -1,    -1,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    -1,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    -1,    -1,    -1,     3,     4,    -1,
      -1,   197,   198,   199,    10,   201,    -1,    13,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,   100,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    -1,    -1,
      36,    37,    -1,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    -1,    -1,    35,     3,
       4,    -1,    -1,    -1,   100,    -1,    10,    -1,    -1,    13,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   198,   199,    33,
     201,    -1,    36,    37,    -1,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    -1,    -1,     3,     4,    -1,    -1,    -1,    -1,    -1,
      10,    -1,    -1,    13,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    -1,   100,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    -1,   201,    36,    37,    -1,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     3,     4,    -1,    -1,    -1,     8,    -1,    10,    -1,
     100,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    -1,    -1,    36,    37,   200,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,     3,     4,    -1,    -1,    -1,     8,    -1,
      10,    -1,    -1,    13,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    -1,    -1,    -1,   100,    -1,
      -1,    -1,    -1,    33,    -1,    -1,    36,    37,   198,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,    -1,    -1,    -1,    -1,    -1,     3,     4,    -1,    -1,
      -1,    -1,    -1,    10,    -1,    -1,    13,    -1,   190,   191,
     192,   193,   194,   195,   196,    22,    23,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    -1,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    -1,    72,    73,    74,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     190,   191,   192,   193,   194,   195,   196,    -1,    -1,    -1,
      -1,    -1,    -1,   100,    -1,    36,    -1,    38,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    72,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    88,    89,    90,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
      -1,    -1,    -1,    -1,    -1,   106,   107,   108,   109,   110,
     111,    -1,    -1,   114,   115,   116,   117,   118,   119,    -1,
     121,   122,   123,   124,   125,   192,   127,   128,   129,   130,
     131,   132,   133,   134,   135,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,     3,
       4,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      -1,    -1,    36,    37,    -1,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,   209,   210,     0,     1,     7,    71,    73,    91,    92,
      93,   104,   112,   113,   212,   213,   216,   217,   218,   219,
     227,   231,   235,   236,   237,   238,   239,   240,   256,   258,
     263,   264,   295,   214,     1,     7,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,   102,
     103,   172,   234,     7,     3,     4,    10,    13,    22,    23,
      33,    36,    37,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    72,    73,    74,   100,   225,
     226,   318,   319,   322,   326,   322,    12,   265,   321,   322,
     259,    12,   207,   211,    36,    38,    72,    88,    89,    90,
      94,    95,    96,    97,    98,    99,   100,   106,   107,   108,
     109,   110,   111,   114,   115,   116,   117,   118,   119,   121,
     122,   123,   124,   125,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   220,
     221,   223,   228,   232,   241,   242,   246,   247,   248,   249,
     250,   251,   253,   254,   255,   269,   270,   272,   273,   274,
     275,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   292,   296,   297,   298,   299,   300,   301,
     302,   303,   330,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   211,   215,
       7,   104,   322,   322,   326,   271,   321,   271,   271,   322,
       7,   318,   318,   318,   318,   318,   320,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      35,    12,    12,    72,    12,    72,   222,   321,   229,   326,
     304,   305,   318,   319,   323,   326,   304,   225,   293,   294,
     307,   308,   314,   319,   326,   321,   309,   310,   317,   319,
     326,   311,   312,   319,   326,   101,   108,   331,   321,   326,
     326,    72,    72,   322,   211,   331,   326,   326,   124,   125,
     126,   252,   252,   289,   224,   243,     8,    56,    57,   190,
     191,   192,   193,   194,   195,   196,   313,   318,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   403,   200,   201,
     392,   393,   392,   393,   306,   322,    13,   192,   204,   205,
     206,   316,   318,   401,   402,   392,   393,    56,    57,   198,
     199,   200,   201,   394,   403,   405,   403,   405,   201,   316,
     401,   316,   401,     8,   198,   199,   200,   201,   355,   391,
     403,   406,   407,   408,     8,    56,   394,     8,   394,     8,
     355,   391,   394,   392,   393,   197,   198,   199,   201,   404,
     404,   306,    13,   401,   313,   403,   403,   403,   403,   392,
     393,   306,   313,   403,   403,   403,   392,   393,   403,   392,
     393,    75,    76,    77,   102,   103,   172,   234,    75,    76,
      77,   234,   211,    12,    11,    10,   226,   326,   326,   326,
     322,   322,   322,   322,   322,   322,   322,   322,   322,   322,
     322,   322,   322,   322,   322,   318,   318,   318,   326,   326,
     326,   326,   326,    11,   326,   327,   326,   326,   326,   326,
     328,   326,   326,   226,   318,   318,   318,   318,   318,   318,
     318,   318,   318,   318,   318,   318,   318,   318,   318,   318,
     318,   318,   318,   318,   266,   257,   260,    72,     6,   230,
     211,     6,   233,   233,     6,   233,     6,   233,     6,     6,
     233,     6,   233,   326,     6,     6,     6,   326,     6,     6,
       6,   318,   322,   225,   290,   291,    72,     4,   244,   245,
     201,    10,    10,     6,     6,     6,     6,   401,     6,    10,
      10,     6,     6,    57,   198,   199,   201,   202,   203,   316,
     318,   396,     6,     6,     6,     6,     6,     6,     6,     6,
     201,    10,     6,   201,     6,     6,     6,     6,     6,     6,
     322,   322,   326,   271,   271,   271,   322,   322,   322,   326,
     322,   268,   226,    11,    11,    11,    11,     6,   325,   325,
     325,   325,   325,   325,     6,     6,     6,     6,     6,     6,
     325,   325,   325,    11,    11,    11,     6,     6,     6,     6,
      11,     6,    11,    11,    11,     6,   329,    11,    11,     6,
      11,    12,   211,     6,   321,     4,   305,   294,   308,   276,
     313,   310,   312,     6,   322,   313,   324,    72,     6,     6,
       6,     6,   233,   245,     9,   197,   198,   199,   201,   198,
     199,   201,   313,   403,   313,   405,   403,   316,   316,   316,
      10,     9,     9,    22,    23,     9,     9,     9,    22,     9,
     316,   316,   201,   316,   200,   316,   394,   200,   394,   313,
     355,   391,   403,   406,   394,     9,     8,     9,     8,   394,
     394,   355,   391,   403,   403,   211,    11,   322,    11,    11,
      11,    11,    11,    11,   322,   322,   322,   322,   322,   322,
      11,    11,    11,   326,   326,   326,   322,   326,   326,     6,
     322,   267,   262,   322,     6,   233,   136,   137,   138,   139,
     140,   141,   142,   143,   332,     6,   332,   326,   326,   291,
      11,    11,    11,    11,    11,    11,    11,     9,     9,   396,
      22,    23,   315,     6,   201,     6,   201,   325,   325,   325,
     325,   325,   325,    11,    11,    11,     6,    11,     6,   323,
     326,    11,   211,    12,     6,   313,     8,   333,   322,   333,
       9,   318,   318,   394,     9,   394,     9,    11,    11,    11,
      11,    11,    11,   321,   326,   261,   322,   321,   334,   334,
      11,    11,   211,     6,     9,     6,   322,    37,    38,     8,
       8,   321,   321,     9,     6,     9,   321,     9
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   208,   209,   210,   210,   211,   211,   212,   212,   212,
     212,   212,   213,   213,   214,   213,   215,   213,   216,   216,
     216,   216,   216,   216,   216,   216,   217,   218,   219,   220,
     222,   221,   224,   223,   225,   225,   226,   226,   227,   227,
     227,   227,   227,   227,   227,   229,   228,   230,   230,   231,
     231,   231,   231,   231,   231,   232,   232,   232,   232,   232,
     232,   232,   232,   232,   232,   232,   232,   232,   232,   232,
     232,   232,   232,   232,   232,   232,   232,   232,   232,   232,
     232,   232,   232,   232,   232,   232,   232,   232,   232,   232,
     232,   232,   232,   232,   232,   233,   233,   234,   234,   234,
     234,   234,   234,   234,   234,   234,   234,   235,   236,   236,
     237,   238,   239,   240,   241,   241,   243,   242,   244,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   252,   252,
     252,   253,   253,   253,   253,   254,   254,   255,   255,   257,
     256,   259,   260,   261,   258,   262,   262,   262,   263,   265,
     266,   267,   264,   268,   264,   269,   270,   271,   271,   272,
     273,   274,   275,   275,   276,   276,   277,   277,   278,   278,
     279,   279,   280,   281,   282,   282,   282,   282,   283,   284,
     285,   286,   287,   289,   288,   290,   290,   291,   292,   293,
     293,   294,   295,   296,   296,   296,   297,   298,   298,   299,
     300,   301,   302,   303,   303,   304,   304,   305,   305,   306,
     307,   307,   308,   308,   309,   309,   310,   310,   311,   311,
     312,   312,   313,   314,   315,   315,   316,   317,   318,   318,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   320,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   321,   322,   323,   324,
     325,   325,   326,   326,   326,   326,   326,   326,   326,   326,
     326,   326,   326,   327,   327,   328,   329,   329,   329,   330,
     331,   331,   331,   332,   332,   332,   332,   332,   332,   332,
     332,   333,   333,   334,   334,   334,   334,   335,   335,   335,
     335,   335,   335,   335,   335,   335,   335,   335,   335,   335,
     335,   335,   335,   335,   335,   335,   335,   335,   335,   335,
     335,   335,   335,   335,   335,   335,   335,   335,   335,   335,
     335,   335,   335,   335,   335,   335,   335,   335,   335,   335,
     335,   335,   335,   336,   336,   337,   337,   337,   337,   338,
     338,   339,   340,   340,   341,   342,   342,   343,   344,   345,
     345,   346,   347,   348,   349,   349,   350,   350,   350,   351,
     351,   352,   352,   353,   353,   354,   354,   354,   354,   355,
     355,   356,   356,   356,   356,   356,   356,   356,   356,   357,
     357,   358,   358,   359,   359,   360,   361,   362,   362,   363,
     363,   363,   364,   364,   365,   366,   366,   367,   368,   369,
     370,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   381,   382,   383,   384,   385,   386,   387,
     387,   388,   388,   389,   390,   390,   391,   392,   392,   393,
     393,   394,   394,   395,   395,   396,   396,   397,   397,   398,
     398,   399,   399,   400,   400,   401,   401,   402,   402,   402,
     402,   403,   403,   403,   403,   403,   403,   403,   403,   404,
     404,   404,   404,   405,   405,   405,   405,   406,   406,   406,
     406,   407,   407,   408,   408
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     0,     2,     1,     1,     1,     2,     2,
       2,     1,     2,     1,     0,     3,     0,     4,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     2,     1,
       0,     3,     0,     3,     1,     1,     1,     1,     0,     1,
       1,     2,     2,     3,     3,     0,     3,     0,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     3,     3,
       3,     3,     3,     3,     2,     4,     0,     3,     1,     2,
       1,     1,     1,     1,     1,     2,     2,     0,     2,     2,
       2,     3,     5,     3,     5,     1,     2,     7,     1,     0,
       5,     0,     0,     0,     9,     1,     3,     5,     3,     0,
       0,     0,     7,     0,     6,     2,     1,     0,     1,     1,
       1,     1,     2,     5,     1,     3,     1,     3,     1,     3,
       1,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     0,     4,     1,     3,     1,     3,     1,
       3,     1,     4,     2,     4,     6,     4,     2,     4,     2,
       1,     1,     3,     1,     3,     1,     3,     1,     1,     1,
       1,     3,     1,     1,     1,     3,     1,     1,     1,     3,
       1,     1,     1,     1,     2,     2,     1,     1,     1,     1,
       1,     1,     2,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     2,     2,     2,     4,     4,     4,     4,
       4,     4,     4,     0,     5,     5,     5,     5,     7,     7,
       7,     7,     7,     5,     5,     5,     5,     5,     5,     7,
       6,     6,     6,     4,     4,     3,     1,     1,     1,     1,
       0,     2,     1,     8,     6,     6,     3,     4,     4,     4,
       8,     4,     4,     1,     3,     2,     0,     3,     3,     7,
       0,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     0,     3,     0,     6,     8,     6,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     2,     2,     2,     4,     4,     2,
       2,     4,     2,     4,     1,     2,     2,     1,     1,     2,
       2,     1,     1,     1,     2,     2,     2,     4,     2,     2,
       4,     6,     6,     6,     6,     4,     4,     4,     4,     3,
       5,     1,     1,     1,     1,     1,     1,     1,     1,     5,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     1,     2,     2,     2,     2,     4,
       1,     2,     1,     2,     1,     2,     1,     2,     1,     2,
       1,     2,     2,     2,     1,     4,     2,     2,     2,     1,
       2,     2,     2,     2,     2,     2,     3,     1,     3,     1,
       3,     1,     4,     1,     4,     1,     4,     1,     4,     1,
       4,     1,     4,     1,     4,     1,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     3,     1,
       1,     3,     4,     3,     4
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        YY_LAC_DISCARD ("YYBACKUP");                              \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Given a state stack such that *YYBOTTOM is its bottom, such that
   *YYTOP is either its top or is YYTOP_EMPTY to indicate an empty
   stack, and such that *YYCAPACITY is the maximum number of elements it
   can hold without a reallocation, make sure there is enough room to
   store YYADD more elements.  If not, allocate a new stack using
   YYSTACK_ALLOC, copy the existing elements, and adjust *YYBOTTOM,
   *YYTOP, and *YYCAPACITY to reflect the new capacity and memory
   location.  If *YYBOTTOM != YYBOTTOM_NO_FREE, then free the old stack
   using YYSTACK_FREE.  Return 0 if successful or if no reallocation is
   required.  Return YYENOMEM if memory is exhausted.  */
static int
yy_lac_stack_realloc (YYPTRDIFF_T *yycapacity, YYPTRDIFF_T yyadd,
#if YYDEBUG
                      char const *yydebug_prefix,
                      char const *yydebug_suffix,
#endif
                      yy_state_t **yybottom,
                      yy_state_t *yybottom_no_free,
                      yy_state_t **yytop, yy_state_t *yytop_empty)
{
  YYPTRDIFF_T yysize_old =
    *yytop == yytop_empty ? 0 : *yytop - *yybottom + 1;
  YYPTRDIFF_T yysize_new = yysize_old + yyadd;
  if (*yycapacity < yysize_new)
    {
      YYPTRDIFF_T yyalloc = 2 * yysize_new;
      yy_state_t *yybottom_new;
      /* Use YYMAXDEPTH for maximum stack size given that the stack
         should never need to grow larger than the main state stack
         needs to grow without LAC.  */
      if (YYMAXDEPTH < yysize_new)
        {
          YYDPRINTF ((stderr, "%smax size exceeded%s", yydebug_prefix,
                      yydebug_suffix));
          return YYENOMEM;
        }
      if (YYMAXDEPTH < yyalloc)
        yyalloc = YYMAXDEPTH;
      yybottom_new =
        YY_CAST (yy_state_t *,
                 YYSTACK_ALLOC (YY_CAST (YYSIZE_T,
                                         yyalloc * YYSIZEOF (*yybottom_new))));
      if (!yybottom_new)
        {
          YYDPRINTF ((stderr, "%srealloc failed%s", yydebug_prefix,
                      yydebug_suffix));
          return YYENOMEM;
        }
      if (*yytop != yytop_empty)
        {
          YYCOPY (yybottom_new, *yybottom, yysize_old);
          *yytop = yybottom_new + (yysize_old - 1);
        }
      if (*yybottom != yybottom_no_free)
        YYSTACK_FREE (*yybottom);
      *yybottom = yybottom_new;
      *yycapacity = yyalloc;
    }
  return 0;
}

/* Establish the initial context for the current lookahead if no initial
   context is currently established.

   We define a context as a snapshot of the parser stacks.  We define
   the initial context for a lookahead as the context in which the
   parser initially examines that lookahead in order to select a
   syntactic action.  Thus, if the lookahead eventually proves
   syntactically unacceptable (possibly in a later context reached via a
   series of reductions), the initial context can be used to determine
   the exact set of tokens that would be syntactically acceptable in the
   lookahead's place.  Moreover, it is the context after which any
   further semantic actions would be erroneous because they would be
   determined by a syntactically unacceptable token.

   YY_LAC_ESTABLISH should be invoked when a reduction is about to be
   performed in an inconsistent state (which, for the purposes of LAC,
   includes consistent states that don't know they're consistent because
   their default reductions have been disabled).  Iff there is a
   lookahead token, it should also be invoked before reporting a syntax
   error.  This latter case is for the sake of the debugging output.

   For parse.lac=full, the implementation of YY_LAC_ESTABLISH is as
   follows.  If no initial context is currently established for the
   current lookahead, then check if that lookahead can eventually be
   shifted if syntactic actions continue from the current context.
   Report a syntax error if it cannot.  */
#define YY_LAC_ESTABLISH                                                \
do {                                                                    \
  if (!yy_lac_established)                                              \
    {                                                                   \
      YYDPRINTF ((stderr,                                               \
                  "LAC: initial context established for %s\n",          \
                  yysymbol_name (yytoken)));                            \
      yy_lac_established = 1;                                           \
      switch (yy_lac (yyesa, &yyes, &yyes_capacity, yyssp, yytoken))    \
        {                                                               \
        case YYENOMEM:                                                  \
          YYNOMEM;                                                      \
        case 1:                                                         \
          goto yyerrlab;                                                \
        }                                                               \
    }                                                                   \
} while (0)

/* Discard any previous initial lookahead context because of Event,
   which may be a lookahead change or an invalidation of the currently
   established initial context for the current lookahead.

   The most common example of a lookahead change is a shift.  An example
   of both cases is syntax error recovery.  That is, a syntax error
   occurs when the lookahead is syntactically erroneous for the
   currently established initial context, so error recovery manipulates
   the parser stacks to try to find a new initial context in which the
   current lookahead is syntactically acceptable.  If it fails to find
   such a context, it discards the lookahead.  */
#if YYDEBUG
# define YY_LAC_DISCARD(Event)                                           \
do {                                                                     \
  if (yy_lac_established)                                                \
    {                                                                    \
      YYDPRINTF ((stderr, "LAC: initial context discarded due to "       \
                  Event "\n"));                                          \
      yy_lac_established = 0;                                            \
    }                                                                    \
} while (0)
#else
# define YY_LAC_DISCARD(Event) yy_lac_established = 0
#endif

/* Given the stack whose top is *YYSSP, return 0 iff YYTOKEN can
   eventually (after perhaps some reductions) be shifted, return 1 if
   not, or return YYENOMEM if memory is exhausted.  As preconditions and
   postconditions: *YYES_CAPACITY is the allocated size of the array to
   which *YYES points, and either *YYES = YYESA or *YYES points to an
   array allocated with YYSTACK_ALLOC.  yy_lac may overwrite the
   contents of either array, alter *YYES and *YYES_CAPACITY, and free
   any old *YYES other than YYESA.  */
static int
yy_lac (yy_state_t *yyesa, yy_state_t **yyes,
        YYPTRDIFF_T *yyes_capacity, yy_state_t *yyssp, yysymbol_kind_t yytoken)
{
  yy_state_t *yyes_prev = yyssp;
  yy_state_t *yyesp = yyes_prev;
  /* Reduce until we encounter a shift and thereby accept the token.  */
  YYDPRINTF ((stderr, "LAC: checking lookahead %s:", yysymbol_name (yytoken)));
  if (yytoken == YYSYMBOL_YYUNDEF)
    {
      YYDPRINTF ((stderr, " Always Err\n"));
      return 1;
    }
  while (1)
    {
      int yyrule = yypact[+*yyesp];
      if (yypact_value_is_default (yyrule)
          || (yyrule += yytoken) < 0 || YYLAST < yyrule
          || yycheck[yyrule] != yytoken)
        {
          /* Use the default action.  */
          yyrule = yydefact[+*yyesp];
          if (yyrule == 0)
            {
              YYDPRINTF ((stderr, " Err\n"));
              return 1;
            }
        }
      else
        {
          /* Use the action from yytable.  */
          yyrule = yytable[yyrule];
          if (yytable_value_is_error (yyrule))
            {
              YYDPRINTF ((stderr, " Err\n"));
              return 1;
            }
          if (0 < yyrule)
            {
              YYDPRINTF ((stderr, " S%d\n", yyrule));
              return 0;
            }
          yyrule = -yyrule;
        }
      /* By now we know we have to simulate a reduce.  */
      YYDPRINTF ((stderr, " R%d", yyrule - 1));
      {
        /* Pop the corresponding number of values from the stack.  */
        YYPTRDIFF_T yylen = yyr2[yyrule];
        /* First pop from the LAC stack as many tokens as possible.  */
        if (yyesp != yyes_prev)
          {
            YYPTRDIFF_T yysize = yyesp - *yyes + 1;
            if (yylen < yysize)
              {
                yyesp -= yylen;
                yylen = 0;
              }
            else
              {
                yyesp = yyes_prev;
                yylen -= yysize;
              }
          }
        /* Only afterwards look at the main stack.  */
        if (yylen)
          yyesp = yyes_prev -= yylen;
      }
      /* Push the resulting state of the reduction.  */
      {
        yy_state_fast_t yystate;
        {
          const int yylhs = yyr1[yyrule] - YYNTOKENS;
          const int yyi = yypgoto[yylhs] + *yyesp;
          yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyesp
                     ? yytable[yyi]
                     : yydefgoto[yylhs]);
        }
        if (yyesp == yyes_prev)
          {
            yyesp = *yyes;
            YY_IGNORE_USELESS_CAST_BEGIN
            *yyesp = YY_CAST (yy_state_t, yystate);
            YY_IGNORE_USELESS_CAST_END
          }
        else
          {
            if (yy_lac_stack_realloc (yyes_capacity, 1,
#if YYDEBUG
                                      " (", ")",
#endif
                                      yyes, yyesa, &yyesp, yyes_prev))
              {
                YYDPRINTF ((stderr, "\n"));
                return YYENOMEM;
              }
            YY_IGNORE_USELESS_CAST_BEGIN
            *++yyesp = YY_CAST (yy_state_t, yystate);
            YY_IGNORE_USELESS_CAST_END
          }
        YYDPRINTF ((stderr, " G%d", yystate));
      }
    }
}

/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yy_state_t *yyesa;
  yy_state_t **yyes;
  YYPTRDIFF_T *yyes_capacity;
  yysymbol_kind_t yytoken;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;

  int yyx;
  for (yyx = 0; yyx < YYNTOKENS; ++yyx)
    {
      yysymbol_kind_t yysym = YY_CAST (yysymbol_kind_t, yyx);
      if (yysym != YYSYMBOL_YYerror && yysym != YYSYMBOL_YYUNDEF)
        switch (yy_lac (yyctx->yyesa, yyctx->yyes, yyctx->yyes_capacity, yyctx->yyssp, yysym))
          {
          case YYENOMEM:
            return YYENOMEM;
          case 1:
            continue;
          default:
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = yysym;
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif



static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
       In the first two cases, it might appear that the current syntax
       error should have been detected in the previous state when yy_lac
       was invoked.  However, at that time, there might have been a
       different syntax error that discarded a different initial context
       during error recovery, leaving behind the current lookahead.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      YYDPRINTF ((stderr, "Constructing syntax error message\n"));
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else if (yyn == 0)
        YYDPRINTF ((stderr, "No expected tokens.\n"));
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.  In order to see if a particular token T is a
   valid looakhead, invoke yy_lac (YYESA, YYES, YYES_CAPACITY, YYSSP, T).

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store or if
   yy_lac returned YYENOMEM.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yystrlen (yysymbol_name (yyarg[yyi]));
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp = yystpcpy (yyp, yysymbol_name (yyarg[yyi++]));
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    yy_state_t yyesa[20];
    yy_state_t *yyes = yyesa;
    YYPTRDIFF_T yyes_capacity = 20 < YYMAXDEPTH ? 20 : YYMAXDEPTH;

  /* Whether LAC context is established.  A Boolean.  */
  int yy_lac_established = 0;
  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= T_EOF)
    {
      yychar = T_EOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    {
      YY_LAC_ESTABLISH;
      goto yydefault;
    }
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      YY_LAC_ESTABLISH;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  YY_LAC_DISCARD ("shift");
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  {
    int yychar_backup = yychar;
    switch (yyn)
      {
  case 14: /* $@1: %empty  */
#line 709 "src/asm/parser.y"
                        {
			lexer_SetMode(LEXER_NORMAL);
			lexer_ToggleStringExpansion(true);
		}
#line 3359 "src/asm/parser.c"
    break;

  case 15: /* line: error $@1 endofline  */
#line 712 "src/asm/parser.y"
                            {
			fstk_StopRept();
			yyerrok;
		}
#line 3368 "src/asm/parser.c"
    break;

  case 16: /* $@2: %empty  */
#line 717 "src/asm/parser.y"
                                {
			lexer_SetMode(LEXER_NORMAL);
			lexer_ToggleStringExpansion(true);
		}
#line 3377 "src/asm/parser.c"
    break;

  case 17: /* line: "label" error $@2 endofline  */
#line 720 "src/asm/parser.y"
                            {
			struct Symbol *macro = sym_FindExactSymbol((yyvsp[-3].symName));

			if (macro && macro->type == SYM_MACRO)
				fprintf(stderr,
					"    To invoke `%s` as a macro it must be indented\n", (yyvsp[-3].symName));
			fstk_StopRept();
			yyerrok;
		}
#line 3391 "src/asm/parser.c"
    break;

  case 26: /* if: "IF" const "newline"  */
#line 746 "src/asm/parser.y"
                                           {
			lexer_IncIFDepth();

			if ((yyvsp[-1].constValue))
				lexer_RunIFBlock();
			else
				lexer_SetMode(LEXER_SKIP_TO_ELIF);
		}
#line 3404 "src/asm/parser.c"
    break;

  case 27: /* elif: "ELIF" const "newline"  */
#line 756 "src/asm/parser.y"
                                             {
			if (lexer_GetIFDepth() == 0)
				fatalerror("Found ELIF outside an IF construct\n");

			if (lexer_RanIFBlock()) {
				if (lexer_ReachedELSEBlock())
					fatalerror("Found ELIF after an ELSE block\n");

				lexer_SetMode(LEXER_SKIP_TO_ENDC);
			} else if ((yyvsp[-1].constValue)) {
				lexer_RunIFBlock();
			} else {
				lexer_SetMode(LEXER_SKIP_TO_ELIF);
			}
		}
#line 3424 "src/asm/parser.c"
    break;

  case 28: /* else: "ELSE" "newline"  */
#line 773 "src/asm/parser.y"
                                       {
			if (lexer_GetIFDepth() == 0)
				fatalerror("Found ELSE outside an IF construct\n");

			if (lexer_RanIFBlock()) {
				if (lexer_ReachedELSEBlock())
					fatalerror("Found ELSE after an ELSE block\n");

				lexer_SetMode(LEXER_SKIP_TO_ENDC);
			} else {
				lexer_RunIFBlock();
				lexer_ReachELSEBlock();
			}
		}
#line 3443 "src/asm/parser.c"
    break;

  case 29: /* endc: "ENDC"  */
#line 789 "src/asm/parser.y"
                             {
			lexer_DecIFDepth();
		}
#line 3451 "src/asm/parser.c"
    break;

  case 30: /* $@3: %empty  */
#line 794 "src/asm/parser.y"
                           {
			lexer_ToggleStringExpansion(false);
		}
#line 3459 "src/asm/parser.c"
    break;

  case 31: /* def_id: "DEF" $@3 "identifier"  */
#line 796 "src/asm/parser.y"
                       {
			lexer_ToggleStringExpansion(true);
			strcpy((yyval.symName), (yyvsp[0].symName));
		}
#line 3468 "src/asm/parser.c"
    break;

  case 32: /* $@4: %empty  */
#line 802 "src/asm/parser.y"
                              {
			lexer_ToggleStringExpansion(false);
		}
#line 3476 "src/asm/parser.c"
    break;

  case 33: /* redef_id: "REDEF" $@4 "identifier"  */
#line 804 "src/asm/parser.y"
                       {
			lexer_ToggleStringExpansion(true);
			strcpy((yyval.symName), (yyvsp[0].symName));
		}
#line 3485 "src/asm/parser.c"
    break;

  case 39: /* label: ":"  */
#line 814 "src/asm/parser.y"
                          {
			sym_AddAnonLabel();
		}
#line 3493 "src/asm/parser.c"
    break;

  case 40: /* label: "local identifier"  */
#line 817 "src/asm/parser.y"
                             {
			sym_AddLocalLabel((yyvsp[0].symName));
		}
#line 3501 "src/asm/parser.c"
    break;

  case 41: /* label: "local identifier" ":"  */
#line 820 "src/asm/parser.y"
                                     {
			sym_AddLocalLabel((yyvsp[-1].symName));
		}
#line 3509 "src/asm/parser.c"
    break;

  case 42: /* label: "label" ":"  */
#line 823 "src/asm/parser.y"
                                  {
			sym_AddLabel((yyvsp[-1].symName));
		}
#line 3517 "src/asm/parser.c"
    break;

  case 43: /* label: "local identifier" ":" ":"  */
#line 826 "src/asm/parser.y"
                                             {
			sym_AddLocalLabel((yyvsp[-2].symName));
			sym_Export((yyvsp[-2].symName));
		}
#line 3526 "src/asm/parser.c"
    break;

  case 44: /* label: "label" ":" ":"  */
#line 830 "src/asm/parser.y"
                                          {
			sym_AddLabel((yyvsp[-2].symName));
			sym_Export((yyvsp[-2].symName));
		}
#line 3535 "src/asm/parser.c"
    break;

  case 45: /* $@5: %empty  */
#line 836 "src/asm/parser.y"
                       {
			// Parsing 'macroargs' will restore the lexer's normal mode
			lexer_SetMode(LEXER_RAW);
		}
#line 3544 "src/asm/parser.c"
    break;

  case 46: /* macro: "identifier" $@5 macroargs  */
#line 839 "src/asm/parser.y"
                            {
			fstk_RunMacro((yyvsp[-2].symName), (yyvsp[0].macroArg));
		}
#line 3552 "src/asm/parser.c"
    break;

  case 47: /* macroargs: %empty  */
#line 844 "src/asm/parser.y"
                         {
			(yyval.macroArg) = macro_NewArgs();
		}
#line 3560 "src/asm/parser.c"
    break;

  case 48: /* macroargs: macroargs "string"  */
#line 847 "src/asm/parser.y"
                                     {
			macro_AppendArg(&((yyval.macroArg)), strdup((yyvsp[0].string)));
		}
#line 3568 "src/asm/parser.c"
    break;

  case 97: /* compoundeq: "+="  */
#line 906 "src/asm/parser.y"
                              { (yyval.compoundEqual) = RPN_ADD; }
#line 3574 "src/asm/parser.c"
    break;

  case 98: /* compoundeq: "-="  */
#line 907 "src/asm/parser.y"
                              { (yyval.compoundEqual) = RPN_SUB; }
#line 3580 "src/asm/parser.c"
    break;

  case 99: /* compoundeq: "*="  */
#line 908 "src/asm/parser.y"
                              { (yyval.compoundEqual) = RPN_MUL; }
#line 3586 "src/asm/parser.c"
    break;

  case 100: /* compoundeq: "/="  */
#line 909 "src/asm/parser.y"
                              { (yyval.compoundEqual) = RPN_DIV; }
#line 3592 "src/asm/parser.c"
    break;

  case 101: /* compoundeq: "%="  */
#line 910 "src/asm/parser.y"
                              { (yyval.compoundEqual) = RPN_MOD; }
#line 3598 "src/asm/parser.c"
    break;

  case 102: /* compoundeq: "^="  */
#line 911 "src/asm/parser.y"
                              { (yyval.compoundEqual) = RPN_XOR; }
#line 3604 "src/asm/parser.c"
    break;

  case 103: /* compoundeq: "|="  */
#line 912 "src/asm/parser.y"
                             { (yyval.compoundEqual) = RPN_OR; }
#line 3610 "src/asm/parser.c"
    break;

  case 104: /* compoundeq: "&="  */
#line 913 "src/asm/parser.y"
                              { (yyval.compoundEqual) = RPN_AND; }
#line 3616 "src/asm/parser.c"
    break;

  case 105: /* compoundeq: "<<="  */
#line 914 "src/asm/parser.y"
                              { (yyval.compoundEqual) = RPN_SHL; }
#line 3622 "src/asm/parser.c"
    break;

  case 106: /* compoundeq: ">>="  */
#line 915 "src/asm/parser.y"
                              { (yyval.compoundEqual) = RPN_SHR; }
#line 3628 "src/asm/parser.c"
    break;

  case 107: /* equ: "label" "EQU" const  */
#line 918 "src/asm/parser.y"
                                          { sym_AddEqu((yyvsp[-2].symName), (yyvsp[0].constValue)); }
#line 3634 "src/asm/parser.c"
    break;

  case 108: /* assignment: "label" "=" const  */
#line 921 "src/asm/parser.y"
                                            { sym_AddVar((yyvsp[-2].symName), (yyvsp[0].constValue)); }
#line 3640 "src/asm/parser.c"
    break;

  case 109: /* assignment: "label" compoundeq const  */
#line 922 "src/asm/parser.y"
                                           { compoundAssignment((yyvsp[-2].symName), (yyvsp[-1].compoundEqual), (yyvsp[0].constValue)); }
#line 3646 "src/asm/parser.c"
    break;

  case 110: /* equs: "label" "EQUS" string  */
#line 925 "src/asm/parser.y"
                                            { sym_AddString((yyvsp[-2].symName), (yyvsp[0].string)); }
#line 3652 "src/asm/parser.c"
    break;

  case 111: /* rb: "label" "RB" rs_uconst  */
#line 928 "src/asm/parser.y"
                                             {
			sym_AddEqu((yyvsp[-2].symName), sym_GetConstantValue("_RS"));
			sym_AddVar("_RS", sym_GetConstantValue("_RS") + (yyvsp[0].constValue));
		}
#line 3661 "src/asm/parser.c"
    break;

  case 112: /* rw: "label" "RW" rs_uconst  */
#line 934 "src/asm/parser.y"
                                             {
			sym_AddEqu((yyvsp[-2].symName), sym_GetConstantValue("_RS"));
			sym_AddVar("_RS", sym_GetConstantValue("_RS") + 2 * (yyvsp[0].constValue));
		}
#line 3670 "src/asm/parser.c"
    break;

  case 113: /* rl: "label" "rl" rs_uconst  */
#line 940 "src/asm/parser.y"
                                             {
			sym_AddEqu((yyvsp[-2].symName), sym_GetConstantValue("_RS"));
			sym_AddVar("_RS", sym_GetConstantValue("_RS") + 4 * (yyvsp[0].constValue));
		}
#line 3679 "src/asm/parser.c"
    break;

  case 114: /* align: "ALIGN" uconst  */
#line 946 "src/asm/parser.y"
                                    {
			if ((yyvsp[0].constValue) > 16)
				error("Alignment must be between 0 and 16, not %u\n", (yyvsp[0].constValue));
			else
				sect_AlignPC((yyvsp[0].constValue), 0);
		}
#line 3690 "src/asm/parser.c"
    break;

  case 115: /* align: "ALIGN" uconst "," uconst  */
#line 952 "src/asm/parser.y"
                                                   {
			if ((yyvsp[-2].constValue) > 16)
				error("Alignment must be between 0 and 16, not %u\n", (yyvsp[-2].constValue));
			else if ((yyvsp[0].constValue) >= 1 << (yyvsp[-2].constValue))
				error("Offset must be between 0 and %u, not %u\n",
					(1 << (yyvsp[-2].constValue)) - 1, (yyvsp[0].constValue));
			else
				sect_AlignPC((yyvsp[-2].constValue), (yyvsp[0].constValue));
		}
#line 3704 "src/asm/parser.c"
    break;

  case 116: /* $@6: %empty  */
#line 963 "src/asm/parser.y"
                            {
			// Parsing 'opt_list' will restore the lexer's normal mode
			lexer_SetMode(LEXER_RAW);
		}
#line 3713 "src/asm/parser.c"
    break;

  case 120: /* opt_list_entry: "string"  */
#line 973 "src/asm/parser.y"
                           { opt_Parse((yyvsp[0].string)); }
#line 3719 "src/asm/parser.c"
    break;

  case 121: /* popo: "POPO"  */
#line 976 "src/asm/parser.y"
                             { opt_Pop(); }
#line 3725 "src/asm/parser.c"
    break;

  case 122: /* pusho: "PUSHO"  */
#line 979 "src/asm/parser.y"
                              { opt_Push(); }
#line 3731 "src/asm/parser.c"
    break;

  case 123: /* pops: "POPS"  */
#line 982 "src/asm/parser.y"
                             { sect_PopSection(); }
#line 3737 "src/asm/parser.c"
    break;

  case 124: /* pushs: "PUSHS"  */
#line 985 "src/asm/parser.y"
                              { sect_PushSection(); }
#line 3743 "src/asm/parser.c"
    break;

  case 125: /* fail: "FAIL" string  */
#line 988 "src/asm/parser.y"
                                    { fatalerror("%s\n", (yyvsp[0].string)); }
#line 3749 "src/asm/parser.c"
    break;

  case 126: /* warn: "WARN" string  */
#line 991 "src/asm/parser.y"
                                    { warning(WARNING_USER, "%s\n", (yyvsp[0].string)); }
#line 3755 "src/asm/parser.c"
    break;

  case 127: /* assert_type: %empty  */
#line 994 "src/asm/parser.y"
                         { (yyval.assertType) = ASSERT_ERROR; }
#line 3761 "src/asm/parser.c"
    break;

  case 128: /* assert_type: "WARN" ","  */
#line 995 "src/asm/parser.y"
                                     { (yyval.assertType) = ASSERT_WARN; }
#line 3767 "src/asm/parser.c"
    break;

  case 129: /* assert_type: "FAIL" ","  */
#line 996 "src/asm/parser.y"
                                     { (yyval.assertType) = ASSERT_ERROR; }
#line 3773 "src/asm/parser.c"
    break;

  case 130: /* assert_type: "FATAL" ","  */
#line 997 "src/asm/parser.y"
                                      { (yyval.assertType) = ASSERT_FATAL; }
#line 3779 "src/asm/parser.c"
    break;

  case 131: /* assert: "ASSERT" assert_type relocexpr  */
#line 1000 "src/asm/parser.y"
                                                     {
			if (!rpn_isKnown(&(yyvsp[0].expr))) {
				if (!out_CreateAssert((yyvsp[-1].assertType), &(yyvsp[0].expr), "",
						      sect_GetOutputOffset()))
					error("Assertion creation failed: %s\n",
						strerror(errno));
			} else if ((yyvsp[0].expr).val == 0) {
				failAssert((yyvsp[-1].assertType));
			}
			rpn_Free(&(yyvsp[0].expr));
		}
#line 3795 "src/asm/parser.c"
    break;

  case 132: /* assert: "ASSERT" assert_type relocexpr "," string  */
#line 1011 "src/asm/parser.y"
                                                                    {
			if (!rpn_isKnown(&(yyvsp[-2].expr))) {
				if (!out_CreateAssert((yyvsp[-3].assertType), &(yyvsp[-2].expr), (yyvsp[0].string),
						      sect_GetOutputOffset()))
					error("Assertion creation failed: %s\n",
						strerror(errno));
			} else if ((yyvsp[-2].expr).val == 0) {
				failAssertMsg((yyvsp[-3].assertType), (yyvsp[0].string));
			}
			rpn_Free(&(yyvsp[-2].expr));
		}
#line 3811 "src/asm/parser.c"
    break;

  case 133: /* assert: "STATIC_ASSERT" assert_type const  */
#line 1022 "src/asm/parser.y"
                                                        {
			if ((yyvsp[0].constValue) == 0)
				failAssert((yyvsp[-1].assertType));
		}
#line 3820 "src/asm/parser.c"
    break;

  case 134: /* assert: "STATIC_ASSERT" assert_type const "," string  */
#line 1026 "src/asm/parser.y"
                                                                       {
			if ((yyvsp[-2].constValue) == 0)
				failAssertMsg((yyvsp[-3].assertType), (yyvsp[0].string));
		}
#line 3829 "src/asm/parser.c"
    break;

  case 135: /* shift: "SHIFT"  */
#line 1032 "src/asm/parser.y"
                              { macro_ShiftCurrentArgs(1); }
#line 3835 "src/asm/parser.c"
    break;

  case 136: /* shift: "SHIFT" const  */
#line 1033 "src/asm/parser.y"
                                    { macro_ShiftCurrentArgs((yyvsp[0].constValue)); }
#line 3841 "src/asm/parser.c"
    break;

  case 137: /* load: "LOAD" sectmod string "," sectiontype sectorg sectattrs  */
#line 1036 "src/asm/parser.y"
                                                                                  {
			sect_SetLoadSection((yyvsp[-4].string), (yyvsp[-2].constValue), (yyvsp[-1].constValue), &(yyvsp[0].sectSpec), (yyvsp[-5].sectMod));
		}
#line 3849 "src/asm/parser.c"
    break;

  case 138: /* load: "ENDL"  */
#line 1039 "src/asm/parser.y"
                             { sect_EndLoadSection(); }
#line 3855 "src/asm/parser.c"
    break;

  case 139: /* @7: %empty  */
#line 1042 "src/asm/parser.y"
                                              {
			(yyval.captureTerminated) = lexer_CaptureRept(&captureBody);
		}
#line 3863 "src/asm/parser.c"
    break;

  case 140: /* rept: "REPT" uconst "newline" @7 endofline  */
#line 1044 "src/asm/parser.y"
                            {
			if ((yyvsp[-1].captureTerminated))
				fstk_RunRept((yyvsp[-3].constValue), captureBody.lineNo, captureBody.body,
					     captureBody.size);
		}
#line 3873 "src/asm/parser.c"
    break;

  case 141: /* $@8: %empty  */
#line 1051 "src/asm/parser.y"
                            {
			lexer_ToggleStringExpansion(false);
		}
#line 3881 "src/asm/parser.c"
    break;

  case 142: /* $@9: %empty  */
#line 1053 "src/asm/parser.y"
                       {
			lexer_ToggleStringExpansion(true);
		}
#line 3889 "src/asm/parser.c"
    break;

  case 143: /* @10: %empty  */
#line 1055 "src/asm/parser.y"
                                             {
			(yyval.captureTerminated) = lexer_CaptureRept(&captureBody);
		}
#line 3897 "src/asm/parser.c"
    break;

  case 144: /* for: "FOR" $@8 "identifier" $@9 "," for_args "newline" @10 endofline  */
#line 1057 "src/asm/parser.y"
                            {
			if ((yyvsp[-1].captureTerminated))
				fstk_RunFor((yyvsp[-6].symName), (yyvsp[-3].forArgs).start, (yyvsp[-3].forArgs).stop, (yyvsp[-3].forArgs).step, captureBody.lineNo,
					    captureBody.body, captureBody.size);
		}
#line 3907 "src/asm/parser.c"
    break;

  case 145: /* for_args: const  */
#line 1063 "src/asm/parser.y"
                        {
			(yyval.forArgs).start = 0;
			(yyval.forArgs).stop = (yyvsp[0].constValue);
			(yyval.forArgs).step = 1;
		}
#line 3917 "src/asm/parser.c"
    break;

  case 146: /* for_args: const "," const  */
#line 1068 "src/asm/parser.y"
                                      {
			(yyval.forArgs).start = (yyvsp[-2].constValue);
			(yyval.forArgs).stop = (yyvsp[0].constValue);
			(yyval.forArgs).step = 1;
		}
#line 3927 "src/asm/parser.c"
    break;

  case 147: /* for_args: const "," const "," const  */
#line 1073 "src/asm/parser.y"
                                                    {
			(yyval.forArgs).start = (yyvsp[-4].constValue);
			(yyval.forArgs).stop = (yyvsp[-2].constValue);
			(yyval.forArgs).step = (yyvsp[0].constValue);
		}
#line 3937 "src/asm/parser.c"
    break;

  case 148: /* break: label "BREAK" endofline  */
#line 1080 "src/asm/parser.y"
                                              {
			if (fstk_Break())
				lexer_SetMode(LEXER_SKIP_TO_ENDR);
		}
#line 3946 "src/asm/parser.c"
    break;

  case 149: /* $@11: %empty  */
#line 1086 "src/asm/parser.y"
                              {
			lexer_ToggleStringExpansion(false);
		}
#line 3954 "src/asm/parser.c"
    break;

  case 150: /* $@12: %empty  */
#line 1088 "src/asm/parser.y"
                       {
			lexer_ToggleStringExpansion(true);
		}
#line 3962 "src/asm/parser.c"
    break;

  case 151: /* @13: %empty  */
#line 1090 "src/asm/parser.y"
                            {
			(yyval.captureTerminated) = lexer_CaptureMacroBody(&captureBody);
		}
#line 3970 "src/asm/parser.c"
    break;

  case 152: /* macrodef: "MACRO" $@11 "identifier" $@12 "newline" @13 endofline  */
#line 1092 "src/asm/parser.y"
                            {
			if ((yyvsp[-1].captureTerminated))
				sym_AddMacro((yyvsp[-4].symName), captureBody.lineNo, captureBody.body,
					     captureBody.size);
		}
#line 3980 "src/asm/parser.c"
    break;

  case 153: /* @14: %empty  */
#line 1097 "src/asm/parser.y"
                                                        {
			warning(WARNING_OBSOLETE, "`%s: MACRO` is deprecated; use `MACRO %s`\n", (yyvsp[-3].symName), (yyvsp[-3].symName));
			(yyval.captureTerminated) = lexer_CaptureMacroBody(&captureBody);
		}
#line 3989 "src/asm/parser.c"
    break;

  case 154: /* macrodef: "label" ":" "MACRO" "newline" @14 endofline  */
#line 1100 "src/asm/parser.y"
                            {
			if ((yyvsp[-1].captureTerminated))
				sym_AddMacro((yyvsp[-5].symName), captureBody.lineNo, captureBody.body,
					     captureBody.size);
		}
#line 3999 "src/asm/parser.c"
    break;

  case 155: /* rsset: "RSSET" uconst  */
#line 1107 "src/asm/parser.y"
                                     { sym_AddVar("_RS", (yyvsp[0].constValue)); }
#line 4005 "src/asm/parser.c"
    break;

  case 156: /* rsreset: "RSRESET"  */
#line 1110 "src/asm/parser.y"
                                { sym_AddVar("_RS", 0); }
#line 4011 "src/asm/parser.c"
    break;

  case 157: /* rs_uconst: %empty  */
#line 1113 "src/asm/parser.y"
                         { (yyval.constValue) = 1; }
#line 4017 "src/asm/parser.c"
    break;

  case 159: /* union: "UNION"  */
#line 1117 "src/asm/parser.y"
                              { sect_StartUnion(); }
#line 4023 "src/asm/parser.c"
    break;

  case 160: /* nextu: "NEXTU"  */
#line 1120 "src/asm/parser.y"
                              { sect_NextUnionMember(); }
#line 4029 "src/asm/parser.c"
    break;

  case 161: /* endu: "ENDU"  */
#line 1123 "src/asm/parser.y"
                             { sect_EndUnion(); }
#line 4035 "src/asm/parser.c"
    break;

  case 162: /* ds: "DS" uconst  */
#line 1126 "src/asm/parser.y"
                                  { sect_Skip((yyvsp[0].constValue), true); }
#line 4041 "src/asm/parser.c"
    break;

  case 163: /* ds: "DS" uconst "," ds_args trailing_comma  */
#line 1127 "src/asm/parser.y"
                                                                 {
			sect_RelBytes((yyvsp[-3].constValue), (yyvsp[-1].dsArgs).args, (yyvsp[-1].dsArgs).nbArgs);
			freeDsArgList(&(yyvsp[-1].dsArgs));
		}
#line 4050 "src/asm/parser.c"
    break;

  case 164: /* ds_args: reloc_8bit  */
#line 1133 "src/asm/parser.y"
                             {
			initDsArgList(&(yyval.dsArgs));
			appendDsArgList(&(yyval.dsArgs), &(yyvsp[0].expr));
		}
#line 4059 "src/asm/parser.c"
    break;

  case 165: /* ds_args: ds_args "," reloc_8bit  */
#line 1137 "src/asm/parser.y"
                                             {
			appendDsArgList(&(yyvsp[-2].dsArgs), &(yyvsp[0].expr));
			(yyval.dsArgs) = (yyvsp[-2].dsArgs);
		}
#line 4068 "src/asm/parser.c"
    break;

  case 166: /* db: "DB"  */
#line 1143 "src/asm/parser.y"
                           { sect_Skip(1, false); }
#line 4074 "src/asm/parser.c"
    break;

  case 168: /* dw: "DW"  */
#line 1147 "src/asm/parser.y"
                           { sect_Skip(2, false); }
#line 4080 "src/asm/parser.c"
    break;

  case 170: /* dl: "DL"  */
#line 1151 "src/asm/parser.y"
                           { sect_Skip(4, false); }
#line 4086 "src/asm/parser.c"
    break;

  case 172: /* def_equ: def_id "EQU" const  */
#line 1155 "src/asm/parser.y"
                                         { sym_AddEqu((yyvsp[-2].symName), (yyvsp[0].constValue)); }
#line 4092 "src/asm/parser.c"
    break;

  case 173: /* redef_equ: redef_id "EQU" const  */
#line 1158 "src/asm/parser.y"
                                           { sym_RedefEqu((yyvsp[-2].symName), (yyvsp[0].constValue)); }
#line 4098 "src/asm/parser.c"
    break;

  case 174: /* def_set: def_id "=" const  */
#line 1161 "src/asm/parser.y"
                                           { sym_AddVar((yyvsp[-2].symName), (yyvsp[0].constValue)); }
#line 4104 "src/asm/parser.c"
    break;

  case 175: /* def_set: redef_id "=" const  */
#line 1162 "src/asm/parser.y"
                                             { sym_AddVar((yyvsp[-2].symName), (yyvsp[0].constValue)); }
#line 4110 "src/asm/parser.c"
    break;

  case 176: /* def_set: def_id compoundeq const  */
#line 1163 "src/asm/parser.y"
                                          { compoundAssignment((yyvsp[-2].symName), (yyvsp[-1].compoundEqual), (yyvsp[0].constValue)); }
#line 4116 "src/asm/parser.c"
    break;

  case 177: /* def_set: redef_id compoundeq const  */
#line 1164 "src/asm/parser.y"
                                            { compoundAssignment((yyvsp[-2].symName), (yyvsp[-1].compoundEqual), (yyvsp[0].constValue)); }
#line 4122 "src/asm/parser.c"
    break;

  case 178: /* def_rb: def_id "RB" rs_uconst  */
#line 1167 "src/asm/parser.y"
                                            {
			sym_AddEqu((yyvsp[-2].symName), sym_GetConstantValue("_RS"));
			sym_AddVar("_RS", sym_GetConstantValue("_RS") + (yyvsp[0].constValue));
		}
#line 4131 "src/asm/parser.c"
    break;

  case 179: /* def_rw: def_id "RW" rs_uconst  */
#line 1173 "src/asm/parser.y"
                                            {
			sym_AddEqu((yyvsp[-2].symName), sym_GetConstantValue("_RS"));
			sym_AddVar("_RS", sym_GetConstantValue("_RS") + 2 * (yyvsp[0].constValue));
		}
#line 4140 "src/asm/parser.c"
    break;

  case 180: /* def_rl: def_id "rl" rs_uconst  */
#line 1179 "src/asm/parser.y"
                                            {
			sym_AddEqu((yyvsp[-2].symName), sym_GetConstantValue("_RS"));
			sym_AddVar("_RS", sym_GetConstantValue("_RS") + 4 * (yyvsp[0].constValue));
		}
#line 4149 "src/asm/parser.c"
    break;

  case 181: /* def_equs: def_id "EQUS" string  */
#line 1185 "src/asm/parser.y"
                                           { sym_AddString((yyvsp[-2].symName), (yyvsp[0].string)); }
#line 4155 "src/asm/parser.c"
    break;

  case 182: /* redef_equs: redef_id "EQUS" string  */
#line 1188 "src/asm/parser.y"
                                             { sym_RedefString((yyvsp[-2].symName), (yyvsp[0].string)); }
#line 4161 "src/asm/parser.c"
    break;

  case 183: /* $@15: %empty  */
#line 1191 "src/asm/parser.y"
                              {
			lexer_ToggleStringExpansion(false);
		}
#line 4169 "src/asm/parser.c"
    break;

  case 184: /* purge: "PURGE" $@15 purge_list trailing_comma  */
#line 1193 "src/asm/parser.y"
                                            {
			lexer_ToggleStringExpansion(true);
		}
#line 4177 "src/asm/parser.c"
    break;

  case 187: /* purge_list_entry: scoped_id  */
#line 1202 "src/asm/parser.y"
                             { sym_Purge((yyvsp[0].symName)); }
#line 4183 "src/asm/parser.c"
    break;

  case 191: /* export_list_entry: scoped_id  */
#line 1212 "src/asm/parser.y"
                              { sym_Export((yyvsp[0].symName)); }
#line 4189 "src/asm/parser.c"
    break;

  case 192: /* include: label "INCLUDE" string endofline  */
#line 1215 "src/asm/parser.y"
                                                       {
			fstk_RunInclude((yyvsp[-1].string));
			if (failedOnMissingInclude)
				YYACCEPT;
		}
#line 4199 "src/asm/parser.c"
    break;

  case 193: /* incbin: "INCBIN" string  */
#line 1222 "src/asm/parser.y"
                                      {
			sect_BinaryFile((yyvsp[0].string), 0);
			if (failedOnMissingInclude)
				YYACCEPT;
		}
#line 4209 "src/asm/parser.c"
    break;

  case 194: /* incbin: "INCBIN" string "," const  */
#line 1227 "src/asm/parser.y"
                                                    {
			sect_BinaryFile((yyvsp[-2].string), (yyvsp[0].constValue));
			if (failedOnMissingInclude)
				YYACCEPT;
		}
#line 4219 "src/asm/parser.c"
    break;

  case 195: /* incbin: "INCBIN" string "," const "," const  */
#line 1232 "src/asm/parser.y"
                                                                  {
			sect_BinaryFileSlice((yyvsp[-4].string), (yyvsp[-2].constValue), (yyvsp[0].constValue));
			if (failedOnMissingInclude)
				YYACCEPT;
		}
#line 4229 "src/asm/parser.c"
    break;

  case 196: /* charmap: "CHARMAP" string "," const_8bit  */
#line 1239 "src/asm/parser.y"
                                                          {
			charmap_Add((yyvsp[-2].string), (uint8_t)(yyvsp[0].constValue));
		}
#line 4237 "src/asm/parser.c"
    break;

  case 197: /* newcharmap: "NEWCHARMAP" "identifier"  */
#line 1244 "src/asm/parser.y"
                                        { charmap_New((yyvsp[0].symName), NULL); }
#line 4243 "src/asm/parser.c"
    break;

  case 198: /* newcharmap: "NEWCHARMAP" "identifier" "," "identifier"  */
#line 1245 "src/asm/parser.y"
                                                     { charmap_New((yyvsp[-2].symName), (yyvsp[0].symName)); }
#line 4249 "src/asm/parser.c"
    break;

  case 199: /* setcharmap: "SETCHARMAP" "identifier"  */
#line 1248 "src/asm/parser.y"
                                        { charmap_Set((yyvsp[0].symName)); }
#line 4255 "src/asm/parser.c"
    break;

  case 200: /* pushc: "PUSHC"  */
#line 1251 "src/asm/parser.y"
                              { charmap_Push(); }
#line 4261 "src/asm/parser.c"
    break;

  case 201: /* popc: "POPC"  */
#line 1254 "src/asm/parser.y"
                             { charmap_Pop(); }
#line 4267 "src/asm/parser.c"
    break;

  case 203: /* println: "PRINTLN"  */
#line 1260 "src/asm/parser.y"
                                {
			putchar('\n');
			fflush(stdout);
		}
#line 4276 "src/asm/parser.c"
    break;

  case 204: /* println: "PRINTLN" print_exprs trailing_comma  */
#line 1264 "src/asm/parser.y"
                                                           {
			putchar('\n');
			fflush(stdout);
		}
#line 4285 "src/asm/parser.c"
    break;

  case 207: /* print_expr: const_no_str  */
#line 1274 "src/asm/parser.y"
                               { printf("$%" PRIX32, (yyvsp[0].constValue)); }
#line 4291 "src/asm/parser.c"
    break;

  case 208: /* print_expr: string  */
#line 1275 "src/asm/parser.y"
                         { printf("%s", (yyvsp[0].string)); }
#line 4297 "src/asm/parser.c"
    break;

  case 209: /* const_3bit: const  */
#line 1278 "src/asm/parser.y"
                        {
			int32_t value = (yyvsp[0].constValue);

			if ((value < 0) || (value > 7)) {
				error("Immediate value must be 3-bit\n");
				(yyval.constValue) = 0;
			} else {
				(yyval.constValue) = value & 0x7;
			}
		}
#line 4312 "src/asm/parser.c"
    break;

  case 212: /* constlist_8bit_entry: reloc_8bit_no_str  */
#line 1294 "src/asm/parser.y"
                                         {
			sect_RelByte(&(yyvsp[0].expr), 0);
		}
#line 4320 "src/asm/parser.c"
    break;

  case 213: /* constlist_8bit_entry: string  */
#line 1297 "src/asm/parser.y"
                         {
			uint8_t *output = malloc(strlen((yyvsp[0].string))); // Cannot be larger than that
			size_t length = charmap_Convert((yyvsp[0].string), output);

			sect_AbsByteGroup(output, length);
			free(output);
		}
#line 4332 "src/asm/parser.c"
    break;

  case 216: /* constlist_16bit_entry: reloc_16bit_no_str  */
#line 1310 "src/asm/parser.y"
                                           {
			sect_RelWord(&(yyvsp[0].expr), 0);
		}
#line 4340 "src/asm/parser.c"
    break;

  case 217: /* constlist_16bit_entry: string  */
#line 1313 "src/asm/parser.y"
                         {
			uint8_t *output = malloc(strlen((yyvsp[0].string))); // Cannot be larger than that
			size_t length = charmap_Convert((yyvsp[0].string), output);

			sect_AbsWordGroup(output, length);
			free(output);
		}
#line 4352 "src/asm/parser.c"
    break;

  case 220: /* constlist_32bit_entry: relocexpr_no_str  */
#line 1326 "src/asm/parser.y"
                                         {
			sect_RelLong(&(yyvsp[0].expr), 0);
		}
#line 4360 "src/asm/parser.c"
    break;

  case 221: /* constlist_32bit_entry: string  */
#line 1329 "src/asm/parser.y"
                         {
			// Charmaps cannot increase the length of a string
			uint8_t *output = malloc(strlen((yyvsp[0].string)));
			size_t length = charmap_Convert((yyvsp[0].string), output);

			sect_AbsLongGroup(output, length);
			free(output);
		}
#line 4373 "src/asm/parser.c"
    break;

  case 222: /* reloc_8bit: relocexpr  */
#line 1339 "src/asm/parser.y"
                            {
			rpn_CheckNBit(&(yyvsp[0].expr), 8);
			(yyval.expr) = (yyvsp[0].expr);
		}
#line 4382 "src/asm/parser.c"
    break;

  case 223: /* reloc_8bit_no_str: relocexpr_no_str  */
#line 1345 "src/asm/parser.y"
                                     {
			rpn_CheckNBit(&(yyvsp[0].expr), 8);
			(yyval.expr) = (yyvsp[0].expr);
		}
#line 4391 "src/asm/parser.c"
    break;

  case 224: /* reloc_8bit_offset: "+" relocexpr  */
#line 1351 "src/asm/parser.y"
                                       {
			rpn_CheckNBit(&(yyvsp[0].expr), 8);
			(yyval.expr) = (yyvsp[0].expr);
		}
#line 4400 "src/asm/parser.c"
    break;

  case 225: /* reloc_8bit_offset: "-" relocexpr  */
#line 1355 "src/asm/parser.y"
                                     {
			rpn_UNNEG(&(yyval.expr), &(yyvsp[0].expr));
			rpn_CheckNBit(&(yyval.expr), 8);
		}
#line 4409 "src/asm/parser.c"
    break;

  case 226: /* reloc_16bit: relocexpr  */
#line 1361 "src/asm/parser.y"
                            {
			rpn_CheckNBit(&(yyvsp[0].expr), 16);
			(yyval.expr) = (yyvsp[0].expr);
		}
#line 4418 "src/asm/parser.c"
    break;

  case 227: /* reloc_16bit_no_str: relocexpr_no_str  */
#line 1367 "src/asm/parser.y"
                                      {
			rpn_CheckNBit(&(yyvsp[0].expr), 16);
			(yyval.expr) = (yyvsp[0].expr);
		}
#line 4427 "src/asm/parser.c"
    break;

  case 229: /* relocexpr: string  */
#line 1375 "src/asm/parser.y"
                         {
			// Charmaps cannot increase the length of a string
			uint8_t *output = malloc(strlen((yyvsp[0].string)));
			uint32_t length = charmap_Convert((yyvsp[0].string), output);
			uint32_t r = str2int2(output, length);

			free(output);
			rpn_Number(&(yyval.expr), r);
		}
#line 4441 "src/asm/parser.c"
    break;

  case 230: /* relocexpr_no_str: scoped_anon_id  */
#line 1386 "src/asm/parser.y"
                                  { rpn_Symbol(&(yyval.expr), (yyvsp[0].symName)); }
#line 4447 "src/asm/parser.c"
    break;

  case 231: /* relocexpr_no_str: "number"  */
#line 1387 "src/asm/parser.y"
                           { rpn_Number(&(yyval.expr), (yyvsp[0].constValue)); }
#line 4453 "src/asm/parser.c"
    break;

  case 232: /* relocexpr_no_str: "!" relocexpr  */
#line 1388 "src/asm/parser.y"
                                                    {
			rpn_LOGNOT(&(yyval.expr), &(yyvsp[0].expr));
		}
#line 4461 "src/asm/parser.c"
    break;

  case 233: /* relocexpr_no_str: relocexpr "||" relocexpr  */
#line 1391 "src/asm/parser.y"
                                                   {
			rpn_BinaryOp(RPN_LOGOR, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4469 "src/asm/parser.c"
    break;

  case 234: /* relocexpr_no_str: relocexpr "&&" relocexpr  */
#line 1394 "src/asm/parser.y"
                                                    {
			rpn_BinaryOp(RPN_LOGAND, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4477 "src/asm/parser.c"
    break;

  case 235: /* relocexpr_no_str: relocexpr "==" relocexpr  */
#line 1397 "src/asm/parser.y"
                                                    {
			rpn_BinaryOp(RPN_LOGEQ, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4485 "src/asm/parser.c"
    break;

  case 236: /* relocexpr_no_str: relocexpr ">" relocexpr  */
#line 1400 "src/asm/parser.y"
                                                   {
			rpn_BinaryOp(RPN_LOGGT, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4493 "src/asm/parser.c"
    break;

  case 237: /* relocexpr_no_str: relocexpr "<" relocexpr  */
#line 1403 "src/asm/parser.y"
                                                   {
			rpn_BinaryOp(RPN_LOGLT, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4501 "src/asm/parser.c"
    break;

  case 238: /* relocexpr_no_str: relocexpr ">=" relocexpr  */
#line 1406 "src/asm/parser.y"
                                                   {
			rpn_BinaryOp(RPN_LOGGE, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4509 "src/asm/parser.c"
    break;

  case 239: /* relocexpr_no_str: relocexpr "<=" relocexpr  */
#line 1409 "src/asm/parser.y"
                                                   {
			rpn_BinaryOp(RPN_LOGLE, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4517 "src/asm/parser.c"
    break;

  case 240: /* relocexpr_no_str: relocexpr "!=" relocexpr  */
#line 1412 "src/asm/parser.y"
                                                   {
			rpn_BinaryOp(RPN_LOGNE, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4525 "src/asm/parser.c"
    break;

  case 241: /* relocexpr_no_str: relocexpr "+" relocexpr  */
#line 1415 "src/asm/parser.y"
                                               {
			rpn_BinaryOp(RPN_ADD, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4533 "src/asm/parser.c"
    break;

  case 242: /* relocexpr_no_str: relocexpr "-" relocexpr  */
#line 1418 "src/asm/parser.y"
                                               {
			rpn_BinaryOp(RPN_SUB, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4541 "src/asm/parser.c"
    break;

  case 243: /* relocexpr_no_str: relocexpr "^" relocexpr  */
#line 1421 "src/asm/parser.y"
                                               {
			rpn_BinaryOp(RPN_XOR, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4549 "src/asm/parser.c"
    break;

  case 244: /* relocexpr_no_str: relocexpr "|" relocexpr  */
#line 1424 "src/asm/parser.y"
                                              {
			rpn_BinaryOp(RPN_OR, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4557 "src/asm/parser.c"
    break;

  case 245: /* relocexpr_no_str: relocexpr "&" relocexpr  */
#line 1427 "src/asm/parser.y"
                                               {
			rpn_BinaryOp(RPN_AND, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4565 "src/asm/parser.c"
    break;

  case 246: /* relocexpr_no_str: relocexpr "<<" relocexpr  */
#line 1430 "src/asm/parser.y"
                                               {
			rpn_BinaryOp(RPN_SHL, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4573 "src/asm/parser.c"
    break;

  case 247: /* relocexpr_no_str: relocexpr ">>" relocexpr  */
#line 1433 "src/asm/parser.y"
                                               {
			rpn_BinaryOp(RPN_SHR, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4581 "src/asm/parser.c"
    break;

  case 248: /* relocexpr_no_str: relocexpr ">>>" relocexpr  */
#line 1436 "src/asm/parser.y"
                                                {
			rpn_BinaryOp(RPN_USHR, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4589 "src/asm/parser.c"
    break;

  case 249: /* relocexpr_no_str: relocexpr "*" relocexpr  */
#line 1439 "src/asm/parser.y"
                                               {
			rpn_BinaryOp(RPN_MUL, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4597 "src/asm/parser.c"
    break;

  case 250: /* relocexpr_no_str: relocexpr "/" relocexpr  */
#line 1442 "src/asm/parser.y"
                                               {
			rpn_BinaryOp(RPN_DIV, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4605 "src/asm/parser.c"
    break;

  case 251: /* relocexpr_no_str: relocexpr "%" relocexpr  */
#line 1445 "src/asm/parser.y"
                                               {
			rpn_BinaryOp(RPN_MOD, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4613 "src/asm/parser.c"
    break;

  case 252: /* relocexpr_no_str: relocexpr "**" relocexpr  */
#line 1448 "src/asm/parser.y"
                                               {
			rpn_BinaryOp(RPN_EXP, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4621 "src/asm/parser.c"
    break;

  case 253: /* relocexpr_no_str: "+" relocexpr  */
#line 1451 "src/asm/parser.y"
                                               { (yyval.expr) = (yyvsp[0].expr); }
#line 4627 "src/asm/parser.c"
    break;

  case 254: /* relocexpr_no_str: "-" relocexpr  */
#line 1452 "src/asm/parser.y"
                                               { rpn_UNNEG(&(yyval.expr), &(yyvsp[0].expr)); }
#line 4633 "src/asm/parser.c"
    break;

  case 255: /* relocexpr_no_str: "~" relocexpr  */
#line 1453 "src/asm/parser.y"
                                               { rpn_UNNOT(&(yyval.expr), &(yyvsp[0].expr)); }
#line 4639 "src/asm/parser.c"
    break;

  case 256: /* relocexpr_no_str: "HIGH" "(" relocexpr ")"  */
#line 1454 "src/asm/parser.y"
                                                        { rpn_HIGH(&(yyval.expr), &(yyvsp[-1].expr)); }
#line 4645 "src/asm/parser.c"
    break;

  case 257: /* relocexpr_no_str: "LOW" "(" relocexpr ")"  */
#line 1455 "src/asm/parser.y"
                                                       { rpn_LOW(&(yyval.expr), &(yyvsp[-1].expr)); }
#line 4651 "src/asm/parser.c"
    break;

  case 258: /* relocexpr_no_str: "ISCONST" "(" relocexpr ")"  */
#line 1456 "src/asm/parser.y"
                                                           { rpn_ISCONST(&(yyval.expr), &(yyvsp[-1].expr)); }
#line 4657 "src/asm/parser.c"
    break;

  case 259: /* relocexpr_no_str: "BANK" "(" scoped_anon_id ")"  */
#line 1457 "src/asm/parser.y"
                                                             {
			// '@' is also a T_ID; it is handled here
			rpn_BankSymbol(&(yyval.expr), (yyvsp[-1].symName));
		}
#line 4666 "src/asm/parser.c"
    break;

  case 260: /* relocexpr_no_str: "BANK" "(" string ")"  */
#line 1461 "src/asm/parser.y"
                                                     { rpn_BankSection(&(yyval.expr), (yyvsp[-1].string)); }
#line 4672 "src/asm/parser.c"
    break;

  case 261: /* relocexpr_no_str: "SIZEOF" "(" string ")"  */
#line 1462 "src/asm/parser.y"
                                                       { rpn_SizeOfSection(&(yyval.expr), (yyvsp[-1].string)); }
#line 4678 "src/asm/parser.c"
    break;

  case 262: /* relocexpr_no_str: "STARTOF" "(" string ")"  */
#line 1463 "src/asm/parser.y"
                                                        { rpn_StartOfSection(&(yyval.expr), (yyvsp[-1].string)); }
#line 4684 "src/asm/parser.c"
    break;

  case 263: /* $@16: %empty  */
#line 1464 "src/asm/parser.y"
                           {
			lexer_ToggleStringExpansion(false);
		}
#line 4692 "src/asm/parser.c"
    break;

  case 264: /* relocexpr_no_str: "DEF" $@16 "(" scoped_anon_id ")"  */
#line 1466 "src/asm/parser.y"
                                                   {
			rpn_Number(&(yyval.expr), sym_FindScopedValidSymbol((yyvsp[-1].symName)) != NULL);

			lexer_ToggleStringExpansion(true);
		}
#line 4702 "src/asm/parser.c"
    break;

  case 265: /* relocexpr_no_str: "ROUND" "(" const opt_q_arg ")"  */
#line 1471 "src/asm/parser.y"
                                                               {
			rpn_Number(&(yyval.expr), fix_Round((yyvsp[-2].constValue), (yyvsp[-1].constValue)));
		}
#line 4710 "src/asm/parser.c"
    break;

  case 266: /* relocexpr_no_str: "CEIL" "(" const opt_q_arg ")"  */
#line 1474 "src/asm/parser.y"
                                                              {
			rpn_Number(&(yyval.expr), fix_Ceil((yyvsp[-2].constValue), (yyvsp[-1].constValue)));
		}
#line 4718 "src/asm/parser.c"
    break;

  case 267: /* relocexpr_no_str: "FLOOR" "(" const opt_q_arg ")"  */
#line 1477 "src/asm/parser.y"
                                                               {
			rpn_Number(&(yyval.expr), fix_Floor((yyvsp[-2].constValue), (yyvsp[-1].constValue)));
		}
#line 4726 "src/asm/parser.c"
    break;

  case 268: /* relocexpr_no_str: "FDIV" "(" const "," const opt_q_arg ")"  */
#line 1480 "src/asm/parser.y"
                                                                            {
			rpn_Number(&(yyval.expr), fix_Div((yyvsp[-4].constValue), (yyvsp[-2].constValue), (yyvsp[-1].constValue)));
		}
#line 4734 "src/asm/parser.c"
    break;

  case 269: /* relocexpr_no_str: "FMUL" "(" const "," const opt_q_arg ")"  */
#line 1483 "src/asm/parser.y"
                                                                            {
			rpn_Number(&(yyval.expr), fix_Mul((yyvsp[-4].constValue), (yyvsp[-2].constValue), (yyvsp[-1].constValue)));
		}
#line 4742 "src/asm/parser.c"
    break;

  case 270: /* relocexpr_no_str: "FMOD" "(" const "," const opt_q_arg ")"  */
#line 1486 "src/asm/parser.y"
                                                                            {
			rpn_Number(&(yyval.expr), fix_Mod((yyvsp[-4].constValue), (yyvsp[-2].constValue), (yyvsp[-1].constValue)));
		}
#line 4750 "src/asm/parser.c"
    break;

  case 271: /* relocexpr_no_str: "POW" "(" const "," const opt_q_arg ")"  */
#line 1489 "src/asm/parser.y"
                                                                           {
			rpn_Number(&(yyval.expr), fix_Pow((yyvsp[-4].constValue), (yyvsp[-2].constValue), (yyvsp[-1].constValue)));
		}
#line 4758 "src/asm/parser.c"
    break;

  case 272: /* relocexpr_no_str: "LOG" "(" const "," const opt_q_arg ")"  */
#line 1492 "src/asm/parser.y"
                                                                           {
			rpn_Number(&(yyval.expr), fix_Log((yyvsp[-4].constValue), (yyvsp[-2].constValue), (yyvsp[-1].constValue)));
		}
#line 4766 "src/asm/parser.c"
    break;

  case 273: /* relocexpr_no_str: "SIN" "(" const opt_q_arg ")"  */
#line 1495 "src/asm/parser.y"
                                                             {
			rpn_Number(&(yyval.expr), fix_Sin((yyvsp[-2].constValue), (yyvsp[-1].constValue)));
		}
#line 4774 "src/asm/parser.c"
    break;

  case 274: /* relocexpr_no_str: "COS" "(" const opt_q_arg ")"  */
#line 1498 "src/asm/parser.y"
                                                             {
			rpn_Number(&(yyval.expr), fix_Cos((yyvsp[-2].constValue), (yyvsp[-1].constValue)));
		}
#line 4782 "src/asm/parser.c"
    break;

  case 275: /* relocexpr_no_str: "TAN" "(" const opt_q_arg ")"  */
#line 1501 "src/asm/parser.y"
                                                             {
			rpn_Number(&(yyval.expr), fix_Tan((yyvsp[-2].constValue), (yyvsp[-1].constValue)));
		}
#line 4790 "src/asm/parser.c"
    break;

  case 276: /* relocexpr_no_str: "ASIN" "(" const opt_q_arg ")"  */
#line 1504 "src/asm/parser.y"
                                                              {
			rpn_Number(&(yyval.expr), fix_ASin((yyvsp[-2].constValue), (yyvsp[-1].constValue)));
		}
#line 4798 "src/asm/parser.c"
    break;

  case 277: /* relocexpr_no_str: "ACOS" "(" const opt_q_arg ")"  */
#line 1507 "src/asm/parser.y"
                                                              {
			rpn_Number(&(yyval.expr), fix_ACos((yyvsp[-2].constValue), (yyvsp[-1].constValue)));
		}
#line 4806 "src/asm/parser.c"
    break;

  case 278: /* relocexpr_no_str: "ATAN" "(" const opt_q_arg ")"  */
#line 1510 "src/asm/parser.y"
                                                              {
			rpn_Number(&(yyval.expr), fix_ATan((yyvsp[-2].constValue), (yyvsp[-1].constValue)));
		}
#line 4814 "src/asm/parser.c"
    break;

  case 279: /* relocexpr_no_str: "ATAN2" "(" const "," const opt_q_arg ")"  */
#line 1513 "src/asm/parser.y"
                                                                             {
			rpn_Number(&(yyval.expr), fix_ATan2((yyvsp[-4].constValue), (yyvsp[-2].constValue), (yyvsp[-1].constValue)));
		}
#line 4822 "src/asm/parser.c"
    break;

  case 280: /* relocexpr_no_str: "STRCMP" "(" string "," string ")"  */
#line 1516 "src/asm/parser.y"
                                                                      {
			rpn_Number(&(yyval.expr), strcmp((yyvsp[-3].string), (yyvsp[-1].string)));
		}
#line 4830 "src/asm/parser.c"
    break;

  case 281: /* relocexpr_no_str: "STRIN" "(" string "," string ")"  */
#line 1519 "src/asm/parser.y"
                                                                     {
			char const *p = strstr((yyvsp[-3].string), (yyvsp[-1].string));

			rpn_Number(&(yyval.expr), p ? p - (yyvsp[-3].string) + 1 : 0);
		}
#line 4840 "src/asm/parser.c"
    break;

  case 282: /* relocexpr_no_str: "STRRIN" "(" string "," string ")"  */
#line 1524 "src/asm/parser.y"
                                                                      {
			char const *p = strrstr((yyvsp[-3].string), (yyvsp[-1].string));

			rpn_Number(&(yyval.expr), p ? p - (yyvsp[-3].string) + 1 : 0);
		}
#line 4850 "src/asm/parser.c"
    break;

  case 283: /* relocexpr_no_str: "STRLEN" "(" string ")"  */
#line 1529 "src/asm/parser.y"
                                                       {
			rpn_Number(&(yyval.expr), strlenUTF8((yyvsp[-1].string)));
		}
#line 4858 "src/asm/parser.c"
    break;

  case 284: /* relocexpr_no_str: "CHARLEN" "(" string ")"  */
#line 1532 "src/asm/parser.y"
                                                        {
			rpn_Number(&(yyval.expr), charlenUTF8((yyvsp[-1].string)));
		}
#line 4866 "src/asm/parser.c"
    break;

  case 285: /* relocexpr_no_str: "(" relocexpr ")"  */
#line 1535 "src/asm/parser.y"
                                              { (yyval.expr) = (yyvsp[-1].expr); }
#line 4872 "src/asm/parser.c"
    break;

  case 286: /* uconst: const  */
#line 1538 "src/asm/parser.y"
                        {
			(yyval.constValue) = (yyvsp[0].constValue);
			if ((yyval.constValue) < 0)
				fatalerror("Constant must not be negative: %d\n", (yyvsp[0].constValue));
		}
#line 4882 "src/asm/parser.c"
    break;

  case 287: /* const: relocexpr  */
#line 1545 "src/asm/parser.y"
                            { (yyval.constValue) = rpn_GetConstVal(&(yyvsp[0].expr)); }
#line 4888 "src/asm/parser.c"
    break;

  case 288: /* const_no_str: relocexpr_no_str  */
#line 1548 "src/asm/parser.y"
                                   { (yyval.constValue) = rpn_GetConstVal(&(yyvsp[0].expr)); }
#line 4894 "src/asm/parser.c"
    break;

  case 289: /* const_8bit: reloc_8bit  */
#line 1551 "src/asm/parser.y"
                             { (yyval.constValue) = rpn_GetConstVal(&(yyvsp[0].expr)); }
#line 4900 "src/asm/parser.c"
    break;

  case 290: /* opt_q_arg: %empty  */
#line 1554 "src/asm/parser.y"
                         { (yyval.constValue) = fix_Precision(); }
#line 4906 "src/asm/parser.c"
    break;

  case 291: /* opt_q_arg: "," const  */
#line 1555 "src/asm/parser.y"
                                {
			if ((yyvsp[0].constValue) >= 1 && (yyvsp[0].constValue) <= 31) {
				(yyval.constValue) = (yyvsp[0].constValue);
			} else {
				error("Fixed-point precision must be between 1 and 31\n");
				(yyval.constValue) = fix_Precision();
			}
		}
#line 4919 "src/asm/parser.c"
    break;

  case 293: /* string: "STRSUB" "(" string "," const "," uconst ")"  */
#line 1566 "src/asm/parser.y"
                                                                                    {
			size_t len = strlenUTF8((yyvsp[-5].string));
			uint32_t pos = adjustNegativePos((yyvsp[-3].constValue), len, "STRSUB");

			strsubUTF8((yyval.string), sizeof((yyval.string)), (yyvsp[-5].string), pos, (yyvsp[-1].constValue));
		}
#line 4930 "src/asm/parser.c"
    break;

  case 294: /* string: "STRSUB" "(" string "," const ")"  */
#line 1572 "src/asm/parser.y"
                                                                     {
			size_t len = strlenUTF8((yyvsp[-3].string));
			uint32_t pos = adjustNegativePos((yyvsp[-1].constValue), len, "STRSUB");

			strsubUTF8((yyval.string), sizeof((yyval.string)), (yyvsp[-3].string), pos, pos > len ? 0 : len + 1 - pos);
		}
#line 4941 "src/asm/parser.c"
    break;

  case 295: /* string: "CHARSUB" "(" string "," const ")"  */
#line 1578 "src/asm/parser.y"
                                                                      {
			size_t len = charlenUTF8((yyvsp[-3].string));
			uint32_t pos = adjustNegativePos((yyvsp[-1].constValue), len, "CHARSUB");

			charsubUTF8((yyval.string), (yyvsp[-3].string), pos);
		}
#line 4952 "src/asm/parser.c"
    break;

  case 296: /* string: "STRCAT" "(" ")"  */
#line 1584 "src/asm/parser.y"
                                                {
			(yyval.string)[0] = '\0';
		}
#line 4960 "src/asm/parser.c"
    break;

  case 297: /* string: "STRCAT" "(" strcat_args ")"  */
#line 1587 "src/asm/parser.y"
                                                            {
			strcpy((yyval.string), (yyvsp[-1].string));
		}
#line 4968 "src/asm/parser.c"
    break;

  case 298: /* string: "STRUPR" "(" string ")"  */
#line 1590 "src/asm/parser.y"
                                                       {
			upperstring((yyval.string), (yyvsp[-1].string));
		}
#line 4976 "src/asm/parser.c"
    break;

  case 299: /* string: "STRLWR" "(" string ")"  */
#line 1593 "src/asm/parser.y"
                                                       {
			lowerstring((yyval.string), (yyvsp[-1].string));
		}
#line 4984 "src/asm/parser.c"
    break;

  case 300: /* string: "STRRPL" "(" string "," string "," string ")"  */
#line 1596 "src/asm/parser.y"
                                                                                     {
			strrpl((yyval.string), sizeof((yyval.string)), (yyvsp[-5].string), (yyvsp[-3].string), (yyvsp[-1].string));
		}
#line 4992 "src/asm/parser.c"
    break;

  case 301: /* string: "STRFMT" "(" strfmt_args ")"  */
#line 1599 "src/asm/parser.y"
                                                            {
			strfmt((yyval.string), sizeof((yyval.string)), (yyvsp[-1].strfmtArgs).format, (yyvsp[-1].strfmtArgs).nbArgs, (yyvsp[-1].strfmtArgs).args);
			freeStrFmtArgList(&(yyvsp[-1].strfmtArgs));
		}
#line 5001 "src/asm/parser.c"
    break;

  case 302: /* string: "SECTION" "(" scoped_anon_id ")"  */
#line 1603 "src/asm/parser.y"
                                                                 {
			struct Symbol *sym = sym_FindScopedValidSymbol((yyvsp[-1].symName));

			if (!sym)
				fatalerror("Unknown symbol \"%s\"\n", (yyvsp[-1].symName));
			struct Section const *section = sym_GetSection(sym);

			if (!section)
				fatalerror("\"%s\" does not belong to any section\n", sym->name);
			// Section names are capped by rgbasm's maximum string length,
			// so this currently can't overflow.
			strcpy((yyval.string), section->name);
		}
#line 5019 "src/asm/parser.c"
    break;

  case 304: /* strcat_args: strcat_args "," string  */
#line 1619 "src/asm/parser.y"
                                             {
			int ret = snprintf((yyval.string), sizeof((yyval.string)), "%s%s", (yyvsp[-2].string), (yyvsp[0].string));

			if (ret == -1)
				fatalerror("snprintf error in STRCAT: %s\n", strerror(errno));
			else if ((unsigned int)ret >= sizeof((yyval.string)))
				warning(WARNING_LONG_STR, "STRCAT: String too long '%s%s'\n",
					(yyvsp[-2].string), (yyvsp[0].string));
		}
#line 5033 "src/asm/parser.c"
    break;

  case 305: /* strfmt_args: string strfmt_va_args  */
#line 1630 "src/asm/parser.y"
                                        {
			(yyval.strfmtArgs).format = strdup((yyvsp[-1].string));
			(yyval.strfmtArgs).capacity = (yyvsp[0].strfmtArgs).capacity;
			(yyval.strfmtArgs).nbArgs = (yyvsp[0].strfmtArgs).nbArgs;
			(yyval.strfmtArgs).args = (yyvsp[0].strfmtArgs).args;
		}
#line 5044 "src/asm/parser.c"
    break;

  case 306: /* strfmt_va_args: %empty  */
#line 1638 "src/asm/parser.y"
                         {
			initStrFmtArgList(&(yyval.strfmtArgs));
		}
#line 5052 "src/asm/parser.c"
    break;

  case 307: /* strfmt_va_args: strfmt_va_args "," const_no_str  */
#line 1641 "src/asm/parser.y"
                                                      {
			size_t i = nextStrFmtArgListIndex(&(yyvsp[-2].strfmtArgs));

			(yyvsp[-2].strfmtArgs).args[i].number = (yyvsp[0].constValue);
			(yyvsp[-2].strfmtArgs).args[i].isNumeric = true;
			(yyval.strfmtArgs) = (yyvsp[-2].strfmtArgs);
		}
#line 5064 "src/asm/parser.c"
    break;

  case 308: /* strfmt_va_args: strfmt_va_args "," string  */
#line 1648 "src/asm/parser.y"
                                                {
			size_t i = nextStrFmtArgListIndex(&(yyvsp[-2].strfmtArgs));

			(yyvsp[-2].strfmtArgs).args[i].string = strdup((yyvsp[0].string));
			(yyvsp[-2].strfmtArgs).args[i].isNumeric = false;
			(yyval.strfmtArgs) = (yyvsp[-2].strfmtArgs);
		}
#line 5076 "src/asm/parser.c"
    break;

  case 309: /* section: "SECTION" sectmod string "," sectiontype sectorg sectattrs  */
#line 1657 "src/asm/parser.y"
                                                                                     {
			sect_NewSection((yyvsp[-4].string), (yyvsp[-2].constValue), (yyvsp[-1].constValue), &(yyvsp[0].sectSpec), (yyvsp[-5].sectMod));
		}
#line 5084 "src/asm/parser.c"
    break;

  case 310: /* sectmod: %empty  */
#line 1662 "src/asm/parser.y"
                         { (yyval.sectMod) = SECTION_NORMAL; }
#line 5090 "src/asm/parser.c"
    break;

  case 311: /* sectmod: "UNION"  */
#line 1663 "src/asm/parser.y"
                              { (yyval.sectMod) = SECTION_UNION; }
#line 5096 "src/asm/parser.c"
    break;

  case 312: /* sectmod: "FRAGMENT"  */
#line 1664 "src/asm/parser.y"
                                 { (yyval.sectMod) = SECTION_FRAGMENT; }
#line 5102 "src/asm/parser.c"
    break;

  case 313: /* sectiontype: "WRAM0"  */
#line 1667 "src/asm/parser.y"
                               { (yyval.constValue) = SECTTYPE_WRAM0; }
#line 5108 "src/asm/parser.c"
    break;

  case 314: /* sectiontype: "VRAM"  */
#line 1668 "src/asm/parser.y"
                              { (yyval.constValue) = SECTTYPE_VRAM; }
#line 5114 "src/asm/parser.c"
    break;

  case 315: /* sectiontype: "ROMX"  */
#line 1669 "src/asm/parser.y"
                              { (yyval.constValue) = SECTTYPE_ROMX; }
#line 5120 "src/asm/parser.c"
    break;

  case 316: /* sectiontype: "ROM0"  */
#line 1670 "src/asm/parser.y"
                              { (yyval.constValue) = SECTTYPE_ROM0; }
#line 5126 "src/asm/parser.c"
    break;

  case 317: /* sectiontype: "HRAM"  */
#line 1671 "src/asm/parser.y"
                              { (yyval.constValue) = SECTTYPE_HRAM; }
#line 5132 "src/asm/parser.c"
    break;

  case 318: /* sectiontype: "WRAMX"  */
#line 1672 "src/asm/parser.y"
                               { (yyval.constValue) = SECTTYPE_WRAMX; }
#line 5138 "src/asm/parser.c"
    break;

  case 319: /* sectiontype: "SRAM"  */
#line 1673 "src/asm/parser.y"
                              { (yyval.constValue) = SECTTYPE_SRAM; }
#line 5144 "src/asm/parser.c"
    break;

  case 320: /* sectiontype: "OAM"  */
#line 1674 "src/asm/parser.y"
                             { (yyval.constValue) = SECTTYPE_OAM; }
#line 5150 "src/asm/parser.c"
    break;

  case 321: /* sectorg: %empty  */
#line 1677 "src/asm/parser.y"
                         { (yyval.constValue) = -1; }
#line 5156 "src/asm/parser.c"
    break;

  case 322: /* sectorg: "[" uconst "]"  */
#line 1678 "src/asm/parser.y"
                                           {
			if ((yyvsp[-1].constValue) < 0 || (yyvsp[-1].constValue) >= 0x10000) {
				error("Address $%x is not 16-bit\n", (yyvsp[-1].constValue));
				(yyval.constValue) = -1;
			} else {
				(yyval.constValue) = (yyvsp[-1].constValue);
			}
		}
#line 5169 "src/asm/parser.c"
    break;

  case 323: /* sectattrs: %empty  */
#line 1688 "src/asm/parser.y"
                         {
			(yyval.sectSpec).alignment = 0;
			(yyval.sectSpec).alignOfs = 0;
			(yyval.sectSpec).bank = -1;
		}
#line 5179 "src/asm/parser.c"
    break;

  case 324: /* sectattrs: sectattrs "," "ALIGN" "[" uconst "]"  */
#line 1693 "src/asm/parser.y"
                                                                        {
			(yyval.sectSpec).alignment = (yyvsp[-1].constValue);
		}
#line 5187 "src/asm/parser.c"
    break;

  case 325: /* sectattrs: sectattrs "," "ALIGN" "[" uconst "," uconst "]"  */
#line 1696 "src/asm/parser.y"
                                                                                       {
			(yyval.sectSpec).alignment = (yyvsp[-3].constValue);
			(yyval.sectSpec).alignOfs = (yyvsp[-1].constValue);
		}
#line 5196 "src/asm/parser.c"
    break;

  case 326: /* sectattrs: sectattrs "," "BANK" "[" uconst "]"  */
#line 1700 "src/asm/parser.y"
                                                                       {
			// We cannot check the validity of this now
			(yyval.sectSpec).bank = (yyvsp[-1].constValue);
		}
#line 5205 "src/asm/parser.c"
    break;

  case 373: /* z80_adc: "adc" op_a_n  */
#line 1755 "src/asm/parser.y"
                                   {
			sect_AbsByte(0xCE);
			sect_RelByte(&(yyvsp[0].expr), 1);
		}
#line 5214 "src/asm/parser.c"
    break;

  case 374: /* z80_adc: "adc" op_a_r  */
#line 1759 "src/asm/parser.y"
                                   { sect_AbsByte(0x88 | (yyvsp[0].constValue)); }
#line 5220 "src/asm/parser.c"
    break;

  case 375: /* z80_add: "add" op_a_n  */
#line 1762 "src/asm/parser.y"
                                   {
			sect_AbsByte(0xC6);
			sect_RelByte(&(yyvsp[0].expr), 1);
		}
#line 5229 "src/asm/parser.c"
    break;

  case 376: /* z80_add: "add" op_a_r  */
#line 1766 "src/asm/parser.y"
                                   { sect_AbsByte(0x80 | (yyvsp[0].constValue)); }
#line 5235 "src/asm/parser.c"
    break;

  case 377: /* z80_add: "add" "hl" "," reg_ss  */
#line 1767 "src/asm/parser.y"
                                                     { sect_AbsByte(0x09 | ((yyvsp[0].constValue) << 4)); }
#line 5241 "src/asm/parser.c"
    break;

  case 378: /* z80_add: "add" "sp" "," reloc_8bit  */
#line 1768 "src/asm/parser.y"
                                                         {
			sect_AbsByte(0xE8);
			sect_RelByte(&(yyvsp[0].expr), 1);
		}
#line 5250 "src/asm/parser.c"
    break;

  case 379: /* z80_and: "and" op_a_n  */
#line 1775 "src/asm/parser.y"
                                   {
			sect_AbsByte(0xE6);
			sect_RelByte(&(yyvsp[0].expr), 1);
		}
#line 5259 "src/asm/parser.c"
    break;

  case 380: /* z80_and: "and" op_a_r  */
#line 1779 "src/asm/parser.y"
                                   { sect_AbsByte(0xA0 | (yyvsp[0].constValue)); }
#line 5265 "src/asm/parser.c"
    break;

  case 381: /* z80_bit: "bit" const_3bit "," reg_r  */
#line 1782 "src/asm/parser.y"
                                                     {
			sect_AbsByte(0xCB);
			sect_AbsByte(0x40 | ((yyvsp[-2].constValue) << 3) | (yyvsp[0].constValue));
		}
#line 5274 "src/asm/parser.c"
    break;

  case 382: /* z80_call: "call" reloc_16bit  */
#line 1788 "src/asm/parser.y"
                                         {
			sect_AbsByte(0xCD);
			sect_RelWord(&(yyvsp[0].expr), 1);
		}
#line 5283 "src/asm/parser.c"
    break;

  case 383: /* z80_call: "call" ccode_expr "," reloc_16bit  */
#line 1792 "src/asm/parser.y"
                                                            {
			sect_AbsByte(0xC4 | ((yyvsp[-2].constValue) << 3));
			sect_RelWord(&(yyvsp[0].expr), 1);
		}
#line 5292 "src/asm/parser.c"
    break;

  case 384: /* z80_ccf: "ccf"  */
#line 1798 "src/asm/parser.y"
                            { sect_AbsByte(0x3F); }
#line 5298 "src/asm/parser.c"
    break;

  case 385: /* z80_cp: "cp" op_a_n  */
#line 1801 "src/asm/parser.y"
                                  {
			sect_AbsByte(0xFE);
			sect_RelByte(&(yyvsp[0].expr), 1);
		}
#line 5307 "src/asm/parser.c"
    break;

  case 386: /* z80_cp: "cp" op_a_r  */
#line 1805 "src/asm/parser.y"
                                  { sect_AbsByte(0xB8 | (yyvsp[0].constValue)); }
#line 5313 "src/asm/parser.c"
    break;

  case 387: /* z80_cpl: "cpl"  */
#line 1808 "src/asm/parser.y"
                            { sect_AbsByte(0x2F); }
#line 5319 "src/asm/parser.c"
    break;

  case 388: /* z80_daa: "daa"  */
#line 1811 "src/asm/parser.y"
                            { sect_AbsByte(0x27); }
#line 5325 "src/asm/parser.c"
    break;

  case 389: /* z80_dec: "dec" reg_r  */
#line 1814 "src/asm/parser.y"
                                  { sect_AbsByte(0x05 | ((yyvsp[0].constValue) << 3)); }
#line 5331 "src/asm/parser.c"
    break;

  case 390: /* z80_dec: "dec" reg_ss  */
#line 1815 "src/asm/parser.y"
                                   { sect_AbsByte(0x0B | ((yyvsp[0].constValue) << 4)); }
#line 5337 "src/asm/parser.c"
    break;

  case 391: /* z80_di: "di"  */
#line 1818 "src/asm/parser.y"
                           { sect_AbsByte(0xF3); }
#line 5343 "src/asm/parser.c"
    break;

  case 392: /* z80_ei: "ei"  */
#line 1821 "src/asm/parser.y"
                           { sect_AbsByte(0xFB); }
#line 5349 "src/asm/parser.c"
    break;

  case 393: /* z80_halt: "halt"  */
#line 1824 "src/asm/parser.y"
                             {
			sect_AbsByte(0x76);
			if (haltnop) {
				if (warnOnHaltNop) {
					warnOnHaltNop = false;
					warning(WARNING_OBSOLETE, "`nop` after `halt` will stop being the default; pass `-H` to opt into it\n");
				}
				sect_AbsByte(0x00);
			}
		}
#line 5364 "src/asm/parser.c"
    break;

  case 394: /* z80_inc: "inc" reg_r  */
#line 1836 "src/asm/parser.y"
                                  { sect_AbsByte(0x04 | ((yyvsp[0].constValue) << 3)); }
#line 5370 "src/asm/parser.c"
    break;

  case 395: /* z80_inc: "inc" reg_ss  */
#line 1837 "src/asm/parser.y"
                                   { sect_AbsByte(0x03 | ((yyvsp[0].constValue) << 4)); }
#line 5376 "src/asm/parser.c"
    break;

  case 396: /* z80_jp: "jp" reloc_16bit  */
#line 1840 "src/asm/parser.y"
                                       {
			sect_AbsByte(0xC3);
			sect_RelWord(&(yyvsp[0].expr), 1);
		}
#line 5385 "src/asm/parser.c"
    break;

  case 397: /* z80_jp: "jp" ccode_expr "," reloc_16bit  */
#line 1844 "src/asm/parser.y"
                                                          {
			sect_AbsByte(0xC2 | ((yyvsp[-2].constValue) << 3));
			sect_RelWord(&(yyvsp[0].expr), 1);
		}
#line 5394 "src/asm/parser.c"
    break;

  case 398: /* z80_jp: "jp" "hl"  */
#line 1848 "src/asm/parser.y"
                                     {
			sect_AbsByte(0xE9);
		}
#line 5402 "src/asm/parser.c"
    break;

  case 399: /* z80_jr: "jr" reloc_16bit  */
#line 1853 "src/asm/parser.y"
                                       {
			sect_AbsByte(0x18);
			sect_PCRelByte(&(yyvsp[0].expr), 1);
		}
#line 5411 "src/asm/parser.c"
    break;

  case 400: /* z80_jr: "jr" ccode_expr "," reloc_16bit  */
#line 1857 "src/asm/parser.y"
                                                          {
			sect_AbsByte(0x20 | ((yyvsp[-2].constValue) << 3));
			sect_PCRelByte(&(yyvsp[0].expr), 1);
		}
#line 5420 "src/asm/parser.c"
    break;

  case 401: /* z80_ldi: "ldi" "[" "hl" "]" "," T_MODE_A  */
#line 1863 "src/asm/parser.y"
                                                                         {
			sect_AbsByte(0x02 | (2 << 4));
		}
#line 5428 "src/asm/parser.c"
    break;

  case 402: /* z80_ldi: "ldi" T_MODE_A "," "[" "hl" "]"  */
#line 1866 "src/asm/parser.y"
                                                                         {
			sect_AbsByte(0x0A | (2 << 4));
		}
#line 5436 "src/asm/parser.c"
    break;

  case 403: /* z80_ldd: "ldd" "[" "hl" "]" "," T_MODE_A  */
#line 1871 "src/asm/parser.y"
                                                                         {
			sect_AbsByte(0x02 | (3 << 4));
		}
#line 5444 "src/asm/parser.c"
    break;

  case 404: /* z80_ldd: "ldd" T_MODE_A "," "[" "hl" "]"  */
#line 1874 "src/asm/parser.y"
                                                                         {
			sect_AbsByte(0x0A | (3 << 4));
		}
#line 5452 "src/asm/parser.c"
    break;

  case 405: /* z80_ldio: "ldh" T_MODE_A "," op_mem_ind  */
#line 1879 "src/asm/parser.y"
                                                        {
			rpn_CheckHRAM(&(yyvsp[0].expr), &(yyvsp[0].expr));

			sect_AbsByte(0xF0);
			sect_RelByte(&(yyvsp[0].expr), 1);
		}
#line 5463 "src/asm/parser.c"
    break;

  case 406: /* z80_ldio: "ldh" op_mem_ind "," T_MODE_A  */
#line 1885 "src/asm/parser.y"
                                                        {
			rpn_CheckHRAM(&(yyvsp[-2].expr), &(yyvsp[-2].expr));

			sect_AbsByte(0xE0);
			sect_RelByte(&(yyvsp[-2].expr), 1);
		}
#line 5474 "src/asm/parser.c"
    break;

  case 407: /* z80_ldio: "ldh" T_MODE_A "," c_ind  */
#line 1891 "src/asm/parser.y"
                                                   {
			sect_AbsByte(0xF2);
		}
#line 5482 "src/asm/parser.c"
    break;

  case 408: /* z80_ldio: "ldh" c_ind "," T_MODE_A  */
#line 1894 "src/asm/parser.y"
                                                   {
			sect_AbsByte(0xE2);
		}
#line 5490 "src/asm/parser.c"
    break;

  case 410: /* c_ind: "[" relocexpr "+" T_MODE_C "]"  */
#line 1900 "src/asm/parser.y"
                                                                {
			if (!rpn_isKnown(&(yyvsp[-3].expr)) || (yyvsp[-3].expr).val != 0xff00)
				error("Expected constant expression equal to $FF00 for \"$ff00+c\"\n");
		}
#line 5499 "src/asm/parser.c"
    break;

  case 419: /* z80_ld_hl: "ld" "hl" "," "sp" reloc_8bit_offset  */
#line 1916 "src/asm/parser.y"
                                                                         {
			sect_AbsByte(0xF8);
			sect_RelByte(&(yyvsp[0].expr), 1);
		}
#line 5508 "src/asm/parser.c"
    break;

  case 420: /* z80_ld_hl: "ld" "hl" "," reloc_16bit  */
#line 1920 "src/asm/parser.y"
                                                         {
			sect_AbsByte(0x01 | (REG_HL << 4));
			sect_RelWord(&(yyvsp[0].expr), 1);
		}
#line 5517 "src/asm/parser.c"
    break;

  case 421: /* z80_ld_sp: "ld" "sp" "," "hl"  */
#line 1926 "src/asm/parser.y"
                                                       { sect_AbsByte(0xF9); }
#line 5523 "src/asm/parser.c"
    break;

  case 422: /* z80_ld_sp: "ld" "sp" "," reloc_16bit  */
#line 1927 "src/asm/parser.y"
                                                         {
			sect_AbsByte(0x01 | (REG_SP << 4));
			sect_RelWord(&(yyvsp[0].expr), 1);
		}
#line 5532 "src/asm/parser.c"
    break;

  case 423: /* z80_ld_mem: "ld" op_mem_ind "," "sp"  */
#line 1933 "src/asm/parser.y"
                                                        {
			sect_AbsByte(0x08);
			sect_RelWord(&(yyvsp[-2].expr), 1);
		}
#line 5541 "src/asm/parser.c"
    break;

  case 424: /* z80_ld_mem: "ld" op_mem_ind "," T_MODE_A  */
#line 1937 "src/asm/parser.y"
                                                       {
			if (optimizeLoads && rpn_isKnown(&(yyvsp[-2].expr))
			 && (yyvsp[-2].expr).val >= 0xFF00) {
				if (warnOnLdOpt) {
					warnOnLdOpt = false;
					warning(WARNING_OBSOLETE, "ld optimization will stop being the default; pass `-l` to opt into it\n");
				}
				sect_AbsByte(0xE0);
				sect_AbsByte((yyvsp[-2].expr).val & 0xFF);
				rpn_Free(&(yyvsp[-2].expr));
			} else {
				sect_AbsByte(0xEA);
				sect_RelWord(&(yyvsp[-2].expr), 1);
			}
		}
#line 5561 "src/asm/parser.c"
    break;

  case 425: /* z80_ld_cind: "ld" c_ind "," T_MODE_A  */
#line 1954 "src/asm/parser.y"
                                                  {
			sect_AbsByte(0xE2);
		}
#line 5569 "src/asm/parser.c"
    break;

  case 426: /* z80_ld_rr: "ld" reg_rr "," T_MODE_A  */
#line 1959 "src/asm/parser.y"
                                                   {
			sect_AbsByte(0x02 | ((yyvsp[-2].constValue) << 4));
		}
#line 5577 "src/asm/parser.c"
    break;

  case 427: /* z80_ld_r: "ld" reg_r "," reloc_8bit  */
#line 1964 "src/asm/parser.y"
                                                    {
			sect_AbsByte(0x06 | ((yyvsp[-2].constValue) << 3));
			sect_RelByte(&(yyvsp[0].expr), 1);
		}
#line 5586 "src/asm/parser.c"
    break;

  case 428: /* z80_ld_r: "ld" reg_r "," reg_r  */
#line 1968 "src/asm/parser.y"
                                               {
			if (((yyvsp[-2].constValue) == REG_HL_IND) && ((yyvsp[0].constValue) == REG_HL_IND))
				error("LD [HL],[HL] not a valid instruction\n");
			else
				sect_AbsByte(0x40 | ((yyvsp[-2].constValue) << 3) | (yyvsp[0].constValue));
		}
#line 5597 "src/asm/parser.c"
    break;

  case 429: /* z80_ld_a: "ld" reg_r "," c_ind  */
#line 1976 "src/asm/parser.y"
                                               {
			if ((yyvsp[-2].constValue) == REG_A)
				sect_AbsByte(0xF2);
			else
				error("Destination operand must be A\n");
		}
#line 5608 "src/asm/parser.c"
    break;

  case 430: /* z80_ld_a: "ld" reg_r "," reg_rr  */
#line 1982 "src/asm/parser.y"
                                                {
			if ((yyvsp[-2].constValue) == REG_A)
				sect_AbsByte(0x0A | ((yyvsp[0].constValue) << 4));
			else
				error("Destination operand must be A\n");
		}
#line 5619 "src/asm/parser.c"
    break;

  case 431: /* z80_ld_a: "ld" reg_r "," op_mem_ind  */
#line 1988 "src/asm/parser.y"
                                                    {
			if ((yyvsp[-2].constValue) == REG_A) {
				if (optimizeLoads && rpn_isKnown(&(yyvsp[0].expr))
				 && (yyvsp[0].expr).val >= 0xFF00) {
					if (warnOnLdOpt) {
						warnOnLdOpt = false;
						warning(WARNING_OBSOLETE, "ld optimization will stop being the default; pass `-l` to opt into it\n");
					}
					sect_AbsByte(0xF0);
					sect_AbsByte((yyvsp[0].expr).val & 0xFF);
					rpn_Free(&(yyvsp[0].expr));
				} else {
					sect_AbsByte(0xFA);
					sect_RelWord(&(yyvsp[0].expr), 1);
				}
			} else {
				error("Destination operand must be A\n");
				rpn_Free(&(yyvsp[0].expr));
			}
		}
#line 5644 "src/asm/parser.c"
    break;

  case 432: /* z80_ld_ss: "ld" "bc" "," reloc_16bit  */
#line 2010 "src/asm/parser.y"
                                                         {
			sect_AbsByte(0x01 | (REG_BC << 4));
			sect_RelWord(&(yyvsp[0].expr), 1);
		}
#line 5653 "src/asm/parser.c"
    break;

  case 433: /* z80_ld_ss: "ld" "de" "," reloc_16bit  */
#line 2014 "src/asm/parser.y"
                                                         {
			sect_AbsByte(0x01 | (REG_DE << 4));
			sect_RelWord(&(yyvsp[0].expr), 1);
		}
#line 5662 "src/asm/parser.c"
    break;

  case 434: /* z80_nop: "nop"  */
#line 2022 "src/asm/parser.y"
                            { sect_AbsByte(0x00); }
#line 5668 "src/asm/parser.c"
    break;

  case 435: /* z80_or: "or" op_a_n  */
#line 2025 "src/asm/parser.y"
                                  {
			sect_AbsByte(0xF6);
			sect_RelByte(&(yyvsp[0].expr), 1);
		}
#line 5677 "src/asm/parser.c"
    break;

  case 436: /* z80_or: "or" op_a_r  */
#line 2029 "src/asm/parser.y"
                                  { sect_AbsByte(0xB0 | (yyvsp[0].constValue)); }
#line 5683 "src/asm/parser.c"
    break;

  case 437: /* z80_pop: "pop" reg_tt  */
#line 2032 "src/asm/parser.y"
                                   { sect_AbsByte(0xC1 | ((yyvsp[0].constValue) << 4)); }
#line 5689 "src/asm/parser.c"
    break;

  case 438: /* z80_push: "push" reg_tt  */
#line 2035 "src/asm/parser.y"
                                    { sect_AbsByte(0xC5 | ((yyvsp[0].constValue) << 4)); }
#line 5695 "src/asm/parser.c"
    break;

  case 439: /* z80_res: "res" const_3bit "," reg_r  */
#line 2038 "src/asm/parser.y"
                                                     {
			sect_AbsByte(0xCB);
			sect_AbsByte(0x80 | ((yyvsp[-2].constValue) << 3) | (yyvsp[0].constValue));
		}
#line 5704 "src/asm/parser.c"
    break;

  case 440: /* z80_ret: "ret"  */
#line 2044 "src/asm/parser.y"
                            { sect_AbsByte(0xC9); }
#line 5710 "src/asm/parser.c"
    break;

  case 441: /* z80_ret: "ret" ccode_expr  */
#line 2045 "src/asm/parser.y"
                                       { sect_AbsByte(0xC0 | ((yyvsp[0].constValue) << 3)); }
#line 5716 "src/asm/parser.c"
    break;

  case 442: /* z80_reti: "reti"  */
#line 2048 "src/asm/parser.y"
                             { sect_AbsByte(0xD9); }
#line 5722 "src/asm/parser.c"
    break;

  case 443: /* z80_rl: "rl" reg_r  */
#line 2051 "src/asm/parser.y"
                                 {
			sect_AbsByte(0xCB);
			sect_AbsByte(0x10 | (yyvsp[0].constValue));
		}
#line 5731 "src/asm/parser.c"
    break;

  case 444: /* z80_rla: "rla"  */
#line 2057 "src/asm/parser.y"
                            { sect_AbsByte(0x17); }
#line 5737 "src/asm/parser.c"
    break;

  case 445: /* z80_rlc: "rlc" reg_r  */
#line 2060 "src/asm/parser.y"
                                  {
			sect_AbsByte(0xCB);
			sect_AbsByte(0x00 | (yyvsp[0].constValue));
		}
#line 5746 "src/asm/parser.c"
    break;

  case 446: /* z80_rlca: "rlca"  */
#line 2066 "src/asm/parser.y"
                             { sect_AbsByte(0x07); }
#line 5752 "src/asm/parser.c"
    break;

  case 447: /* z80_rr: "rr" reg_r  */
#line 2069 "src/asm/parser.y"
                                 {
			sect_AbsByte(0xCB);
			sect_AbsByte(0x18 | (yyvsp[0].constValue));
		}
#line 5761 "src/asm/parser.c"
    break;

  case 448: /* z80_rra: "rra"  */
#line 2075 "src/asm/parser.y"
                            { sect_AbsByte(0x1F); }
#line 5767 "src/asm/parser.c"
    break;

  case 449: /* z80_rrc: "rrc" reg_r  */
#line 2078 "src/asm/parser.y"
                                  {
			sect_AbsByte(0xCB);
			sect_AbsByte(0x08 | (yyvsp[0].constValue));
		}
#line 5776 "src/asm/parser.c"
    break;

  case 450: /* z80_rrca: "rrca"  */
#line 2084 "src/asm/parser.y"
                             { sect_AbsByte(0x0F); }
#line 5782 "src/asm/parser.c"
    break;

  case 451: /* z80_rst: "rst" reloc_8bit  */
#line 2087 "src/asm/parser.y"
                                       {
			rpn_CheckRST(&(yyvsp[0].expr), &(yyvsp[0].expr));
			if (!rpn_isKnown(&(yyvsp[0].expr)))
				sect_RelByte(&(yyvsp[0].expr), 0);
			else
				sect_AbsByte(0xC7 | (yyvsp[0].expr).val);
			rpn_Free(&(yyvsp[0].expr));
		}
#line 5795 "src/asm/parser.c"
    break;

  case 452: /* z80_sbc: "sbc" op_a_n  */
#line 2097 "src/asm/parser.y"
                                   {
			sect_AbsByte(0xDE);
			sect_RelByte(&(yyvsp[0].expr), 1);
		}
#line 5804 "src/asm/parser.c"
    break;

  case 453: /* z80_sbc: "sbc" op_a_r  */
#line 2101 "src/asm/parser.y"
                                   { sect_AbsByte(0x98 | (yyvsp[0].constValue)); }
#line 5810 "src/asm/parser.c"
    break;

  case 454: /* z80_scf: "scf"  */
#line 2104 "src/asm/parser.y"
                            { sect_AbsByte(0x37); }
#line 5816 "src/asm/parser.c"
    break;

  case 455: /* z80_set: "set" const_3bit "," reg_r  */
#line 2107 "src/asm/parser.y"
                                                     {
			sect_AbsByte(0xCB);
			sect_AbsByte(0xC0 | ((yyvsp[-2].constValue) << 3) | (yyvsp[0].constValue));
		}
#line 5825 "src/asm/parser.c"
    break;

  case 456: /* z80_sla: "sla" reg_r  */
#line 2113 "src/asm/parser.y"
                                  {
			sect_AbsByte(0xCB);
			sect_AbsByte(0x20 | (yyvsp[0].constValue));
		}
#line 5834 "src/asm/parser.c"
    break;

  case 457: /* z80_sra: "sra" reg_r  */
#line 2119 "src/asm/parser.y"
                                  {
			sect_AbsByte(0xCB);
			sect_AbsByte(0x28 | (yyvsp[0].constValue));
		}
#line 5843 "src/asm/parser.c"
    break;

  case 458: /* z80_srl: "srl" reg_r  */
#line 2125 "src/asm/parser.y"
                                  {
			sect_AbsByte(0xCB);
			sect_AbsByte(0x38 | (yyvsp[0].constValue));
		}
#line 5852 "src/asm/parser.c"
    break;

  case 459: /* z80_stop: "stop"  */
#line 2131 "src/asm/parser.y"
                             {
			sect_AbsByte(0x10);
			sect_AbsByte(0x00);
		}
#line 5861 "src/asm/parser.c"
    break;

  case 460: /* z80_stop: "stop" reloc_8bit  */
#line 2135 "src/asm/parser.y"
                                        {
			sect_AbsByte(0x10);
			sect_RelByte(&(yyvsp[0].expr), 1);
		}
#line 5870 "src/asm/parser.c"
    break;

  case 461: /* z80_sub: "sub" op_a_n  */
#line 2141 "src/asm/parser.y"
                                   {
			sect_AbsByte(0xD6);
			sect_RelByte(&(yyvsp[0].expr), 1);
		}
#line 5879 "src/asm/parser.c"
    break;

  case 462: /* z80_sub: "sub" op_a_r  */
#line 2145 "src/asm/parser.y"
                                   { sect_AbsByte(0x90 | (yyvsp[0].constValue)); }
#line 5885 "src/asm/parser.c"
    break;

  case 463: /* z80_swap: "swap" reg_r  */
#line 2148 "src/asm/parser.y"
                                   {
			sect_AbsByte(0xCB);
			sect_AbsByte(0x30 | (yyvsp[0].constValue));
		}
#line 5894 "src/asm/parser.c"
    break;

  case 464: /* z80_xor: "xor" op_a_n  */
#line 2154 "src/asm/parser.y"
                                   {
			sect_AbsByte(0xEE);
			sect_RelByte(&(yyvsp[0].expr), 1);
		}
#line 5903 "src/asm/parser.c"
    break;

  case 465: /* z80_xor: "xor" op_a_r  */
#line 2158 "src/asm/parser.y"
                                   { sect_AbsByte(0xA8 | (yyvsp[0].constValue)); }
#line 5909 "src/asm/parser.c"
    break;

  case 466: /* op_mem_ind: "[" reloc_16bit "]"  */
#line 2161 "src/asm/parser.y"
                                                { (yyval.expr) = (yyvsp[-1].expr); }
#line 5915 "src/asm/parser.c"
    break;

  case 468: /* op_a_r: T_MODE_A "," reg_r  */
#line 2165 "src/asm/parser.y"
                                         { (yyval.constValue) = (yyvsp[0].constValue); }
#line 5921 "src/asm/parser.c"
    break;

  case 470: /* op_a_n: T_MODE_A "," reloc_8bit  */
#line 2169 "src/asm/parser.y"
                                              { (yyval.expr) = (yyvsp[0].expr); }
#line 5927 "src/asm/parser.c"
    break;

  case 486: /* ccode_expr: "!" ccode_expr  */
#line 2201 "src/asm/parser.y"
                                           {
			(yyval.constValue) = (yyvsp[0].constValue) ^ 1;
		}
#line 5935 "src/asm/parser.c"
    break;

  case 487: /* ccode: "nz"  */
#line 2206 "src/asm/parser.y"
                          { (yyval.constValue) = CC_NZ; }
#line 5941 "src/asm/parser.c"
    break;

  case 488: /* ccode: "z"  */
#line 2207 "src/asm/parser.y"
                         { (yyval.constValue) = CC_Z; }
#line 5947 "src/asm/parser.c"
    break;

  case 489: /* ccode: "nc"  */
#line 2208 "src/asm/parser.y"
                          { (yyval.constValue) = CC_NC; }
#line 5953 "src/asm/parser.c"
    break;

  case 490: /* ccode: "c"  */
#line 2209 "src/asm/parser.y"
                            { (yyval.constValue) = CC_C; }
#line 5959 "src/asm/parser.c"
    break;

  case 491: /* reg_r: T_MODE_B  */
#line 2212 "src/asm/parser.y"
                           { (yyval.constValue) = REG_B; }
#line 5965 "src/asm/parser.c"
    break;

  case 492: /* reg_r: T_MODE_C  */
#line 2213 "src/asm/parser.y"
                           { (yyval.constValue) = REG_C; }
#line 5971 "src/asm/parser.c"
    break;

  case 493: /* reg_r: T_MODE_D  */
#line 2214 "src/asm/parser.y"
                           { (yyval.constValue) = REG_D; }
#line 5977 "src/asm/parser.c"
    break;

  case 494: /* reg_r: T_MODE_E  */
#line 2215 "src/asm/parser.y"
                           { (yyval.constValue) = REG_E; }
#line 5983 "src/asm/parser.c"
    break;

  case 495: /* reg_r: T_MODE_H  */
#line 2216 "src/asm/parser.y"
                           { (yyval.constValue) = REG_H; }
#line 5989 "src/asm/parser.c"
    break;

  case 496: /* reg_r: T_MODE_L  */
#line 2217 "src/asm/parser.y"
                           { (yyval.constValue) = REG_L; }
#line 5995 "src/asm/parser.c"
    break;

  case 497: /* reg_r: "[" "hl" "]"  */
#line 2218 "src/asm/parser.y"
                                              { (yyval.constValue) = REG_HL_IND; }
#line 6001 "src/asm/parser.c"
    break;

  case 498: /* reg_r: T_MODE_A  */
#line 2219 "src/asm/parser.y"
                           { (yyval.constValue) = REG_A; }
#line 6007 "src/asm/parser.c"
    break;

  case 499: /* reg_tt: "bc"  */
#line 2222 "src/asm/parser.y"
                            { (yyval.constValue) = REG_BC; }
#line 6013 "src/asm/parser.c"
    break;

  case 500: /* reg_tt: "de"  */
#line 2223 "src/asm/parser.y"
                            { (yyval.constValue) = REG_DE; }
#line 6019 "src/asm/parser.c"
    break;

  case 501: /* reg_tt: "hl"  */
#line 2224 "src/asm/parser.y"
                            { (yyval.constValue) = REG_HL; }
#line 6025 "src/asm/parser.c"
    break;

  case 502: /* reg_tt: "af"  */
#line 2225 "src/asm/parser.y"
                            { (yyval.constValue) = REG_AF; }
#line 6031 "src/asm/parser.c"
    break;

  case 503: /* reg_ss: "bc"  */
#line 2228 "src/asm/parser.y"
                            { (yyval.constValue) = REG_BC; }
#line 6037 "src/asm/parser.c"
    break;

  case 504: /* reg_ss: "de"  */
#line 2229 "src/asm/parser.y"
                            { (yyval.constValue) = REG_DE; }
#line 6043 "src/asm/parser.c"
    break;

  case 505: /* reg_ss: "hl"  */
#line 2230 "src/asm/parser.y"
                            { (yyval.constValue) = REG_HL; }
#line 6049 "src/asm/parser.c"
    break;

  case 506: /* reg_ss: "sp"  */
#line 2231 "src/asm/parser.y"
                            { (yyval.constValue) = REG_SP; }
#line 6055 "src/asm/parser.c"
    break;

  case 507: /* reg_rr: "[" "bc" "]"  */
#line 2234 "src/asm/parser.y"
                                              { (yyval.constValue) = REG_BC_IND; }
#line 6061 "src/asm/parser.c"
    break;

  case 508: /* reg_rr: "[" "de" "]"  */
#line 2235 "src/asm/parser.y"
                                              { (yyval.constValue) = REG_DE_IND; }
#line 6067 "src/asm/parser.c"
    break;

  case 509: /* reg_rr: hl_ind_inc  */
#line 2236 "src/asm/parser.y"
                             { (yyval.constValue) = REG_HL_INDINC; }
#line 6073 "src/asm/parser.c"
    break;

  case 510: /* reg_rr: hl_ind_dec  */
#line 2237 "src/asm/parser.y"
                             { (yyval.constValue) = REG_HL_INDDEC; }
#line 6079 "src/asm/parser.c"
    break;


#line 6083 "src/asm/parser.c"

        default: break;
      }
    if (yychar_backup != yychar)
      YY_LAC_DISCARD ("yychar change");
  }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yyesa, &yyes, &yyes_capacity, yytoken};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        if (yychar != YYEMPTY)
          YY_LAC_ESTABLISH;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          YYNOMEM;
      }
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= T_EOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == T_EOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  /* If the stack popping above didn't lose the initial context for the
     current lookahead token, the shift below will for sure.  */
  YY_LAC_DISCARD ("error recovery");

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yyes != yyesa)
    YYSTACK_FREE (yyes);
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 2248 "src/asm/parser.y"

